<?php defined('SYSPATH') or die('No direct script access.');

class Activity {

	public static function add($user_id, $action, $description, $control_no='', $category_id=0)
	{
		$page_status = MyHelper::page_status();

		$user = ORM::factory('Admin', $user_id);

		if ($user->loaded())
		{
			// For Maker, Checker, Checker 2, Publisher filtered by the action selected
			if ($user->role_id >= 4)
			{
				$arr_statuses = array_keys($page_status);

				if (in_array($action, $arr_statuses))
				{
					if ($action == 'pending-concur' OR $action == 'pending-publish' OR $action == 'request-archive' OR $action == 'check-archive' OR $action == 'pending-archive')
					{
						$action = $page_status[$action][$user->role_id];
					}
					else
					{
						$action = $page_status[$action];
					}
				}
			}

			$user_name = $user->name;

			$log = ORM::factory('Activity');
			$log->user_name = HTML::chars($user_name);
			$log->user_id=  $user_id;
			$log->user_type = $user->role->name;
			$log->action = HTML::chars($action);
			$log->category_id = $category_id;
			$log->control_no = $control_no ? $control_no : 'NA';
			$log->description = HTML::chars($description);
			$log->save();
		}
	}

	/**
	 * Check user if he/she is inactive for the past $int_inactive days
	 * @param  [int] $user_id      [user id]
	 * @param  [int] $int_inactive [number of days]
	 * @return [bool]              [description]
	 */
	public static function check_inactive($user_id, $int_inactive)
	{
		$user = ORM::factory('Admin', $user_id);

		if ($user->loaded())
		{
			$ret = false;
			$last_visit = $user->last_visit;

			if ($last_visit)
			{
				$last_visit_ts = strtotime($last_visit);
				$current_date = mktime(0, 0, 0, date('m'), date('j'), date('Y'));

				$last_visit = mktime(0, 0, 0, date('m', $last_visit_ts), date('j', $last_visit_ts) + $int_inactive, date('Y', $last_visit_ts));

				// user is inactive for the past $int_inactive days
				if ($current_date > $last_visit)
				{
					$ret = true;
				}
				else
				{
					$ret = false;
				}
			}

			return $ret;
		}
	}
}
