<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Admin_Cms extends Controller_Template {

	public $template = 'template/admin_tpl';

	public function before()
	{
		parent::before();

		$this->session = Session::instance();

		//checking ifAdministrator is logged in
		if( ! $this->session->get('user_id'))
		{
			throw HTTP_Exception::factory(404, 'URL not found!');
		}

		$checklogin = MyHelper::check_user_login($this->session->get('user_id'));
		if ($checklogin == 'Y')
		{
			$this->redirect('admin/logout/push');
		}

		$this->template->navmenu = View::factory('nav/main');

		// $this->filesite = Kohana::$config->load('site')->get('dbserver');
		// $this->filepath = $this->filesite.'/media/uploads';
	}

	public function action_index()
	{
		// $this->template->content = '<h2>Hello World</h2>';
		$this->redirect('admin/cms/view_all');
	}

	/**
	 * Default landing page for Maker, Checker, Publisher
	 *
	 */
	public function action_view_all()
	{
		$nav = 'nav_viewall';
		if ($this->session->get('nav_link') != $nav)
		{
			$this->session->set('nav_link', $nav);
		}

		$sort_fields = array(
			'date_created' => 'Date Created',
			'control_no' => 'Control No',
			'title' => 'Title',
			'content_type_id' => 'Content Type',
			'status' => 'Status'
		);

		$page_header = 'View All';

		$user_category_ids = $this->session->get('user_category_ids');
		$qry = ORM::factory('Category')
			->where('id', 'IN', DB::expr('('.$user_category_ids.')'))
			->find_all();

		$arr_content_types = array_keys($this->user_content_types($qry, 'filtered'));
		$user_content_types = implode(",", $arr_content_types);

		$sql = ORM::factory('Page');

		// list all pages based on who is accessing it.
		$user_role = $this->session->get('user_role_id');

		if ($user_role == 4)
		{
			$arr_segments = array();
			if ($this->session->get('user_segment_ids'))
			{
				$arr_segments = explode(",", $this->session->get('user_segment_ids'));
			}

			// user is Maker
			$sql->where_open()
				->where('status', '=', 'pending-check')
				->or_where('status', '=', 'pending-concur')
				->or_where('status', '=', 'request-archive')
				->or_where('status', '=', 'draft')
				->or_where('status', '=', 'rework')
				->or_where('status', '=', 'rework-archive')
				->or_where('status', '=', 'check-archive') // checker marked posting request to archive as checked
				->or_where('status', '=', 'denied')
				->or_where('status', '=', 'pending-publish') // labeled as "Checked"
				->or_where('status', '=', 'pending-archive') // labeled as "Checked"
				->or_where('status', '=', 'concurred')
				->or_where('status', '=', 'published')
				->or_where('status', '=', 'archived')
				->where_close()
				->where('category_id', 'IN', DB::expr('('.$user_category_ids.')'));
			/*
			if ($user_content_types)
			{
				$sql->or_where('content_type_id', 'IN', DB::expr('('.$user_content_types.')'));
			}
			*/
			$sql->where_open();
			foreach ($arr_segments as $s => $segment_id)
			{
				$sql->or_where(DB::expr('\',\'+').'segment_ids'.DB::expr('+\',\''), 'LIKE', "%,$segment_id,%")
					->or_where(DB::expr('\',\'+').'segment_ids'.DB::expr('+\',\''), 'IS', NULL);
			}
			$sql->where_close();

			if ($user_content_types)
			{
				$sql->where('content_type_id', 'IN', DB::expr('('.$user_content_types.')'));
			}
		}
		else if ($user_role == 5)
		{
			$arr_segments = array();
			if ($this->session->get('user_segment_ids'))
			{
				$arr_segments = explode(",", $this->session->get('user_segment_ids'));
			}

			// user is Checker
			$sql->where_open()
				->where('status', '=', 'pending-check')
				->or_where('status', '=', 'pending-concur')
				->or_where('status', '=', 'request-archive')
				->or_where('status', '=', 'pending-archive')
				->or_where('status', '=', 'check-archive')
				->or_where('status', '=', 'denied')
				->or_where('status', '=', 'pending-publish')
				->or_where('status', '=', 'published')
				->or_where('status', '=', 'archived')
				->where_close()
				->where('category_id', 'IN', DB::expr('('.$this->session->get('user_category_ids').')'));
			/*
			if ($user_content_types)
			{
				$sql->or_where('content_type_id', 'IN', DB::expr('('.$user_content_types.')'));
			}
			*/
			$sql->where_open();
			foreach ($arr_segments as $s => $segment_id)
			{
				$sql->or_where(DB::expr('\',\'+').'segment_ids'.DB::expr('+\',\''), 'LIKE', "%,$segment_id,%")
					->or_where(DB::expr('\',\'+').'segment_ids'.DB::expr('+\',\''), 'IS', NULL);
			}
			$sql->where_close();

			if ($user_content_types)
			{
				$sql->where('content_type_id', 'IN', DB::expr('('.$user_content_types.')'));
			}
		}
		else if ($user_role == 6)
		{
			$arr_segments = array();
			if ($this->session->get('user_segment_ids'))
			{
				$arr_segments = explode(",", $this->session->get('user_segment_ids'));
			}

			// user is Checker 2
			$sql->where_open()
				->where('status', '=', 'pending-concur')
				->or_where('status', '=', 'check-archive')
				->or_where('status', '=', 'pending-archive')
				->or_where('status', '=', 'request-archive')
				->or_where('status', '=', 'denied')
				->or_where('status', '=', 'pending-publish')
				->or_where('status', '=', 'published')
				->or_where('status', '=', 'archived')
				->where_close()
				->where('category_id', 'IN', DB::expr('('.$this->session->get('user_category_ids').')'));
			/*
			if ($user_content_types)
			{
				$sql->or_where('content_type_id', 'IN', DB::expr('('.$user_content_types.')'));
			}
			*/
			$sql->where_open();
			foreach ($arr_segments as $s => $segment_id)
			{
				$sql->or_where(DB::expr('\',\'+').'segment_ids'.DB::expr('+\',\''), 'LIKE', "%,$segment_id,%")
					->or_where(DB::expr('\',\'+').'segment_ids'.DB::expr('+\',\''), 'IS', NULL);
			}
			$sql->where_close();

			if ($user_content_types)
			{
				$sql->where('content_type_id', 'IN', DB::expr('('.$user_content_types.')'));
			}
		}
		else if ($user_role == 7)
		{
			$arr_segments = array();
			if ($this->session->get('user_segment_ids'))
			{
				$arr_segments = explode(",", $this->session->get('user_segment_ids'));
			}

			// user is Publisher
			$sql->where_open()
				->where('status', '=', 'pending-publish')
				->or_where('status', '=', 'pending-archive')
				->or_where('status', '=', 'check-archive')
				->or_where('status', '=', 'request-archive')
				->or_where('status', '=', 'published')
				->or_where('status', '=', 'archived')
				->where_close()
				->where('category_id', 'IN', DB::expr('('.$this->session->get('user_category_ids').')'));
			/*
			if ($user_content_types)
			{
				$sql->or_where('content_type_id', 'IN', DB::expr('('.$user_content_types.')'));
			}
			*/
			$sql->where_open();
			foreach ($arr_segments as $s => $segment_id)
			{
				$sql->or_where(DB::expr('\',\'+').'segment_ids'.DB::expr('+\',\''), 'LIKE', "%,$segment_id,%")
					->or_where(DB::expr('\',\'+').'segment_ids'.DB::expr('+\',\''), 'IS', NULL);
			}
			$sql->where_close();

			if ($user_content_types)
			{
				$sql->where('content_type_id', 'IN', DB::expr('('.$user_content_types.')'));
			}
		}

		if ($this->session->get('s_search_keyword'))
		{
			$search_keyword = strtolower($this->session->get('s_search_keyword'));

			$wildcard_search = str_replace('.', '%.%', $search_keyword);

			$sql->where_open()
				->where('control_no', '=', $search_keyword)
				->or_where('title', 'LIKE', "%".$wildcard_search."%");

			$arr_page_status = MyHelper::page_status_search($search_keyword, MyHelper::page_status(), $user_role);
			if (count($arr_page_status))
			{
				foreach ($arr_page_status as $key => $page_status)
				{
					$sql->or_where('status', '=', $page_status);
				}
			}

			$arr_content_types = MyHelper::content_types();
			$arr_ctypes = array();
			foreach ($arr_content_types as $k => $v)
			{
				$arr_ctypes[$k] = strtolower($v);
			}

			$search_ctype = NULL;
			if (in_array($search_keyword, $arr_ctypes))
			{
				$search_ctype_res = array_keys($arr_ctypes, $search_keyword);
				$search_ctype = $search_ctype_res[0];
			}
			if ($search_ctype)
			{
				$sql->or_where('content_type_id', '=', $search_ctype);
			}
			$sql->where_close();

			$this->session->delete('s_search_keyword');
		}

		/*
		$page_query = clone $sql;
		$query = $page_query->find_all();
		$count = $query->count();
		// echo Database::instance()->last_query;
		$pagination = Pagination::factory(array(
		    'total_items'    => $count,
		    'view'           => 'pagination/floating',
		    'items_per_page' => 20
		));

		$page_links = $pagination->render();

		$sql->limit($pagination->items_per_page)
		    ->offset($pagination->offset);
		*/
		$sort_field = $this->session->get('s_sort_field') ? $this->session->get('s_sort_field') : 'date_created';
		$sort_by = $this->session->get('s_sort_by') ? $this->session->get('s_sort_by') : 'DESC';
		$list = $sql->order_by($sort_field, $sort_by)->find_all();
		// echo Database::instance()->last_query;
		$this->template->content = View::factory('admin/cms/view_all');
		$this->template->content->query = $list;
		// $this->template->content->pagination = $page_links;
		$this->template->content->page_header = $page_header;
		$this->template->content->sort_fields = $sort_fields;
	}

	/**
	 * Create New CMS/Page (Maker Only)
	 * @return [type] [description]
	 */
	public function action_new_posting()
	{
		if ($this->session->get('user_role_id') != 4)
		{
			throw HTTP_Exception::factory(500, 'You are not authorized to access this.');
		}

		$nav = 'nav_newcms';
		if ($this->session->get('nav_link') != $nav)
		{
			$this->session->set('nav_link', $nav);
		}

		// based on the user category assignment, get it's corresponding content type assigned to a category
		$user_category_ids = $this->session->get('user_category_ids');
		$sql = ORM::factory('Category')
			->where('id', 'IN', DB::expr('('.$user_category_ids.')'))
			->find_all();

		if ($sql->count())
		{
			$arr_content_types = $this->user_content_types($sql);

			$title_bar = 'New Posting';
			$this->template->content = View::factory('admin/cms/form');
			$this->template->content->arr_content_types = $arr_content_types;
			$this->template->content->title_bar = $title_bar;
		}
		else
		{
			throw HTTP_Exception::factory(404, 'URL not found!');
		}
	}

	/**
	 * Generate fields related to content type;
	 * @return [type] [description]
	 */
	public function action_get_content_type()
	{
		$this->auto_render = FALSE;

		if (HTTP_Request::POST == $this->request->method() AND $this->request->is_ajax())
		{
			$content_type = Arr::get($this->request->post(), 'type');

			$sql = ORM::factory('ContentType', $content_type);
			$charlimit = $sql->charlimit > 0 ? $sql->charlimit : '';

			// if this has value, we're editing an article/page
			$page_id = Arr::get($this->request->post(), 'id');
			if ($page_id)
			{
				$page = ORM::factory('Page', $page_id);
			}
			else
			{
				$page_id = 0;
			}

			// display only the Categories this user is able to see
			$arr_categories = array();
			$user_category_ids = $this->session->get('user_category_ids');
			$categ = ORM::factory('Category')
				->where('id', 'IN', DB::expr('('.$user_category_ids.')'))
				->where(DB::expr('\',\'+').'content_types'.DB::expr('+\',\''), 'LIKE', "%,$content_type,%")
				->order_by('name')
				->find_all();
			$arr_categories = array();
			if ($content_type != 7)
			{
				$arr_categories[] = '';
			}
			foreach ($categ as $res)
			{
				$arr_categories[$res->id] = $res->name;
			}

			$view = '';
			// For Info Page and all other New Content Type
			if ($content_type == 1 OR $content_type > 7)
			{
				// Info Page
				$view = View::factory('admin/cms/info_page/fields');

				$view->arr_categories = $arr_categories;

				// For editing
				$data = array();
				if ($page_id)
				{
					$data = array(
						'id' => $page->id,
						'category_id' => $page->category_id,
						'sub_category1' => $page->sub_category1,
						'sub_category2' => $page->sub_category2,
						'sub_category3' => $page->sub_category3,
						'title' => $page->title,
						'template_id' => $page->template_id,
						'start_date' => strstr($page->start_date, '1900-01-01') ? '' : date('m/d/Y', strtotime($page->start_date)),
						'end_date' => strstr($page->end_date, '1900-01-01') ? '' : date('m/d/Y', strtotime($page->end_date)),
						'meta_title' => html_entity_decode($page->meta_title),
						'meta_description' => html_entity_decode($page->meta_description),
						'meta_keyword' => html_entity_decode($page->meta_keyword)
					);
				}
				$view->data = $data;
				$view->content_type = $content_type;
			}
			else if ($content_type == 2)
			{
				// Splash Banner
				$view = View::factory('admin/cms/splash_banner/fields');

				$view->arr_categories = $arr_categories;

				$segment_views = MyHelper::segments();

				$user_segment_ids = $this->session->get('user_segment_ids');

				$arr_user_segments = $user_segment_ids ? explode(",", $user_segment_ids) : array();
				$user_segments = '';
				foreach ($arr_user_segments as $k => $v)
				{
					$user_segments .= ($user_segments ? ', ' : '').Arr::get($segment_views, $v);
				}

				$view->segment_views = $user_segments;

				// For editing
				$data = array(
					'charlimit' => $charlimit
				);
				if ($page_id)
				{
					$data = array(
						'id' => $page->id,
						'category_id' => $page->category_id,
						'sub_category1' => $page->sub_category1,
						'sub_category2' => $page->sub_category2,
						'sub_category3' => $page->sub_category3,
						'title' => $page->title,
						'link1' => $page->link1,
						'image1' => $page->image1,
						'image2' => $page->image2,
						'start_date' => strstr($page->start_date, '1900-01-01') ? '' : date('m/d/Y', strtotime($page->start_date)),
						'end_date' => strstr($page->end_date, '1900-01-01') ? '' : date('m/d/Y', strtotime($page->end_date)),
						'charlimit' => $charlimit
					);
				}
				$view->data = $data;
				$view->content_type = $content_type;
			}
			else if ($content_type == 3)
			{
				// Ad Banner
				$view = View::factory('admin/cms/ad_banner/fields');

				$view->arr_categories = $arr_categories;

				// For editing
				$data = array(
					'charlimit' => $charlimit
				);

				if ($page_id)
				{
					$data = array(
						'id' => $page->id,
						'category_id' => $page->category_id,
						'sub_category1' => $page->sub_category1,
						'sub_category2' => $page->sub_category2,
						'sub_category3' => $page->sub_category3,
						'title' => $page->title,
						'link1' => $page->link1,
						'image1' => $page->image1,
						'start_date' => strstr($page->start_date, '1900-01-01') ? '' : date('m/d/Y', strtotime($page->start_date)),
						'end_date' => strstr($page->end_date, '1900-01-01') ? '' : date('m/d/Y', strtotime($page->end_date)),
						'charlimit' => $charlimit
					);
				}
				$view->data = $data;
				$view->content_type = $content_type;
			}
			else if ($content_type == 4)
			{
				// Promo
				$view = View::factory('admin/cms/promo/fields');

				$product_categ = MyHelper::product_category();

				$view->arr_categories = $arr_categories;
				$view->arr_prod_categ = $product_categ;

				// For editing
				$data = array(
					'charlimit' => $charlimit
				);

				if ($page_id)
				{
					if ($page->link5)
					{
						$mechanics = 'thumbnail-link';
					}
					else if ($page->template_id)
					{
						$mechanics = 'mechanics-link';
					}
					else
					{
						$mechanics = '';
					}

					$data = array(
						'id' => $page->id,
						'category_id' => $page->category_id,
						'sub_category1' => $page->sub_category1,
						'sub_category2' => $page->sub_category2,
						'sub_category3' => $page->sub_category3,
						'title' => $page->title,
						'promo_desc' => html_entity_decode($page->body4),
						'promo_thumbnail' => $page->image5,
						'mechanics' => $mechanics,
						'start_date' => strstr($page->start_date, '1900-01-01') ? '' : date('m/d/Y', strtotime($page->start_date)),
						'end_date' => strstr($page->end_date, '1900-01-01') ? '' : date('m/d/Y', strtotime($page->end_date)),
						'charlimit' => $charlimit,
						'product_category' => $page->product_category,
						'meta_title' => html_entity_decode($page->meta_title),
						'meta_description' => html_entity_decode($page->meta_description),
						'meta_keyword' => html_entity_decode($page->meta_keyword)
					);
				}
				$view->data = $data;
				$view->content_type = $content_type;
			}
			else if ($content_type == 5)
			{
				// Client Update
				$view = View::factory('admin/cms/client_update/fields');

				$view->arr_categories = $arr_categories;

				$segment_views = MyHelper::segments();

				$user_segments = $this->session->get('user_segment_ids');
				$arr_user_segments = $user_segments ? explode(",", $user_segments) : array();
				$user_segments = '';
				foreach ($arr_user_segments as $k => $v)
				{
					$user_segments .= ($user_segments ? ',' : '').Arr::get($segment_views, $v);
				}

				$view->segment_views = $user_segments;

				// For editing
				$data = array();
				if ($page_id)
				{
					$data = array(
						'id' => $page->id,
						'category_id' => $page->category_id,
						'sub_category1' => $page->sub_category1,
						'sub_category2' => $page->sub_category2,
						'sub_category3' => $page->sub_category3,
						'title' => $page->title,
						'body1' => html_entity_decode($page->body1),
						'start_date' => strstr($page->start_date, '1900-01-01') ? '' : date('m/d/Y', strtotime($page->start_date)),
						'end_date' => strstr($page->end_date, '1900-01-01') ? '' : date('m/d/Y', strtotime($page->end_date)),
						'meta_title' => html_entity_decode($page->meta_title),
						'meta_description' => html_entity_decode($page->meta_description),
						'meta_keyword' => html_entity_decode($page->meta_keyword)
					);
				}
				$view->data = $data;
				$view->content_type = $content_type;
			}
			else if ($content_type == 6)
			{
				// Splash Page
				$view = View::factory('admin/cms/splash_page/fields');

				$view->arr_categories = $arr_categories;

				// For editing
				$data = array();
				if ($page_id)
				{
					$data = array(
						'id' => $page->id,
						'category_id' => $page->category_id,
						'sub_category1' => $page->sub_category1,
						'sub_category2' => $page->sub_category2,
						'sub_category3' => $page->sub_category3,
						'title' => $page->title,
						'body1' => html_entity_decode($page->body1),
						'start_date' => strstr($page->start_date, '1900-01-01') ? '' : date('m/d/Y', strtotime($page->start_date)),
						'end_date' => strstr($page->end_date, '1900-01-01') ? '' : date('m/d/Y', strtotime($page->end_date)),
						'meta_title' => html_entity_decode($page->meta_title),
						'meta_description' => html_entity_decode($page->meta_description),
						'meta_keyword' => html_entity_decode($page->meta_keyword)
					);
				}

				$view->data = $data;
				$view->content_type = $content_type;
			}
			else if ($content_type == 7)
			{
				// Splash Block
				$view = View::factory('admin/cms/splash_block/fields');

				$view->arr_categories = $arr_categories;

				$segment_views = MyHelper::segments();
				$segments[] = '';
				foreach ($segment_views as $k => $v)
				{
					$segments[$k] = $v;
				}
				$view->segment_views = $segments;

				// For editing
				$data = array();
				if ($page_id)
				{
					$field_content = $page->field_content ? json_decode($page->field_content, true) : array();

					$data = array(
						'id' => $page->id,
						'category_id' => $page->category_id,
						'segment_view' => $page->segment_ids,
						'title' => $page->title,
						'body1' => html_entity_decode($page->body1),
						'title1' => html_entity_decode(Arr::get($field_content, 'title1')),
						'image1' => $page->image1,
						'body2' => html_entity_decode($page->body2),
						'link1' => html_entity_decode($page->link1),
						'title2' => html_entity_decode(Arr::get($field_content, 'title2')),
						'image2' => $page->image2,
						'body3' => html_entity_decode($page->body3),
						'link2' => html_entity_decode($page->link2),
						'title3' => html_entity_decode(Arr::get($field_content, 'title3')),
						'image3' => $page->image3,
						'body4' => html_entity_decode($page->body4),
						'link3' => html_entity_decode($page->link3),
						'body6' => html_entity_decode(Arr::get($field_content, 'body6')),
						'body7' => html_entity_decode(Arr::get($field_content, 'body7')),
						'start_date' => strstr($page->start_date, '1900-01-01') ? '' : date('m/d/Y', strtotime($page->start_date)),
						'end_date' => strstr($page->end_date, '1900-01-01') ? '' : date('m/d/Y', strtotime($page->end_date))
					);
				}
				$view->data = $data;
				$view->content_type = $content_type;
			}

			$view->page_id = $page_id;
			$this->response->body($view);
		}
	}

	/**
	 * Get the first Sub Category based on the passed variable
	 * @return [type] [description]
	 */
	public function action_category_change()
	{
		$this->auto_render = FALSE;

		if (HTTP_Request::POST == $this->request->method() AND $this->request->is_ajax())
		{
			$categ_id = Arr::get($this->request->post(), 'categ_id');
			$content_type = Arr::get($this->request->post(), 'content_type');
			$page_id = Arr::get($this->request->post(), 'page_id');

			$template_id = '';
			$page_categ_id = 0;
			if ($page_id)
			{
				$page = ORM::factory('Page', $page_id);
				$template_id = $page->template_id;
				$page_categ_id = $page->category_id;
			}

			// Sub Categories are found in the Nav Tree
			$sub = ORM::factory('NavTree')
				->where('category_id', '=', $categ_id)
				->where('level', '=', 1)
				->order_by('name')
				->find_all();

			$subcateg1 = array();
			// splash banner, client updates, splash page violator
			// will hide the subcategories
			$arr_c = array(2, 5, 6);
			if ( ! in_array($content_type, $arr_c))
			{
				if ($sub->count())
				{
					$subcateg1[] = '';
					foreach ($sub as $res)
					{
						$subcateg1[$res->id] = $res->name;
					}
				}
			}
			$data = array();
			$tpl_view = '';
			$current_tpl = '';

			$subcateg2 = array();
			$subcateg3 = array();

			// get the list of Templates applicable for this Category/Content Type matching
			$sql = ORM::factory('Category', $categ_id);
			$tpls = json_decode($sql->templates);
			$tpl_list = isset($tpls->{$content_type}) ? $tpls->{$content_type} : '';

			$cur_tpl_id = 0;
			if ($page_id)
			{
				if ($page->sub_category2 AND $categ_id == $page_categ_id)
				{
					$categ = ORM::factory('Navtree')
						->where('parent_id', '=', $page->sub_category1)
						->order_by('name')
						->find_all();
					if ($categ->count())
					{
						foreach ($categ as $res)
						{
							$subcateg2[$res->id] = $res->name;
						}
					}
					unset($categ);
				}

				if ($page->sub_category3 AND $categ_id == $page_categ_id)
				{
					$categ = ORM::factory('Navtree')
						->where('parent_id', '=', $page->sub_category2)
						->order_by('name')
						->find_all();
					if ($categ->count())
					{
						foreach ($categ as $res)
						{
							$subcateg3[$res->id] = $res->name;
						}
					}
					unset($categ);
				}

				$data = array(
					'sub_category1' => $categ_id == $page_categ_id ? $page->sub_category1 : NULL,
					'sub_category2' => $categ_id == $page_categ_id ? $page->sub_category2 : NULL,
					'subcateg2' => $subcateg2,
					'sub_category3' => $categ_id == $page_categ_id ? $page->sub_category3 : NULL,
					'subcateg3' => $subcateg3
				);

				$qry = ORM::factory('ContentType', $content_type);
				$char_limit = $qry->charlimit > 0 ? $qry->charlimit : '';

				$arr_tpl_list = explode(",", $tpl_list);
				if ($template_id AND in_array($template_id, $arr_tpl_list))
				{
					$tpl = ORM::factory('Template', $template_id);
					$tpl_sections = $tpl->sections ? json_decode($tpl->sections, true) : array();

					if ($tpl->thumbnail)
					{
						$tpl_image = '<img src="'.URL::site('media/template/'.$tpl->thumbnail).'" style="" alt="" />';
						// $tpl_image = '<img src="'.$this->filesite.'/media/template/'.$tpl->thumbnail.'" style="" alt="" />';
					}
					else
					{
						$tpl_image = '<img data-src="'.URL::site('assets/js/holder.js/120').'" src="'.URL::site('assets/images/160x120.png').'" alt="" />';
					}

					$current_tpl = "<span class=\"thumb-nail\" id=\"".$tpl->id."\" title=\"".$tpl->name."\">".$tpl_image."</span>";
					$tpl_view = View::factory('admin/cms/tpl_fields');
					$tpl_view->tpl_sections = $tpl_sections;
					// $tpl_view->template_id = $template_id;
					$tpl_view->page = $page;
					$tpl_view->page_id = $page_id;
					$tpl_view->category_id = $categ_id;
					$tpl_view->content_type_id = $content_type;
					$tpl_view->char_limit = $char_limit;
					// $tpl_view->filepath = $this->filepath;
				}

				$cur_tpl_id = $template_id;
			}

			$view = View::factory('admin/cms/form_content');
			$view->subcateg1 = $subcateg1;
			$view->data = $data;
			$view->tpl_list = $tpl_list;
			$view->current_tpl = $current_tpl;
			$view->tpl_view = $tpl_view;
			$view->content_type = $content_type;
			$view->template_id = $template_id > 0 ? $template_id : '';
			$view->page_id = $page_id;
			$view->category_id = $categ_id;
			$view->cur_tpl_id = $cur_tpl_id;

			$this->response->body($view);
		}
	}

	/**
	 * Generic function to get subcategory of a subcategory
	 * @return [type] [description]
	 */
	public function action_get_subcategory()
	{
		$this->auto_render = FALSE;

		if (HTTP_Request::POST == $this->request->method() AND $this->request->is_ajax())
		{
			$category_id = Arr::get($this->request->post(), 'category_id');
			$parent_id = Arr::get($this->request->post(), 'parent_id');
			$level = (int) Arr::get($this->request->post(), 'level');
			$nxt_level = $level + 1;
			//$page_id = Arr::get($this->request->post(), 'page_id');

			if ($parent_id > 0)
			{
				// Sub Categories are found in the Nav Tree
				$sub = ORM::factory('NavTree')
					->where('category_id', '=', $category_id)
					->where('parent_id', '=', $parent_id)
					// ->where('level', '=', $level)
					->find_all();

				$subcateg = array();
				$subcateg[] = '';

				if ($sub->count())
				{
					foreach ($sub as $res)
					{
						$subcateg[$res->id] = $res->name;
					}

					if ($nxt_level == 2)
					{
						// sub_category2
						$rel = 'subcateg3';
						$fieldname = 'sub_category2';
					}
					else if ($nxt_level == 3)
					{
						$rel = '';
						$fieldname = 'sub_category3';
					}

					$view = View::factory('admin/cms/form_subcategory');
					$view->subcateg = $subcateg;
					$view->level = $level;
					$view->nxt_level = $nxt_level;
					$view->fieldname = $fieldname;

					$data = array();
					$view->data = $data;

					$this->response->body($view);
				}
			}
		}
	}

	/**
	 * Display available templates in colorbox based on the selected category
	 * @return [type] [description]
	 */
	public function action_select_template()
	{
		$this->auto_render = FALSE;

		if (HTTP_Request::POST == $this->request->method() AND $this->request->is_ajax())
		{
			$tpl_list = Arr::get($this->request->post(), 'tpl_list');

			$tpls = ORM::factory('Template')
				->where('id', 'IN', DB::expr('('.$tpl_list.')'))
				->find_all();

			$view = View::factory('admin/cms/tpl_list');
			$view->tpls = $tpls;
			// $view->filesite = $this->filesite;

			$this->response->body($view);
		}
	}

	/**
	 * Use the selected template in the CMS form
	 * @return [type] [description]
	 */
	public function action_set_template()
	{
		$this->auto_render = FALSE;

		if (HTTP_Request::POST == $this->request->method() AND $this->request->is_ajax())
		{
			$template_id = Arr::get($this->request->post(), 'tpl_id');
			$category_id = Arr::get($this->request->post(), 'category_id');
			$content_type_id = Arr::get($this->request->post(), 'content_type_id');

			$tpl = ORM::factory('Template', $template_id);
			$tpl_sections = $tpl->sections ? json_decode($tpl->sections, true) : array();

			$qry = ORM::factory('ContentType', $content_type_id);
			$char_limit = $qry->charlimit > 0 ? $qry->charlimit : '';

			$page = '';
			$view = View::factory('admin/cms/tpl_fields');
			$view->tpl_sections = $tpl_sections;
			// $view->template_id = $template_id;
			$view->category_id = $category_id;
			$view->char_limit = $char_limit;
			$view->content_type_id = $content_type_id;
			$view->page = $page;
			$view->page_id = '';
			// $view->filepath = $this->filepath;

			if ($tpl->thumbnail)
			{
				$tpl_image = '<img src="'.URL::site('media/template/'.$tpl->thumbnail).'" alt="" />';
				// $tpl_image = '<img src="'.$this->filesite.'/media/template/'.$tpl->thumbnail.'" alt="" />';
			}
			else
			{
				$tpl_image = '<img data-src="'.URL::site('assets/js/holder.js/120').'" src="'.URL::site('assets/images/160x120.png').'" alt="" />';
			}

			$selected_tpl = "<span class=\"thumb-nail\" id=\"".$tpl->id."\" title=\"".$tpl->name."\">".$tpl_image."</span>";
			$data = array(
				'html' => $view->render(),
				'tpl' => $selected_tpl,
				'tpl_id' => $template_id
			);

			echo json_encode($data);
			//$this->response->body($view);
		}
	}

	/**
	 * Save the CMS content
	 * @return [type] [description]
	 */
	public function action_save()
	{
		$this->auto_render = FALSE;

		if (HTTP_Request::POST == $this->request->method())
		{
			$token = Arr::get($this->request->post(), 'token');
			// check csrf
			if (Security::check($token))
			{
				// echo "<pre>";
				// var_dump($this->request->post());
				// echo "</pre>";
				// exit;
				// $page_id will have value if we are editing a draft
				$page_id = Arr::get($this->request->post(), 'id');

				$content_type_id = Arr::get($this->request->post(), 'content_type');

				//generate a temp id to identify media files being uploaded which will be updated by the page id generated
				$tmp_id = uniqid();

				if ($page_id > 0)
				{
					$sql = ORM::factory('Page', $page_id);
					$old_template_id = $sql->template_id;
					$old_status = $sql->status;
				}
				else
				{
					$sql = ORM::factory('Page');
					$old_template_id = '';
					$old_status = '';
					$sql->created_by = $this->session->get('user_id');
					$sql->date_created = date('Ymd h:i:s A', time());
				}

				$sql->content_type_id = $content_type_id;

				// For Create New Copy feature (published)
				$control_no_supersede = Arr::get($this->request->post(), 'control_no_supersede');
				$supersede_cn = Arr::get($this->request->post(), 'supersede_cn');
				$stat = Arr::get($this->request->post(), 'stat');

				// Get all applicable fields for this CMS content type
				$category_id = Arr::get($this->request->post(), 'category');
				$sub_category1 = Arr::get($this->request->post(), 'sub_category1');
				$sub_category2 = Arr::get($this->request->post(), 'sub_category2');
				$sub_category3 = Arr::get($this->request->post(), 'sub_category3');

				$sql->category_id = $category_id;
				$sql->sub_category1 = $sub_category1;
				$sql->sub_category2 = $sub_category2;
				$sql->sub_category3 = $sub_category3;

				$meta_title = HTML::chars(Arr::get($this->request->post(), 'meta_title'));
				$meta_description = HTML::chars(Arr::get($this->request->post(), 'meta_description'));
				$meta_keyword = HTML::chars(Arr::get($this->request->post(), 'meta_keyword'));

				// file upload directory
				$directory = DOCROOT.'media/uploads';

				$file_error = '';
				$field_label = array();
				$field_content = array();
				switch ($content_type_id)
				{
					case 2: // Splash Banner
						$user_segments = $this->session->get('user_segment_ids');
						$sql->segment_ids = $user_segments;

						$sql->title = HTML::chars(Arr::get($this->request->post(), 'title'));
						$sql->link1 = HTML::chars(Arr::get($this->request->post(), 'link1'));
						if (Arr::get($this->request->post(), 'file_image1'))
						{
							$image1 = HTML::chars(Arr::get($this->request->post(), 'file_image1'));
							$sql->image1 = $image1;
							DB::insert('media', array('temp_id', 'filename'))
								->values(array($tmp_id, $image1))
								->execute();
							/*
							// remove the existing file in the server
							$old_file = Arr::get($this->request->post(), 'image1_hid');
							if ($old_file)
							{
								MyHelper::remove_file($old_file);
							}
							*/
						}

						if (Arr::get($this->request->post(), 'file_image2'))
						{
							$image2 = HTML::chars(Arr::get($this->request->post(), 'file_image2'));
							$sql->image2 = $image2;
							DB::insert('media', array('temp_id', 'filename'))
								->values(array($tmp_id, $image2))
								->execute();
							/*
							// remove the existing file in the server
							$old_file = Arr::get($this->request->post(), 'image2_hid');
							if ($old_file)
							{
								MyHelper::remove_file($old_file);
							}
							*/
						}

						break;
					case 3: // Ad Banner
						$template_id = Arr::get($this->request->post(), 'template_id');
						$sql->template_id = $template_id;

						$sql->title = HTML::chars(Arr::get($this->request->post(), 'title'));
						$sql->link1 = HTML::chars(Arr::get($this->request->post(), 'link1'));
						if (Arr::get($this->request->post(), 'file_image1'))
						{
							$image1 = HTML::chars(Arr::get($this->request->post(), 'file_image1'));
							$sql->image1 = $image1;
							DB::insert('media', array('temp_id', 'filename'))
								->values(array($tmp_id, $image1))
								->execute();
							/*
							// remove the existing file in the server
							$old_file = Arr::get($this->request->post(), 'image1_hid');
							if ($old_file)
							{
								MyHelper::remove_file($old_file);
							}
							*/
						}
						break;
					case 4: // Promo
						$template_id = Arr::get($this->request->post(), 'template_id');
						$product_category = Arr::get($this->request->post(), 'product_category');
						$sql->template_id = $template_id;
						$sql->product_category = $product_category;

						$sql->meta_title = $meta_title;
						$sql->meta_description = $meta_description;
						$sql->meta_keyword = $meta_keyword;

						$mechanics_click = Arr::get($this->request->post(), 'mechanics_click');

						if (Arr::get($this->request->post(), 'file_image5'))
						{
							$image5 = HTML::chars(Arr::get($this->request->post(), 'file_image5'));
							$sql->image5 = $image5;
							DB::insert('media', array('temp_id', 'filename'))
								->values(array($tmp_id, $image5))
								->execute();
							/*
							// remove the existing file in the server
							$old_file = Arr::get($this->request->post(), 'image5_hid');
							if ($old_file)
							{
								MyHelper::remove_file($old_file);
							}
							*/
						}

						$sql->title = HTML::chars(Arr::get($this->request->post(), 'title'));
						// promo description
						$sql->body4 = HTML::chars(Arr::get($this->request->post(), 'body4'));

						if ($mechanics_click == 'thumbnail-link')
						{
							// promo mechanics link
							$sql->link5 = HTML::chars(Arr::get($this->request->post(), 'link5'));

							// if when editing, the user selected thumbnail link instead of the original mechanics link which is based on the template,
							// set the fields used by the previous template as null
							if ($old_template_id)
							{
								$tpl = ORM::factory('Template', $old_template_id);
								$tpl_sections = $tpl->sections ? json_decode($tpl->sections, true) : array();
								foreach ($tpl_sections as $section => $label)
								{
									$sql->$section = NULL;
								}
							}
						}
						else
						{
							// user selected mechanics link
							$sql->link5 = NULL;

							$tpl = ORM::factory('Template', $template_id);
							$tpl_sections = $tpl->sections ? json_decode($tpl->sections, true) : array();

							foreach ($tpl_sections as $section => $label)
							{
								if (strstr($section, 'image'))
								{
									$regular_fields = array('image1', 'image2', 'image3', 'image4', 'image5');

									if (Arr::get($this->request->post(), 'file_'.$section))
									{
										$fname = HTML::chars(Arr::get($this->request->post(), 'file_'.$section));

										DB::insert('media', array('temp_id', 'filename'))
											->values(array($tmp_id, $fname))
											->execute();

										if (in_array($section, $regular_fields))
										{
											$sql->$section = $fname;
										}
										else
										{
											$field_label[$section] = $label;
											$field_content[$section] = $fname;
										}
										/*
										// remove the existing file in the server
										$old_file = Arr::get($this->request->post(), $section.'_hid');
										if ($old_file)
										{
											MyHelper::remove_file($old_file);
										}
										*/
									}
								}
								else if (strstr($section, 'doc'))
								{
									$regular_fields = array('doc1', 'doc2', 'doc3', 'doc4', 'doc5');

									if (Arr::get($this->request->post(), 'file_'.$section))
									{
										$fname = HTML::chars(Arr::get($this->request->post(), 'file_'.$section));
										// Doc Link Label
										$t = substr($section, 3, 1);
										$fieldlabel = 'doc_label'.$t;
										$filedoc_data = HTML::chars(Arr::get($this->request->post(), $fieldlabel));

										DB::insert('media', array('temp_id', 'filename'))
											->values(array($tmp_id, $fname))
											->execute();

										if (in_array($section, $regular_fields))
										{
											$sql->$section = $fname;
											$sql->$fieldlabel = $filedoc_data;
										}
										else
										{
											$field_label[$section] = $label;
											$field_content[$section] = $fname;
											$field_label[$fieldlabel] = 'File Download Name';
											$field_content[$fieldlabel] = $filedoc_data;
										}
										/*
										// remove the existing file in the server
										$old_file = Arr::get($this->request->post(), $section.'_hid');
										if ($old_file)
										{
											MyHelper::remove_file($old_file);
										}
										*/
									}
								}
								else
								{
									$regular_fields = array('title', 'body1', 'body2', 'body3', 'body4', 'body5', 'link1', 'link2', 'link3', 'link4', 'link5', 'embed1', 'embed2', 'embed3', 'embed4', 'embed5');

									$fname = HTML::chars(Arr::get($this->request->post(), $section));

									if (in_array($section, $regular_fields))
									{
										$sql->$section = $fname;
									}
									else
									{
										$field_label[$section] = $label;
										$field_content[$section] = $fname;
									}
								}
							}

							$sql->field_label = count($field_label) > 0 ? json_encode($field_label) : NULL;
							$sql->field_content = count($field_content) > 0 ? json_encode($field_content) : NULL;
						}

						break;
					case 7: // Splash Block
						$sql->segment_ids = Arr::get($this->request->post(), 'segment_view');
						$sql->title = HTML::chars(Arr::get($this->request->post(), 'title'));
						$sql->body1 = HTML::chars(Arr::get($this->request->post(), 'body1'));

						// Featured 1 block
						$field_label['title1'] = 'Featured 1 Text';
						$field_content['title1'] = HTML::chars(Arr::get($this->request->post(), 'title1'));
						$sql->link1 = HTML::chars(Arr::get($this->request->post(), 'link1'));
						if (Arr::get($this->request->post(), 'file_image1'))
						{
							$image1 = HTML::chars(Arr::get($this->request->post(), 'file_image1'));
							$sql->image1 = $image1;
							DB::insert('media', array('temp_id', 'filename'))
								->values(array($tmp_id, $image1))
								->execute();
						}
						$sql->body2 = HTML::chars(Arr::get($this->request->post(), 'body2'));

						// Featured 2 block
						$field_label['title2'] = 'Featured 2 Text';
						$field_content['title2'] = HTML::chars(Arr::get($this->request->post(), 'title2'));
						$sql->link2 = HTML::chars(Arr::get($this->request->post(), 'link2'));
						if (Arr::get($this->request->post(), 'file_image2'))
						{
							$image2 = HTML::chars(Arr::get($this->request->post(), 'file_image2'));
							$sql->image2 = $image2;
							DB::insert('media', array('temp_id', 'filename'))
								->values(array($tmp_id, $image2))
								->execute();
						}
						$sql->body3 = HTML::chars(Arr::get($this->request->post(), 'body3'));

						// Featured 3 block
						$field_label['title3'] = 'Featured 3 Text';
						$field_content['title3'] = HTML::chars(Arr::get($this->request->post(), 'title3'));
						$sql->link3 = HTML::chars(Arr::get($this->request->post(), 'link3'));
						if (Arr::get($this->request->post(), 'file_image3'))
						{
							$image3 = HTML::chars(Arr::get($this->request->post(), 'file_image3'));
							$sql->image3 = $image3;
							DB::insert('media', array('temp_id', 'filename'))
								->values(array($tmp_id, $image3))
								->execute();
						}
						$sql->body4 = HTML::chars(Arr::get($this->request->post(), 'body4'));

						$field_label['body6'] = 'Top Right Text';
						$field_content['body6'] = HTML::chars(Arr::get($this->request->post(), 'body6'));

						$field_label['body7'] = 'Bottom Right Text';
						$field_content['body7'] = HTML::chars(Arr::get($this->request->post(), 'body7'));

						$sql->field_label = count($field_label) > 0 ? json_encode($field_label) : NULL;
						$sql->field_content = count($field_content) > 0 ? json_encode($field_content) : NULL;

						break;
					default:
						$sql->meta_title = $meta_title;
						$sql->meta_description = $meta_description;
						$sql->meta_keyword = $meta_keyword;

						if ($content_type_id == 5)
						{
							// client update
							$user_segments = $this->session->get('user_segment_ids');
							$sql->segment_ids = $user_segments;
						}

						$template_id = Arr::get($this->request->post(), 'template_id');
						$sql->template_id = $template_id;

						// if user change the template used for this page,
						// set previous template fields to null
						if ($old_template_id AND ($old_template_id != $template_id))
						{
							$tpl = ORM::factory('Template', $old_template_id);
							$tpl_sections = $tpl->sections ? json_decode($tpl->sections, true) : array();
							foreach ($tpl_sections as $section => $label)
							{
								$sql->$section = NULL;
							}
						}

						// Record the fields used for the Template
						$tpl = ORM::factory('Template', $template_id);
						$tpl_sections = $tpl->sections ? json_decode($tpl->sections, true) : array();
						foreach ($tpl_sections as $section => $label)
						{
							if (strstr($section, 'image'))
							{
								$regular_fields = array('image1', 'image2', 'image3', 'image4', 'image5');

								if (Arr::get($this->request->post(), 'file_'.$section))
								{
									$fname = HTML::chars(Arr::get($this->request->post(), 'file_'.$section));

									DB::insert('media', array('temp_id', 'filename'))
										->values(array($tmp_id, $fname))
										->execute();

									if (in_array($section, $regular_fields))
									{
										$sql->$section = $fname;
										// echo $section.' = '.$fname.'<br >';
									}
									else
									{
										$field_label[$section] = $label;
										$field_content[$section] = $fname;
									}
									/*
									// remove the existing file in the server
									$old_file = Arr::get($this->request->post(), $section.'_hid');
									if ($old_file)
									{
										MyHelper::remove_file($old_file);
									}
									*/
								}
							}
							else if (strstr($section, 'doc'))
							{
								$regular_fields = array('doc1', 'doc2', 'doc3', 'doc4', 'doc5');

								if (Arr::get($this->request->post(), 'file_'.$section))
								{
									$fname = HTML::chars(Arr::get($this->request->post(), 'file_'.$section));
									// Doc Link Label
									$t = substr($section, 3, 1);
									$fieldlabel = 'doc_label'.$t;
									$filedoc_data = HTML::chars(Arr::get($this->request->post(), $fieldlabel));

									DB::insert('media', array('temp_id', 'filename'))
										->values(array($tmp_id, $fname))
										->execute();

									if (in_array($section, $regular_fields))
									{
										$sql->$section = $fname;
										$sql->$fieldlabel = $filedoc_data;
									}
									else
									{
										$field_label[$section] = $label;
										$field_content[$section] = $fname;
										$field_label[$fieldlabel] = 'File Download Name';
										$field_content[$fieldlabel] = $filedoc_data;
									}
									/*
									// remove the existing file in the server
									$old_file = Arr::get($this->request->post(), $section.'_hid');
									if ($old_file)
									{
										MyHelper::remove_file($old_file);
									}
									*/
								}
							}
							else
							{
								$regular_fields = array('title', 'body1', 'body2', 'body3', 'body4', 'body5', 'link1', 'link2', 'link3', 'link4', 'link5', 'embed1', 'embed2', 'embed3', 'embed4', 'embed5');

								$fname = HTML::chars(Arr::get($this->request->post(), $section));

								if (in_array($section, $regular_fields))
								{
									$sql->$section = $fname;
								}
								else
								{
									$field_label[$section] = $label;
									$field_content[$section] = $fname;
								}
							}
						}

						$sql->field_label = count($field_label) > 0 ? json_encode($field_label) : NULL;
						$sql->field_content = count($field_content) > 0 ? json_encode($field_content) : NULL;
						break;
				}

				$start_date = Arr::get($this->request->post(), 'startdate');
				$end_date = Arr::get($this->request->post(), 'enddate');

				// Use of Control No
				if ( ! $page_id)
				{
					$control_no = MyHelper::generate_control_no();

					$sql->control_no = $control_no;
				}
				else
				{
					// Create Copy
					if ($stat == 'create-new-copy')
					{
						if ($supersede_cn == 'Y')
						{
							$sql->control_no_supersede = $control_no_supersede;
						}
						$control_no = MyHelper::generate_control_no();

						$sql->control_no = $control_no;
						$sql->date_created = date('Ymd h:i:s A', time());
						$sql->created_by = $this->session->get('user_id');
					}
					else
					{
						$control_no = $sql->control_no;
					}
				}

				$this->session->set('s_control_no', $control_no);

				// Check which button activate the Save
				$btn_clicked = Arr::get($this->request->post(), 'btn_clicked');
				if ($btn_clicked == 'btn-submitted') {
					// Submit for Checking button is clicked
					// Maker submits CMS to Checker for checking
					$status = 'pending-check';
					if ($old_status == 'rework')
					{
						// Rework
						$log_description = 'Re-submitted for Checking';
					}
					else
					{
						// New Posting Request
						$log_description = 'Created New Posting Request';
					}
				} else if ($btn_clicked == 'btn-draft') {
					// Save button is clicked.
					// Maker saves the CMS as Draft
					$status = 'draft';
					if ($old_status == 'rework')
					{
						$status = 'rework';
						$log_description = 'Saved as Draft';
					}
					else
					{
						$log_description = 'Drafted New Posting ';
					}
				}
				// for save complete check of message
				$this->session->set('old_status', $old_status);

				$sql->start_date = $start_date;
				$sql->end_date = $end_date;
				$sql->status_date = date('Ymd h:i:s A', time());

				$sql->status = $status;
				$sql->save();

				$page_id = $sql->id;

				// Update the Media table and link it to the corresponding cms created;
			   DB::update('media')
			    	->set(array('page_id'=>$page_id, 'page_status'=>$status, 'date_added'=>date('Ymd h:i:s A', time())))
			    	->where('temp_id', '=', $tmp_id)
			    	->execute();

				//Document History Trail
				$page_content_type = Arr::get(MyHelper::content_types(), $content_type_id);
				$log_description = $log_description.' - '.$page_content_type;
				MyHelper::document_history($page_id, $this->session->get('user_id'), $log_description);

				if ($btn_clicked == 'btn-submitted') {
					// Submit for Checking button is clicked
					// Maker submits CMS to Checker for checking
					$em = 0;
					if ($old_status == 'rework')
					{
						// Rework
						$subject = $control_no.': EOL Posting request re-submitted for checking';

						// Email to all Checkers
						$em = Email::send(array(5), $subject, $category_id, $page_id);
					}
					else
					{
						// New Posting Request
						$subject = $control_no.': EOL Posting request for checking';

						// Email to all Checkers
						$em = Email::send(array(5), $subject, $category_id, $page_id);
					}

					if ($em != 0)
					{
						$this->session->set('em', $em);
					}
				}

				// Log Activity
				Activity::add($this->session->get('user_id'), $status, $log_description, $control_no, $category_id);

				// if ($status == 'draft')
				if ($btn_clicked == 'btn-draft')
				{
					$navlink = Arr::get($this->request->post(), 'navlink');
					if ($navlink == 'change_pw')
					{
						$this->redirect('admin/misc/change_pw');
					// } else if ($navlink == 'view_all' OR $navlink == 'close' OR ! $navlink) {
					} else if ($navlink == 'view_all' OR $navlink == 'close') {
						$this->redirect('admin/cms/view_all');
					} else if ($navlink == 'new_posting') {
						$this->redirect('admin/cms/new_posting');
					} else if ($navlink == 'logout') {
						$this->redirect('admin/logout');
					} else if ($navlink) {
						$this->redirect('admin/cms/list/'.$navlink);
					} else if ($status == 'draft' OR $status == 'rework') {
						$this->redirect('admin/cms/view/'.$page_id);
					/*
					} else if ($old_status == 'rework') {
						$this->redirect('admin/cms/list/rework');
					*/
					}
				} else {
					$this->redirect('admin/cms/save_complete');
				}
			}

			throw HTTP_Exception::factory(403, 'Error Processing Request');
		}

		throw HTTP_Exception::factory(404, 'URL not found!');
	}

	/**
	 * CMS Confirmation Page
	 * @return [type] [description]
	 */
	public function action_save_complete()
	{
		$control_no = $this->session->get('s_control_no');
		$this->session->delete('s_control_no');
		$old_status = $this->session->get_once('old_status');

		// for email sending check
		$em = $this->session->get_once('em');

		$this->template->content = View::factory('admin/cms/save_complete');
		$this->template->content->control_no = $control_no;
		$this->template->content->old_status = $old_status;
		$this->template->content->em = $em;
	}

	/**
	 * Updating a CMS (Rework, Denied, Archive)
	 * @return [type] [description]
	 */
	public function action_update()
	{
		$this->auto_render = FALSE;

		if (HTTP_Request::POST == $this->request->method())
		{
			$token = Arr::get($this->request->post(), 'token');

			// check csrf
			if (Security::check($token))
			{
				/*
				echo "<pre>";
				var_dump($this->request->post());
				echo "</pre>";
				exit;
				*/
				$page_id = Arr::get($this->request->post(), 'page_id');
				$comment = Arr::get($this->request->post(), 'comment');

				$page = ORM::factory('Page', $page_id);

				if ($page->loaded())
				{
					$btn_clicked = Arr::get($this->request->post(), 'btn_clicked');

					$control_no = $page->control_no;
					$content_type_id = $page->content_type_id;
					$category_id = $page->category_id;
					$current_status = $page->status;

					// check if this page has a coresponding control_no_supersede.
					// mark the referenced control no supersede as archived when user published this page.
					$control_no_supersede = $page->control_no_supersede;
					$copy_from = $page->copy_from;

					if ($btn_clicked == 'btn-copy' OR $btn_clicked == 'btn-copy-archive')
					{
						// Maker is making a new copy of the published or archived posting
						$new_id = $this->page_copy($page_id);

						$status = 'create-new-copy';
						$log_description = 'Create New Copy';
						// Add to History Trail
						$page_content_type = Arr::get(MyHelper::content_types(), $content_type_id);
						$log_description = $log_description.' - '.$page_content_type;
						MyHelper::document_history($page_id, $this->session->get('user_id'), $log_description);

						// Log Activity
						Activity::add($this->session->get('user_id'), $status, $log_description, $control_no, $category_id);

						// Supersede control no
						$this->session->set('copy_cc', $control_no);
						$this->session->set('prev_status', $current_status);

						$this->redirect('admin/cms/view/'.$new_id);
						exit;
					} else if ($btn_clicked == 'btn-pending-publish') {
						// Checker submits CMS to Publisher
						$status = 'pending-publish';
						$log_description = 'Send Posting for Publishing';
						$subject = $control_no.': EOL Posting request for publishing';
					} else if ($btn_clicked == 'btn-pending-check') {
						// Checker submits CMS to Checker 2
						$status = 'pending-concur';
						$log_description = 'Send Posting for Checking';
						$subject = $control_no.': EOL Posting request for concurrence';
					} else if ($btn_clicked == 'button-rework') {
						// Checker return the CMS to maker for Rework
						$status = 'rework';
						$log_description = 'Send Posting for Rework';
						$subject = $control_no.': EOL Posting request returned for rework';
					} else if ($btn_clicked == 'button-rework-archive') {
						// Checker, Checker 2, Publisher return the CMS to maker for Rework Archive request
						$status = 'rework-archive';
						$log_description = 'Send Request to Archive Posting for Rework';
						$subject = $control_no.': EOL Archiving request returned for rework';
					} else if ($btn_clicked == 'button-denied') {
						// Checker denied the page
						$status = 'denied';
						$log_description = 'Mark Posting as Denied';
						$subject = $control_no.': EOL Posting request has been denied';
					} else if ($btn_clicked == 'button-denied-archive') {
						// Checker denied request to archive page, revert the page to publish status
						$status = 'published';
						$log_description = 'Mark Posting for Archive as Denied';
						$subject = $control_no.': EOL Posting request for archiving has been denied';
					} else if ($btn_clicked == 'btn-published') {
						// Publisher published the page
						$status = 'published';
						$log_description = 'Mark Posting as Published';
						$subject = $control_no.': EOL Posting request has been published';
						// record the published date separately
						$page->published_date = date('Ymd h:i:s A', time());
					} else if ($btn_clicked == 'btn-request-archive' OR $btn_clicked == 'btn-request-archive-rework') {
						// Maker requested a published article to be archived
						$status = 'request-archive';
						$log_description = 'Send Posting for Archiving';
						if ($btn_clicked == 'btn-request-archive-rework')
						{
							$subject = $control_no.': EOL Archiving request re-submitted for checking';
						}
						else
						{
							$subject = $control_no.': EOL Archiving request for checking';
						}
					} else if ($btn_clicked == 'btn-check-archive') {
						// Checker checked the requested article to be archived.  Goes to Publisher
						$status = 'pending-archive';
						$log_description = 'Checked Posting for Archiving';
						$subject = $control_no.': EOL Archiving request for implementation';
					} else if ($btn_clicked == 'btn-check2-archive') {
						// Checker checked the requested article to be archived.  Goes to Checker 2
						$status = 'check-archive';
						$log_description = 'Checked Posting For Archiving';
						$subject = $control_no.': EOL Archiving request for concurrence';
					} else if ($btn_clicked == 'btn-for-archive') {
						// Checker2 checked the requested article to be archived.  Goes to Publisher
						$status = 'pending-archive';
						$log_description = 'Checked Posting For Archiving';
						$subject = $control_no.': EOL Archiving request for implementation';
					} else if ($btn_clicked == 'btn-archived') {
						// Publisher archived the page
						$status = 'archived';
						$log_description = 'Archived Posting';
						$subject = $control_no.': EOL Archiving request has been implemented';
					} else if ($btn_clicked == 'btn-cancel-request-archive') {
						// User clicked the Cancel Request to archive the page
						$status = 'published';
						$log_description = 'Archiving request has been cancelled';
						$subject = $control_no.': EOL Archiving request has been cancelled';
					}

					$page->status = $status;
					$page->status_date = date('Ymd h:i:s A', time());
					$page->save();

					$this->session->set('s_control_no', $control_no);

					// save comment
					if ($comment)
					{
						$sql = ORM::factory('PageComment');
						$sql->page_id = $page_id;
						$sql->comment = $comment;
						$sql->comment_by = $this->session->get('user_id');
						$sql->comment_date = date('Ymd h:i:s A', time());
						$sql->save();
					}

					// Add to History Trail
					$page_content_type = Arr::get(MyHelper::content_types(), $content_type_id);
					$log_description = $log_description.' - '.$page_content_type;
					MyHelper::document_history($page_id, $this->session->get('user_id'), $log_description);

					// Mark the referenced control no as archived when this page is published
					// this is now handled by the cron job
					/*
					if ($control_no_supersede AND $copy_from AND $btn_clicked == 'btn-published')
					{
						$p = ORM::factory('Page', $copy_from);
						$p->status = 'archived';
						$p->status_date = date('Ymd h:i:s A', time());
						$p->save();
					}
					*/

					// Send Email Notification
					$em = 0;
					if ($btn_clicked == 'btn-pending-publish') {
						// Email to all Publishers
						$em = Email::send(array(7), $subject, $category_id, $page_id);
					} else if ($btn_clicked == 'btn-pending-check') {
						// Email to Checker 2
						$em = Email::send(array(6), $subject, $category_id, $page_id);
					} else if ($btn_clicked == 'button-rework') {
						// Email to Maker for Rework
						$em = Email::send(array(4), $subject, $category_id, $page_id);
					} else if ($btn_clicked == 'button-denied') {
						// Email to Maker Denying posting request
						$em = Email::send(array(4), $subject, $category_id, $page_id);
					} else if ($btn_clicked == 'button-rework-archive') {
						// Email to Maker for Rework (Request Archive Rework)
						$em = Email::send(array(4), $subject, $category_id, $page_id);
					} else if ($btn_clicked == 'btn-published') {
						// Email to Maker, Checker, EOL Manager
						$em = Email::send(array(4, 5, 6), $subject, $category_id, $page_id, 1);
					} else if ($btn_clicked == 'btn-request-archive' OR $btn_clicked == 'btn-request-archive-rework') {
						// Email to Checker requesting a published article to be archived
						$em = Email::send(array(5), $subject, $category_id, $page_id);
						if ($btn_clicked == 'btn-request-archive-rework')
						{
							$status = 'request-archive-rework';
						}
					} else if ($btn_clicked == 'btn-check2-archive') {
						// Checker checked the requested article to be archived.  Goes to Checker 2
						$em = Email::send(array(6), $subject, $category_id, $page_id);
					} else if ($btn_clicked == 'btn-for-archive') {
						// Email to Publisher notifying them about the request to archive posting
						$em = Email::send(array(7), $subject, $category_id, $page_id);
					} else if ($btn_clicked == 'btn-check-archive') {
						// Email to Publisher notifying them about the request to archive posting
						$em = Email::send(array(7), $subject, $category_id, $page_id);
					} else if ($btn_clicked == 'btn-archived') {
						// Email to Maker, Checker notifying them that the page has been archived
						$em = Email::send(array(4, 5, 6, 7), $subject, $category_id, $page_id, 1);
					} else if ($btn_clicked == 'button-denied-archive') {
						// Email to Maker Denying posting request to archive
						$em = Email::send(array(4), $subject, $category_id, $page_id);
						$status = 'denied-archive';
					} else if ($btn_clicked == 'btn-cancel-request-archive') {
						$em = Email::send(array(4, 5, 6, 7), $subject, $category_id, $page_id);
						$status = 'cancel-rework-archive';
					}

					// Log Activity
					Activity::add($this->session->get('user_id'), $status, $log_description, $control_no, $category_id);

					if ($em != 0)
					{
						$this->session->set('em', $em);
					}

					$this->session->set('s_status', $status);

					$this->redirect('admin/cms/update_complete');
				}
			}
			else
			{
				throw HTTP_Exception::factory(403, 'Error Processing Request');
			}
		}
		else
		{
			throw HTTP_Exception::factory(404, 'URL not found!');
		}
	}

	/**
	 * Landing page after updating a CMS
	 * @return [type] [description]
	 */
	public function action_update_complete()
	{
		$status = $this->session->get('s_status');
		$this->session->delete('s_status');
		$control_no = $this->session->get('s_control_no');
		$this->session->delete('s_control_no');

		$em = $this->session->get_once('em');

		$user_role = $this->session->get('user_role_id');
		switch ($status)
		{
			case 'denied':
				$page_header = 'Denied';
				$page_msg = '<p>Your request with control number '.$control_no.' has been marked as denied.<br />Do you want to check another post?</p>';
				$yes_btn = '<a href="'.URL::site('admin/cms/list/pending-check').'" class="btn btn-success">Yes</a>';
				break;
			case 'rework':
				$page_header = 'For Rework';
				$page_msg = '<p>Your request with control number '.$control_no.' has been returned for rework.<br />Do you want to check another post?</p>';
				$yesbtn_link = 'pending-check';
				if ($user_role == '7')
				{
					$page_msg = '<p>Your request with control number '.$control_no.' has been returned for rework.<br />Do you want to publish another post?</p>';
					$yesbtn_link = 'pending-publish';
				}
				$yes_btn = '<a href="'.URL::site('admin/cms/list/'.$yesbtn_link).'" class="btn btn-success">Yes</a>';
				break;
			case 'rework-archive':
				$page_header = 'For Rework - Archiving Request';
				$page_msg = '<p>Your request with control number '.$control_no.' has been returned for rework.<br />Do you want to check another post?</p>';
				$yesbtn_link = 'pending-check';
				if ($user_role == '7')
				{
					$page_msg = '<p>Your request with control number '.$control_no.' has been returned for rework.<br />Do you want to archive another post?</p>';
					$yesbtn_link = 'pending-archive';
				}
				$yes_btn = '<a href="'.URL::site('admin/cms/list/'.$yesbtn_link).'" class="btn btn-success">Yes</a>';
				break;
			case 'cancel-rework-archive':
				$page_header = 'For Rework - Archiving Request';
				$page_msg = '<p>Your request for archiving with control number '.$control_no.' has been cancelled.<br />Do you want to check another post?</p>';
				$yesbtn_link = 'rework';
				$yes_btn = '<a href="'.URL::site('admin/cms/list/'.$yesbtn_link).'" class="btn btn-success">Yes</a>';
				break;
			case 'pending-publish':
				$page_header = 'Pending for Publishing';
				$page_msg = '<p>Your request with control number '.$control_no.' has been submitted for publishing.<br />Do you want to check another post?</p>';
				$yesbtn_link = 'pending-check';
				if ($user_role == '6')
				{
					$yesbtn_link = 'pending-concur';
				}
				$yes_btn = '<a href="'.URL::site('admin/cms/list/'.$yesbtn_link).'" class="btn btn-success">Yes</a>';
				break;
			case 'published':
				$page_header = 'Published';
				$page_msg = '<p>Control number '.$control_no.' has been published.<br />Do you want to publish another post?</p>';
				$yes_btn = '<a href="'.URL::site('admin/cms/list/pending-publish').'" class="btn btn-success">Yes</a>';
				break;
			case 'request-archive':
				$page_header = 'For Archiving';
				$page_msg = '<p>Your request with control number '.$control_no.' has been submitted for checking.<br />Do you want to archive another post?</p>';
				$yes_btn = '<a href="'.URL::site('admin/cms/list/published').'" class="btn btn-success">Yes</a>';
				break;
			case 'request-archive-rework':
				$page_header = 'For Archiving';
				$page_msg = '<p>Your request with control number '.$control_no.' has been submitted for checking.<br />Do you want to rework another request?</p>';
				$yes_btn = '<a href="'.URL::site('admin/cms/list/rework').'" class="btn btn-success">Yes</a>';
				break;
			case 'pending-archive':
				$page_header = 'For Archiving';
				$page_msg = '<p>Control number '.$control_no.' has been submitted for archiving.<br />Do you want to check another post?</p>';
				$yes_btn = '<a href="'.URL::site('admin/cms/list/pending-check').'" class="btn btn-success">Yes</a>';
				break;
			case 'check-archive':
				$page_header = 'For Archiving';
				$page_msg = '<p>Control number '.$control_no.' has been submitted for checking.<br />Do you want to check another post?</p>';
				$yes_btn = '<a href="'.URL::site('admin/cms/list/pending-check').'" class="btn btn-success">Yes</a>';
				break;
			case 'archived':
				$page_header = 'Archived';
				$page_msg = '<p>Control number '.$control_no.' has been archived.<br />Do you want to archive another post?</p>';
				$yes_btn = '<a href="'.URL::site('admin/cms/list/pending-archive').'" class="btn btn-success">Yes</a>';
				break;
			case 'pending-concur':
				$page_header = 'For Concurring';
				$page_msg = '<p>Control number '.$control_no.' has been submitted for checking.<br />Do you want to check another post?</p>';
				$yes_btn = '<a href="'.URL::site('admin/cms/list/pending-check').'" class="btn btn-success">Yes</a>';
				break;
			case 'denied-archive':
				$page_header = 'For Archiving';
				$page_msg = '<p>Your request with control number '.$control_no.' for archiving has been denied.<br />Do you want to check another post?</p>';
				$yes_btn = '<a href="'.URL::site('admin/cms/list/pending-check').'" class="btn btn-success">Yes</a>';
				break;
		}

		$this->template->content = View::factory('admin/cms/update_complete');
		$this->template->content->control_no = $control_no;
		$this->template->content->page_header = $page_header;
		$this->template->content->page_msg = $page_msg;
		$this->template->content->yes_btn = $yes_btn;
		$this->template->content->em = $em;
	}

	/**
	 * For Promo Mechanics section
	 * @return [type] [description]
	 */
	public function action_promo_mechanics()
	{
		$this->auto_render = FALSE;

		if (HTTP_Request::POST == $this->request->method() AND $this->request->is_ajax())
		{
			$type = Arr::get($this->request->post(), 'type');
			$page_id = Arr::get($this->request->post(), 'page_id');
			$category_id = Arr::get($this->request->post(), 'category_id');
			$content_type_id = Arr::get($this->request->post(), 'content_type_id');

			$page = NULL;
			if ($page_id)
			{
				$page = ORM::factory('Page', (int) $page_id);
			}

			if ($type == 'link')
			{
				$view = View::factory('admin/cms/promo/link');
				$view->page = $page;
			}
			else if ($type == 'form')
			{
				$view = View::factory('admin/cms/promo/form');

				// Display default template if any
				$tpl = ORM::factory('ContentType', 4);

				if ($page_id)
				{
					$template_id = $page->template_id;
				}
				else
				{
					$template_id = 0;
				}

				if ($tpl->loaded())
				{
					$tpl_list = $tpl->def_tpl;
					$view->tpl_list = $tpl_list;
				}

				$view->tpl_view = '';
				$view->current_tpl = '';
				$arr_tpl_list = explode(",", $tpl_list);
				// if ($template_id)
				if ($template_id AND in_array($template_id, $arr_tpl_list))
				{
					$tpl = ORM::factory('Template', $template_id);
					$tpl_sections = $tpl->sections ? json_decode($tpl->sections, true) : array();

					if ($tpl->thumbnail)
					{
						$tpl_image = '<img src="'.URL::site('media/template/'.$tpl->thumbnail).'" style="" alt="" />';
						// $tpl_image = '<img src="'.$this->filesite.'/media/template/'.$tpl->thumbnail.'" style="" alt="" />';
					}
					else
					{
						$tpl_image = '<img data-src="'.URL::site('assets/js/holder.js/120').'" src="'.URL::site('assets/images/160x120.png').'" alt="" />';
					}

					$view->current_tpl = "<span class=\"thumb-nail\" id=\"".$tpl->id."\" title=\"".$tpl->name."\">".$tpl_image."</span>";
					$view->tpl_view = View::factory('admin/cms/tpl_fields');
					$view->tpl_view->tpl_sections = $tpl_sections;
					$view->tpl_view->category_id = $category_id;
					$view->tpl_view->page = $page;
					$view->tpl_view->page_id = $page_id;
					$view->tpl_view->content_type_id = $content_type_id;
					// $view->tpl_view->template_id = $template_id;
					// $view->filepath = $this->filepath;
				}

				$view->template_id = $template_id;
			}

			$this->response->body($view);
		}
	}

	/**
	 * View CMS
	 * @return [type] [description]
	 */
	public function action_view()
	{
		$page_id = $this->request->param('id');

		$user_role = $this->session->get('user_role_id');

		$user_category_ids = $this->session->get('user_category_ids');
		$qry = ORM::factory('Category')
			->where('id', 'IN', DB::expr('('.$user_category_ids.')'))
			->find_all();

		$arr_content_types = array_keys($this->user_content_types($qry, 'filtered'));
		$user_content_types = implode(",", $arr_content_types);

		$sql = ORM::factory('Page');

		if ($user_role == 4)
		{
			$arr_segments = array();
			if ($this->session->get('user_segment_ids'))
			{
				$arr_segments = explode(",", $this->session->get('user_segment_ids'));
			}

			// user is Maker
			$sql->where_open()
				->where('status', '=', 'pending-check')
				->or_where('status', '=', 'pending-concur')
				->or_where('status', '=', 'request-archive')
				->or_where('status', '=', 'draft')
				->or_where('status', '=', 'create-new-copy')
				->or_where('status', '=', 'rework')
				->or_where('status', '=', 'rework-archive')
				->or_where('status', '=', 'check-archive')
				->or_where('status', '=', 'denied')
				->or_where('status', '=', 'pending-publish') // labeled as "Checked"
				->or_where('status', '=', 'pending-archive') // labeled as "Checked"
				->or_where('status', '=', 'concurred')
				->or_where('status', '=', 'published')
				->or_where('status', '=', 'archived')
				->where_close()
				->where('category_id', 'IN', DB::expr('('.$this->session->get('user_category_ids').')'));
			/*
			if ($user_content_types)
			{
				$sql->or_where('content_type_id', 'IN', DB::expr('('.$user_content_types.')'));
			}
			*/
			$sql->where_open();
			foreach ($arr_segments as $s => $segment_id)
			{
				$sql->or_where(DB::expr('\',\'+').'segment_ids'.DB::expr('+\',\''), 'LIKE', "%,$segment_id,%")
					->or_where(DB::expr('\',\'+').'segment_ids'.DB::expr('+\',\''), 'IS', NULL);
			}
			$sql->where_close();

			if ($user_content_types)
			{
				$sql->where('content_type_id', 'IN', DB::expr('('.$user_content_types.')'));
			}
		}
		else if ($user_role == 5)
		{
			$arr_segments = array();
			if ($this->session->get('user_segment_ids'))
			{
				$arr_segments = explode(",", $this->session->get('user_segment_ids'));
			}

			// user is Checker
			$sql->where_open()
				->where('status', '=', 'pending-check')
				->or_where('status', '=', 'pending-concur')
				->or_where('status', '=', 'pending-archive')
				->or_where('status', '=', 'request-archive')
				->or_where('status', '=', 'check-archive')
				->or_where('status', '=', 'denied')
				->or_where('status', '=', 'pending-publish')
				->or_where('status', '=', 'published')
				->or_where('status', '=', 'archived')
				->where_close()
				->where('category_id', 'IN', DB::expr('('.$this->session->get('user_category_ids').')'));
			/*
			if ($user_content_types)
			{
				$sql->or_where('content_type_id', 'IN', DB::expr('('.$user_content_types.')'));
			}
			*/
			$sql->where_open();
			foreach ($arr_segments as $s => $segment_id)
			{
				$sql->or_where(DB::expr('\',\'+').'segment_ids'.DB::expr('+\',\''), 'LIKE', "%,$segment_id,%")
					->or_where(DB::expr('\',\'+').'segment_ids'.DB::expr('+\',\''), 'IS', NULL);
			}
			$sql->where_close();

			if ($user_content_types)
			{
				$sql->where('content_type_id', 'IN', DB::expr('('.$user_content_types.')'));
			}
		}
		else if ($user_role == 6)
		{
			$arr_segments = array();
			if ($this->session->get('user_segment_ids'))
			{
				$arr_segments = explode(",", $this->session->get('user_segment_ids'));
			}

			// user is Checker 2
			$sql->where_open()
				->where('status', '=', 'pending-check')
				->or_where('status', '=', 'pending-concur')
				->or_where('status', '=', 'check-archive')
				->or_where('status', '=', 'pending-archive')
				->or_where('status', '=', 'request-archive')
				->or_where('status', '=', 'denied')
				->or_where('status', '=', 'pending-publish')
				->or_where('status', '=', 'published')
				->or_where('status', '=', 'archived')
				->where_close()
				->where('category_id', 'IN', DB::expr('('.$this->session->get('user_category_ids').')'));
			/*
			if ($user_content_types)
			{
				$sql->or_where('content_type_id', 'IN', DB::expr('('.$user_content_types.')'));
			}
			*/
			$sql->where_open();
			foreach ($arr_segments as $s => $segment_id)
			{
				$sql->or_where(DB::expr('\',\'+').'segment_ids'.DB::expr('+\',\''), 'LIKE', "%,$segment_id,%")
					->or_where(DB::expr('\',\'+').'segment_ids'.DB::expr('+\',\''), 'IS', NULL);
			}
			$sql->where_close();

			if ($user_content_types)
			{
				$sql->where('content_type_id', 'IN', DB::expr('('.$user_content_types.')'));
			}
		}
		else if ($user_role == 7)
		{
			$arr_segments = array();
			if ($this->session->get('user_segment_ids'))
			{
				$arr_segments = explode(",", $this->session->get('user_segment_ids'));
			}

			// user is Publisher
			$sql->where_open()
				->where('status', '=', 'pending-publish')
				->or_where('status', '=', 'pending-archive')
				->or_where('status', '=', 'check-archive')
				->or_where('status', '=', 'request-archive')
				->or_where('status', '=', 'published')
				->or_where('status', '=', 'archived')
				->where_close()
				->where('category_id', 'IN', DB::expr('('.$this->session->get('user_category_ids').')'));
			/*
			if ($user_content_types)
			{
				$sql->or_where('content_type_id', 'IN', DB::expr('('.$user_content_types.')'));
			}
			*/
			$sql->where_open();
			foreach ($arr_segments as $s => $segment_id)
			{
				$sql->or_where(DB::expr('\',\'+').'segment_ids'.DB::expr('+\',\''), 'LIKE', "%,$segment_id,%")
					->or_where(DB::expr('\',\'+').'segment_ids'.DB::expr('+\',\''), 'IS', NULL);
			}
			$sql->where_close();

			if ($user_content_types)
			{
				$sql->where('content_type_id', 'IN', DB::expr('('.$user_content_types.')'));
			}
		}

		$qry = $sql->where('id', '=', $page_id)
			->find_all();

		if ($qry->count())
		{
			$page = $qry->current();
			$status = $page->status;
			$content_type_id = $page->content_type_id;
			$copy_from = $page->copy_from;
			/*
			// Maker not allowed to view posting that are still pending for checking
			if ($user_role == 4 AND $status == 'pending-check')
			{
				throw HTTP_Exception::factory(403, 'Error Processing Request');
			}
			// Checker not allowed to view posting that are still draft
			if ($user_role == 5 AND $status == 'draft')
			{
				throw HTTP_Exception::factory(403, 'Error Processing Request');
			}
			*/

			// only Info Page, Ad Banner and Promo content type (id 1, 3 & 4) has the category/subcategory fields
			$arr_categories = array();
			if ($content_type_id == 1  OR $content_type_id == 3 OR $content_type_id == 4 OR $content_type_id > 7)
			{
				$category_id = $page->category_id;
				$sub_category1 = $page->sub_category1;
				$sub_category2 = $page->sub_category2;
				$sub_category3 = $page->sub_category3;

				if ($category_id)
				{
					$c = ORM::factory('Category', $category_id);
					$arr_categories['category'] = $c->name;
					unset($c);
				}
				if ($sub_category1)
				{
					$c = ORM::factory('Navtree', $sub_category1);
					$arr_categories['subcateg1'] = $c->name;
					unset($c);
				}
				if ($sub_category2)
				{
					$c = ORM::factory('Navtree', $sub_category2);
					$arr_categories['subcateg2'] = $c->name;
					unset($c);
				}
				if ($sub_category3)
				{
					$c = ORM::factory('Navtree', $sub_category3);
					$arr_categories['subcateg3'] = $c->name;
					unset($c);
				}
			}

			$segments = '';
			// only Splash Banner, Client Update, Splash Block content type (id 2, 5 & 7) has the segment fields
			if ($content_type_id == 2 OR $content_type_id == 5 OR $content_type_id == 7)
			{
				$page_segments = $page->segment_ids;

				$segment_views = MyHelper::segments();
				/*
				$user_segments = $this->session->get('user_segment_ids');

				$arr_user_segments = $user_segments ? explode(",", $user_segments) : array();
				foreach ($arr_user_segments as $k => $v)
				{
					$segments .= ($segments ? ', ' : '').Arr::get($segment_views, $v);
				}
				*/

				$arr_segments = $page_segments ? explode(",", $page_segments) : array();
				foreach ($arr_segments as $k => $v)
				{
					$segments .= ($segments ? ', ' : '').Arr::get($segment_views, $v);
				}
			}

			// If page status is draft or rework or create new copy, view edit form
			$editing_statuses = array('draft', 'rework', 'create-new-copy');
			if (in_array($status, $editing_statuses))
			{
				$this->template->content = View::factory('admin/cms/edit');

				// based on the user category assignment, get it's corresponding content type assigned to a category
				$user_category_ids = $this->session->get('user_category_ids');
				$sql = ORM::factory('Category')
					->where('id', 'IN', DB::expr('('.$user_category_ids.')'))
					->find_all();

				$arr_content_types = $this->user_content_types($sql);

				$prev_status = NULL;

				// superseding applies to info page and new content type only
				if ($status == 'create-new-copy')
				{
					$prev_status = $this->session->get('prev_status');
					if ($prev_status != 'archived')
					{
						$supersede_control_no = $this->session->get('copy_cc');
						$this->template->content->supersede_control_no = $supersede_control_no;
					}
				}
				$this->template->content->arr_content_types = $arr_content_types;
				$this->template->content->content_type_id = $page->content_type_id;
				$this->template->content->status = $status;
				$this->template->content->prev_status = $prev_status;
				$this->template->content->copy_from = $copy_from;
			}
			else
			{
				$this->template->content = View::factory('admin/cms/view');

				if ($page->meta_title)
				{
					$this->template->content->meta_title = html_entity_decode($page->meta_title);
				}
				if ($page->meta_description)
				{
					$this->template->content->meta_description = html_entity_decode($page->meta_description);
				}
				if ($page->meta_keyword)
				{
					$this->template->content->meta_keyword = html_entity_decode($page->meta_keyword);
				}
			}

			$page_header = Arr::get(MyHelper::page_status(), $status);
			if (is_array($page_header))
			{
				$page_header = Arr::get($page_header, $this->session->get('user_role_id'));
			}

			if ($status == 'create-new-copy')
			{
				$page_header = 'Create New Copy';
			}

			$arr_archive_statuses = array(
				'rework-archive',
				'request-archive',
				'pending-archive',
				'check-archive'
			);
			if (in_array($status, $arr_archive_statuses))
			{
				$add_status = ' - <small>Request for Archiving</small>';
				$page_header .= $add_status;
			}

			if (is_array($page_header))
			{
				$add_status = '';
				if (in_array($status, $arr_archive_statuses))
				{
					$add_status = ' - <small>Request for Archiving</small>';
				}
				$page_header = Arr::get($page_header, $this->session->get('user_id')).$add_status;
			}

			// get page history
			$history = ORM::factory('DocumentHistory')
				->where('page_id', '=', $page_id)
				->order_by('date_added', 'DESC')
				->find_all();

			// get page comments
			$comments = ORM::factory('PageComment')
				->where('page_id', '=', $page_id)
				->order_by('comment_date', 'DESC')
				->find_all();

			$this->template->content->page = $page;
			$this->template->content->page_header = $page_header;
			$this->template->content->arr_categories = $arr_categories;
			$this->template->content->user_role = $user_role;
			$this->template->content->segments = $segments;

			$this->template->content->doc_history = $history;
			$this->template->content->page_comments = $comments;
		}
		else
		{
			throw HTTP_Exception::factory(403, 'Error Processing Request');
		}
	}

	/**
	 * Get content types based on the user category assignment.
	 * @param  [type] $sql [SQL Object]
	 * @return [type]      [description]
	 */
	private function user_content_types($sql, $type = '')
	{
		$arr_content_types = array();
		if (is_object($sql))
		{
			$tmp_ctypes = array();
			$ctypes = array();
			$arr_ctypes = array();
			foreach ($sql as $res)
			{
				$tmp_ctypes = explode(",", $res->content_types);
				$ctypes = array_merge($ctypes, $tmp_ctypes);
			}

			if ($sql->count() > 1)
			{
				/*
				$arr_unique = array_unique($ctypes);
				$arr_ctypes = array_diff_assoc($ctypes, $arr_unique);
				var_dump($ctypes);
				var_dump($arr_unique);
				var_dump($arr_ctypes);
				*/
				$arr_ctypes = array_unique($ctypes);
			} else {
				$arr_ctypes = $ctypes;
			}

			$content_types = implode(",", $arr_ctypes);

			$sql = ORM::factory('ContentType')
				->where('id', 'IN', DB::expr('('.$content_types.')'))
				->find_all();

			if (! $type)
				$arr_content_types[] = '';

			foreach ($sql as $ctype)
			{
				$arr_content_types[$ctype->id] = $ctype->name;
			}
		}

		return $arr_content_types;
	}

	/**
	 * List CMS based on their status
	 * @return [type] [description]
	 */
	public function action_list()
	{
		// $this->session->delete('s_search_keyword');

		$sort_fields = array(
			'date_created' => 'Date Created',
			'control_no' => 'Control No',
			'title' => 'Title',
			'content_type_id' => 'Content Type',
			'status' => 'Status'
		);

		// get user role id.
		$user_role = $this->session->get('user_role_id');

		$status = $this->request->param('id');

		$nav = $status;
		if ($this->session->get('nav_link') != $nav)
		{
			$this->session->set('nav_link', $nav);
		}

		$page_header = Arr::get(MyHelper::page_status(), $status);
		if (is_array($page_header))
		{
			$page_header = Arr::get($page_header, $this->session->get('user_role_id'));
		}
		if (is_array($page_header))
		{
			$page_header = Arr::get($page_header, $this->session->get('user_id'));
		}

		$user_category_ids = $this->session->get('user_category_ids');
		$qry = ORM::factory('Category')
			->where('id', 'IN', DB::expr('('.$user_category_ids.')'))
			->find_all();

		$arr_content_types = array_keys($this->user_content_types($qry, 'filtered'));
		$user_content_types = implode(",", $arr_content_types);

		$sql = ORM::factory('Page')
			->where_open()
			->where('status', '=', $status);

		switch ($status)
		{
			case 'pending-check':
				$status_date_label = 'Date Submitted';
				if ($user_role == 4 OR $user_role == 5)
				{
					// Request for Archiving is labeled as Pending for Checking in the Maker and Checker view
					$sql->or_where('status', '=', 'request-archive');
				} else if ($user_role == 6) {
					// Checker two pending-check also applies to check-archive status
					$sql->or_where('status', '=', 'check-archive');
				}
				break;
			case 'pending-concur':
				$status_date_label = 'Date Submitted';
				if ($user_role == 6) {
					// Checker two pending-check also applies to check-archive status
					$sql->or_where('status', '=', 'check-archive');
				}
				break;
			case 'draft':
				$status_date_label = 'Last Modified';
				break;
			case 'rework':
				$status_date_label = 'Date Returned';
				if ($user_role == 4)
				{
					// Request for Archiving is labeled as Pending for Checking in the Maker and Checker view
					$sql->or_where('status', '=', 'rework-archive');
				}
				break;
			case 'denied':
				$status_date_label = 'Date Denied';
				break;
			case 'pending-publish':
				if ($user_role == 7)
				{
					$status_date_label = 'Date Received';
				} else {
					$status_date_label = 'Date Checked';
				}
				if ($user_role == 4 OR $user_role == 5 OR $user_role == 6)
				{
					// Request for Archiving is labeled as Pending for Checking in the Maker and Checker view
					$sql->or_where('status', '=', 'pending-archive');
				}
				if ($user_role == 4 OR $user_role == 5)
				{
					$sql->or_where('status', '=', 'check-archive')
						->or_where('status', '=', 'pending-concur');
				}

				break;
			case 'published':
				$status_date_label = 'Date Published';
				if ($user_role == 6)
				{
					$sql->or_where('status', '=', 'request-archive');
				}
				if ($user_role == 7)
				{
					$sql->or_where('status', '=', 'check-archive')
						->or_where('status', '=', 'request-archive');
				}
				break;
			case 'archived':
				$status_date_label = 'Date Archived';
				break;
			case 'pending-archive':
				if ($user_role == 7)
				{
					$status_date_label = 'Date Received';
				} else {
					$status_date_label = 'Date';
				}
				break;
			default:
				$status_date_label = 'Date';
		}

		$sql->where_close();

		$arr_segments = array();
		if ($this->session->get('user_segment_ids'))
		{
			$arr_segments = explode(",", $this->session->get('user_segment_ids'));
		}

		$sql->where_open();
		foreach ($arr_segments as $s => $segment_id)
		{
			$sql->or_where(DB::expr('\',\'+').'segment_ids'.DB::expr('+\',\''), 'LIKE', "%,$segment_id,%")
				->or_where(DB::expr('\',\'+').'segment_ids'.DB::expr('+\',\''), 'IS', NULL);
		}
		$sql->where_close();

		$sql->where('category_id', 'IN', DB::expr('('.$this->session->get('user_category_ids').')'));

		if ($user_content_types)
		{
			$sql->where('content_type_id', 'IN', DB::expr('('.$user_content_types.')'));
		}

		if ($this->session->get('s_search_keyword'))
		{
			$search_keyword = strtolower($this->session->get('s_search_keyword'));

			$wildcard_search = str_replace('.', '%.%', $search_keyword);

			$sql->where_open()
				->where('control_no', '=', $search_keyword)
				->or_where('title', 'LIKE', "%".$wildcard_search."%");

			$arr_page_status = MyHelper::page_status_search($search_keyword, MyHelper::page_status(), $user_role);
			if (count($arr_page_status))
			{
				foreach ($arr_page_status as $key => $page_status)
				{
					$sql->or_where('status', '=', $page_status);
				}
			}

			$arr_content_types = MyHelper::content_types();
			$arr_ctypes = array();
			foreach ($arr_content_types as $k => $v)
			{
				$arr_ctypes[$k] = strtolower($v);
			}

			$search_ctype = NULL;
			if (in_array($search_keyword, $arr_ctypes))
			{
				$search_ctype_res = array_keys($arr_ctypes, $search_keyword);
				$search_ctype = $search_ctype_res[0];
			}
			if ($search_ctype)
			{
				$sql->or_where('content_type_id', '=', $search_ctype);
			}
			$sql->where_close();

			$this->session->delete('s_search_keyword');
		}

		/*
		$page_query = clone $sql;
		$query = $page_query->find_all();
		$count = $query->count();

		$pagination = Pagination::factory(array(
		    'total_items'    => $count,
		    'view'           => 'pagination/floating',
		    'items_per_page' => 20
		));

		$page_links = $pagination->render();

		$sql->limit($pagination->items_per_page)
		    ->offset($pagination->offset);
		*/
		$sort_field = $this->session->get('s_sort_field') ? $this->session->get('s_sort_field') : 'date_created';
		$sort_by = $this->session->get('s_sort_by') ? $this->session->get('s_sort_by') : 'DESC';
		$list = $sql->order_by($sort_field, $sort_by)->find_all();
		// echo Database::instance()->last_query;
		$this->template->content = View::factory('admin/cms/list');
		$this->template->content->query = $list;
		// $this->template->content->pagination = $page_links;
		$this->template->content->page_header = $page_header;
		$this->template->content->status_date_label = $status_date_label;
		$this->template->content->sort_fields = $sort_fields;
		$this->template->content->status = $status;
	}

	/**
	 * Search Function
	 * @return [type] [description]
	 */
	public function action_search()
	{
		$this->auto_render = FALSE;

		if (HTTP_Request::POST == $this->request->method())
		{
			$search_keyword = HTML::chars(Arr::get($this->request->post(), 'search_keyword'));
			$status = Arr::get($this->request->post(), 'status');

			$this->session->set('s_search_keyword', $search_keyword);

			if ($status)
			{
				$this->redirect('admin/cms/list/'.$status);
			} else {
				$this->redirect('admin/cms/view_all');
			}
		}
	}

	/**
	 * Sort CMS list
	 * @return [type] [description]
	 */
	public function action_sort()
	{
		$this->auto_render = FALSE;

		if (HTTP_Request::POST == $this->request->method())
		{
			$sort_field = Arr::get($this->request->post(), 'sort_field');
			$sort_by = Arr::get($this->request->post(), 'sort_by');
			$redirect = Arr::get($this->request->post(), 'redirect');

			$this->session->set('s_sort_field', $sort_field);
			$this->session->set('s_sort_by', $sort_by);

			$this->redirect('admin/cms/'.$redirect);
		}
	}

	/**
	 * Display of Comment Form Field for Rework, Denied, Archive Status
	 * @return [type] [description]
	 */
	public function action_show_comment_form()
	{
		$this->auto_render = FALSE;

		if (HTTP_Request::POST == $this->request->method() AND $this->request->is_ajax())
		{
			$page_id = Arr::get($this->request->post(), 'page_id');
			$btn_clicked = Arr::get($this->request->post(), 'btn_clicked');

			$view = View::factory('admin/cms/comment_form');
			$view->page_id = $page_id;
			$view->btn_clicked = $btn_clicked;

			$this->response->body($view);
		}
	}

	public function action_delete_request()
	{
		$this->auto_render = FALSE;

		if (HTTP_Request::POST == $this->request->method() AND $this->request->is_ajax())
		{
			$token = Arr::get($this->request->post(), 'token');

			// check csrf
			if (Security::check($token))
			{
				/*
				echo "<pre>";
				var_dump($this->request->post());
				echo "</pre>";
				exit;
				*/
				$page_id = Arr::get($this->request->post(), 'page_id');

				$docroot = DOCROOT.'media/uploads';
				// delete all Media files attached to this page/cms
				$media = ORM::factory('Media')
					->where('page_id', '=', $page_id)
					->find_all();
				foreach ($media as $f)
				{
					$filename = $f->filename;

					if (is_file($docroot.'/'.$filename) AND file_exists($docroot.'/'.$filename))
					{
						@unlink($docroot.'/'.$filename);
					}
				}
				// Delete Records in Media table
				DB::delete('media')
			        ->where('page_id', '=', $page_id)
			        ->execute();

				// Delete CMS
				$page = ORM::factory('Page', $page_id);
				$control_no = $page->control_no;
				$category_id = $page->category_id;
				$content_type_id = $page->content_type_id;
				$page->delete();

				// Log Activity
				$page_content_type = Arr::get(MyHelper::content_types(), $content_type_id);
				$status = 'Delete Request';
				$log_description = 'Deleted Posting Request - '.$page_content_type;
				Activity::add($this->session->get('user_id'), $status, $log_description, $control_no, $category_id);

				echo json_encode(TRUE);
			}
		}
	}

	/**
	 * Copy existing cms page
	 * @param  [type] $orig_id [description]
	 * @return [type]          [description]
	 */
	private function page_copy($orig_id)
	{
		$this->auto_render = FALSE;

		$sql = ORM::factory('Page');

		$new_id = $sql->page_copy_new($orig_id);

		return $new_id;
	}

	public function action_remove_file()
	{
		$this->auto_render = FALSE;

		if (HTTP_Request::POST == $this->request->method() AND $this->request->is_ajax())
		{
			$page_id = Arr::get($this->request->post(), 'page_id');
			$field = Arr::get($this->request->post(), 'field');
			$file = Arr::get($this->request->post(), 'file');

			$docroot = DOCROOT.'media/uploads';

			if (is_file($docroot.'/'.$file) AND file_exists($docroot.'/'.$file))
			{
				@unlink($docroot.'/'.$file);

				// remove record from the media table
				$media = ORM::factory('Media')
					->where('page_id', '=', $page_id)
					->where('filename', '=', $file)
					->find();
				if ($media->loaded())
				{
					$media->delete();
				}

				$doc_fields = array('doc1', 'doc2', 'doc3', 'doc4', 'doc5');
				// remove record in the pages table based on the field being deleted
				$sql = ORM::factory('Page', $page_id);
				if ($sql->loaded())
				{
					$sql->{$field} = '';

					if (in_array($field, $doc_fields))
					{
						$t = substr($field, 3, 1);
						$fieldlabel = 'doc_label'.$t;
						$sql->{$fieldlabel} = '';
					}
					$sql->save();
				}

				echo json_encode(true);
				exit;
			}

			echo json_encode(false);
		}
	}

	/*
	 * Handles iframe upload of file
	 *
	 */
	public function action_upload_file()
	{
		$this->auto_render = FALSE;

		$field = $this->request->param('id');
		$type = $this->request->param('id2');

		// $arr_files = array('image1', 'image2', 'image3', 'image4', 'image5');
		if( ! empty($_FILES))
		{
			$directory = DOCROOT.'media/uploads';
			$file = '';
			if (isset($_FILES[$field]['name']))
			{
				if ($type == 'doc')
				{
					$files = Validation::factory($_FILES)
						->rules($field, array(
							array('Upload::not_empty'),
							array('Upload::size', array(':value', '5M')),
							array('Upload::type', array(':value', array('pdf'))),
						));
				}
				else
				{
					$files = Validation::factory($_FILES)
						->rules($field, array(
							array('Upload::not_empty'),
							array('Upload::size', array(':value', '5M')),
							array('Upload::type', array(':value', array('gif', 'jpg', 'jpeg', 'png'))),
						));
				}

				if ($files->check())
				{
					$filename  = preg_replace('/\s+/u', '_', $files[$field]['name']);
					$image = uniqid().'_'.$filename;
					// Upload!
					$file = Upload::save($files[$field], $image, $directory);

					$result = true;
					$msg = $image;
				} else {
					$e = $files->errors('custom');
					$result = false;
					$msg = $e[$field];
				}
				$res = array("result" => $result, "msg" => $msg);

				echo json_encode($res);
			}
			/*
			foreach ($arr_files as $k => $field)
			{
				if (isset($_FILES[$field]['name']))
				{
					$files = Validation::factory($_FILES)
						->rules($field, array(
							array('Upload::not_empty'),
							array('Upload::size', array(':value', '5M')),
							array('Upload::type', array(':value', array('gif', 'jpg', 'jpeg', 'png'))),
						));

					if ($files->check())
					{
						$filename  = preg_replace('/\s+/u', '_', $files[$field]['name']);
						$image = uniqid().'_'.$filename;
						// Upload!
						$file = Upload::save($files[$field], $image, $directory);

						$result = true;
						$msg = $image;
					} else {
						$e = $files->errors('custom');
						$result = false;
						$msg = $e[$field];
					}
					$res = array("result" => $result, "msg" => $msg);

					echo json_encode($res);
					break;
				}
			}
			*/
		}
	}

	public function action_check_navstring()
	{
		$this->auto_render = FALSE;

		if (HTTP_Request::POST == $this->request->method() AND $this->request->is_ajax())
		{
			$category_id = Arr::get($this->request->post(), 'category');
			$content_type_id = Arr::get($this->request->post(), 'content_type');
			$sub_category1 = Arr::get($this->request->post(), 'sub_category1');
			$sub_category2 = Arr::get($this->request->post(), 'sub_category2');
			$sub_category3 = Arr::get($this->request->post(), 'sub_category3');

			// if navstring is checked when in draft or rework or create new copy, this pid variable will have the page id value
			$pid = Arr::get($this->request->post(), 'pid');

			// if create new copy, this variable will have the id of the page being copied
			$copy_from = Arr::get($this->request->post(), 'copy_from');

			// check if supersede checkbox is checked or not
			$supersede = Arr::get($this->request->post(), 'supersede');
			$control_no = Arr::get($this->request->post(), 'ccn_supersede') ? Arr::get($this->request->post(), 'ccn_supersede') : NULL;

			$status = Arr::get($this->request->post(), 'status', '');

			$result = 0;
			$page_id = 0;
			$msg_type = 'alert';
			$page_status = NULL;

			// Info Page Content Type
			if ($content_type_id == 1 OR $content_type_id > 7)
			{
				$sql = ORM::factory('Page')
					->where_open()
					->where('content_type_id', '=', 1)
					->or_where('content_type_id', '>', 7)
					->where_close()
					->where('category_id', '=', $category_id)
					->where('status', '!=', 'denied')
					->where('status', '!=', 'archived')
					->where('status', '!=', 'create-new-copy');

				if ($sub_category1 > 0)
				{
					$sql->where('sub_category1', '=', $sub_category1);
				} else {
					$sql->where_open()
						->where('sub_category1', 'IS', NULL)
						->or_where('sub_category1', '=', 0)
						->where_close();
				}
				if ($sub_category2 > 0)
				{
					$sql->where('sub_category2', '=', $sub_category2);
				} else {
					$sql->where_open()
						->where('sub_category2', 'IS', NULL)
						->or_where('sub_category2', '=', 0)
						->where_close();
				}
				if ($sub_category3 > 0)
				{
					$sql->where('sub_category3', '=', $sub_category3);
				} else {
					$sql->where_open()
						->where('sub_category3', 'IS', NULL)
						->or_where('sub_category3', '=', 0)
						->where_close();
				}

				if ($pid)
				{
					// do not include the current page being edited/reworked in the navstring check
					$sql->where('id', '!=', $pid);
				}

				/*
				if ($copy_from)
				{
					// do not include the copied page in the navstring check
					$sql->where('id', '!=', $copy_from);
				}
				*/

				if ($status == 'draft' OR $status == 'rework')
				{
					$sql->where('id', '!=', $copy_from);
				}

				$qry = $sql->find_all();
				// echo Database::instance()->last_query;
				$page_id = 0;
				if ($qry->count())
				{
					// echo 'false';
					$p = $qry->current();
					$result = 1;
					$page_status = Arr::get(MyHelper::page_status(), $p->status);
					if (is_array($page_status))
					{
						$page_status = Arr::get($page_status, Session::instance()->get('user_role_id'));
					}
					$control_no = $p->control_no;
					$page_id = $p->id;

					if ($supersede == 'false' AND $copy_from == $page_id)
					{
						// supersede unchecked, hierarchy did not change
						$msg_type = 'alert2';
					}
					else if ($supersede == 'false' AND $copy_from != $page_id)
					{
						// supersede unchecked, heirarchy matches other page
						$msg_type = 'confirm';
					}
					else if ($supersede == 'true' AND $copy_from != $page_id)
					{
						// supersede is checked, hierarchy did not match the previous hierarchy
						$msg_type = 'alert3';
					}
				}
				else
				{
					if ($supersede == 'true' AND $copy_from != $page_id)
					{
						// supersede is checked, hierarchy did not match the previous hierarchy
						$msg_type = 'alert3';
					}
				}
			}

			echo $result.'|'.$page_status.'|'.$control_no.'|'.$page_id.'|'.$msg_type;
		}
	}

	public function action_cms_list()
	{
		$this->auto_render = FALSE;

		if (HTTP_Request::POST == $this->request->method() AND $this->request->is_ajax())
		{
			$target_id = Arr::get($this->request->post(), 'target_id');

			$current_date = date('Y-m-d', time());

			$sql = ORM::factory('Page')
				->where_open()
				->where('content_type_id', '=', 1)
				->or_where('content_type_id', '>', 7)
				->where_close()
				->where('start_date', '<=', $current_date)
				->where('end_date', '>=', $current_date)
				->where_open()
				->where('status', '=', 'published')
				->or_where('status', '=', 'request-archive')
				->or_where('status', '=', 'pending-archive')
				->or_where('status', '=', 'check-archive')
				->or_where('status', '=', 'rework-archive')
				->where_close()
				->find_all();

			$v = View::factory('template/body_tpl');
			$view = View::factory('admin/cms_list');
			$view->query = $sql;
			$view->target_id = $target_id;
			$view->cms = 1;

			$v->content = $view;

			$this->response->body($v);
		}
	}

	public function action_check_segment()
	{
		$this->auto_render = FALSE;

		if (HTTP_Request::POST == $this->request->method() AND $this->request->is_ajax())
		{
			$segment_id = Arr::get($this->request->post(), 'segment_view');
			$page_id = Arr::get($this->request->post(), 'id');

			$sql = ORM::factory('Page')
				->where('segment_ids', '=', $segment_id)
				->where('content_type_id', '=', 7)
				->where_open()
				->where('status', '=', 'published')
				->or_where('status', '=', 'request-archive')
				->or_where('status', '=', 'pending-archive')
				->or_where('status', '=', 'check-archive')
				->or_where('status', '=', 'rework-archive')
				->where_close();
			if ($page_id > 0)
			{
				$sql->where('id', '!=', $page_id);
			}

			$query = $sql->find();

			if ($query->loaded())
			{
				echo json_encode(false);
			}
			else
			{
				echo json_encode(true);
			}
		}
	}
}