<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Admin_Help extends Controller_Template {

	public $template = 'template/login_tpl';

	public function action_forgot_password()
	{
		$error = $this->request->param('id');

		$this->template->navmenu = '';
		$this->template->content = View::factory('admin/help/forgot_password');
		$this->template->content->err = $error;
	}

	public function action_verify_user()
	{
		$this->auto_render = FALSE;

		if (HTTP_Request::POST == $this->request->method())
		{
			$token = Arr::get($this->request->post(), 'token');

			if (Security::check($token))
			{
				$subject = 'BPI Express Online CMS Forgot Password';
				$username = Arr::get($this->request->post(), 'username');
				$email = Arr::get($this->request->post(), 'email');

				$user = ORM::factory('Admin')
					->where('username', '=', $username)
					->where('email', '=', $email)
					->find();

				if ($user->id)
				{
					$password = 'temppassword';

					$passw = crypt($password, Cookie::$salt);

					SwiftMailer::init();
					// Create the Transport
					$transport = Swift_MailTransport::newInstance();
					$mailer = Swift_Mailer::newInstance($transport);
					// Message instance with Subject
					$message = Swift_Message::newInstance($subject);

					$msg = "<p>Hi {$user->name},</p><p><br />Your password has been updated. Please use the password given below:<br /><br />{$passw}</p><p><br /><br />BPI Express Online CMS</p>";

					// Set a From: address including a name
					$message->setFrom(array('cms@bpi.com.ph' => 'BPI Express Online CMS'));
					$message->setBody($msg, 'text/html');
					$message->addTo($email, $user->name);

					// Send the message
					$result = $mailer->send($message);

					$this->request->redirect('admin/help/email_sent');

				}
				else
				{
					$this->request->redirect('admin/help/forgot_password/err');
				}
			}
		}
	}

	public function action_email_sent()
	{
		$this->template->navmenu = '';
		$this->template->content = View::factory('admin/help/email_sent');
	}

	public function action_update_password()
	{
		$crypt_data = $this->request->param('id');

		$encrypt = Encrypt::instance();
		$decrypt_data = $encrypt->decode($crypt_data);
		$arr_data = explode("|", $decrypt_data);

		$this->template->navmenu = '';
		$this->template->content = View::factory('admin/help/update_password');
		$this->template->content->arr_data = $arr_data;
	}

	public function action_update_pass()
	{
		$this->auto_render = FALSE;

		if ($this->request->post())
		{
			$password = Arr::get($this->request->post(), 'password');
			$id = Arr::get($this->request->post(), 'user_id');
			$email = Arr::get($this->request->post(), 'email');

			$user = ORM::factory('user', $id);
			$name = $user->name;
			$user->password = sha1($password);
			$user->save();

			$updated_fields = '';
			$updated_fields .= ($updated_fields ? "<br />" : "").'Password has been updated through "Forgot Password" facility';
			// audit trail
			$a_data = array(
				'user_id' => $id,
				'section' => 'Forgot Password',
				'action' => 'Edit',
				'description' => $name.'\'s account has been changed.'."<br />{$updated_fields}",
				'date_added' => time()
			);
			MyHelper::add_log($a_data);

			$this->request->redirect('admin/help/password_changed');
		}
	}

	public function action_password_changed()
	{
		$this->template->content = View::factory('admin/help/password_changed');
	}

	public function action_check_password()
	{
		$this->auto_render = FALSE;

		if ($this->request->post() AND $this->request->is_ajax())
		{
			$password = $this->request->post('password');

			if( ! $this->password_expression($password))
			{
				echo json_encode(FALSE);
			}
			else
			{
				echo json_encode(TRUE);
			}
		}
	}

	private function password_expression($password)
	{
		$text = $password;
		// $regex = '/(?=^.{7,}$)((?=.*\d)|(?=.*\W+))(?![.\n])(?=.*[A-Z])(?=.*[a-z])(?=.*[!@#$%^&+=-]).*$/';
		// $regex = '^.*(?=.{7,20})(?=.*\d)(?=.*[a-zA-Z]).*$^';
		$regex = '/(?=^.{8,}$)((?=.*\d)|(?=.*\W+))(?![.\n])(?=.*[A-Z])(?=.*[a-z])(?=.*[!*@#$%^&+=-]).*$/';

		//now compare
		if ( ! preg_match($regex, $text) ) {
 			return false;
		}else{
			return true;
		}
	}
}
