<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Admin_Login extends Controller_Template {

	public $template = 'template/login_tpl';

	public function action_index()
	{
		$session = Session::instance();
		
		// check if there's a valid user session
		if ($session->get('user_id'))
		{
			$role_id = $session->get('user_role_id');

			if ($role_id == 1 OR $role_id == 2)
			{
				$this->redirect('admin/users');
			}
			else if ($role_id == 3)
			{
				$this->redirect('admin/category');
			}
			else
			{
				$this->redirect('admin/cms');
			}
		}

		$msg = $session->get_once('msg');

		$this->template->navmenu = '';
		$this->template->content = View::factory('admin/login/index');
		$this->template->content->msg = $msg;
	}
	
	public function action_check()
	{
		$this->auto_render = FALSE;

		$session = Session::instance();

		$return = FALSE;
		$redirect = NULL;
		$msg = 'Username and Password do not match.  Please try again.';

		$int_login_try = Kohana::$config->load('site')->get('login_try');
		$sess_idle_time = Kohana::$config->load('site')->get('sess_idle_time');
		$sess_logout_time = Kohana::$config->load('site')->get('sess_logout_time');

		// if (HTTP_Request::POST == $this->request->method() AND $this->request->is_ajax())
		if (HTTP_Request::POST == $this->request->method())
		{
			$token = Arr::get($this->request->post(), 'token');

			if (Security::check($token))
			{
				$username = HTML::chars(Arr::get($this->request->post(), 'username'));
				$passw = HTML::chars(Arr::get($this->request->post(), 'password'));
				// $password = crypt($passw, Cookie::$salt);

				// Test Log
				MyHelper::login_log(array('uname'=>$username, 'pword'=>$passw));

				$check = ORM::factory('Admin')
				    ->where('username', '=', $username)
				    ->where('active', '=', 'Y')
				    ->find();

				if ($check->id)
				{
					$user_id = $check->id;
					$locked = $check->locked;
					$login_try = $check->login_try;
					$role_id = $check->role_id;

					// check it to Active Directory
					$ldap = ldap_connect("133.100.206.130","389") or die("Could not connect to Active Directory");

					if ($ldap)
					{
						$uname = $username.'@UCAS-DEV.BPI.COM.PH';
						$ldap_bind = @ldap_bind($ldap, $uname, $passw);

						if ($ldap_bind)
						{
							if ($locked == 'Y' OR $login_try >= $int_login_try)
							{
								$return = FALSE;
								$msg = 'Your password has been locked due to '.$int_login_try.' invalid login attempts';
								if ($role_id <= 3 OR $role_id > 7)
								{
									$msg .= '<br />Please contact Level 1 User to re-activate your password';
								} else {
									$msg .= '<br />Please contact the user administrator to re-activate your password';
								}

								// For Activity
								$log_action = "Log In";
								$log_description = "Account is locked due to ".$int_login_try." invalid login attempts";

								// Log Activity
								Activity::add($user_id, $log_action, $log_description);
							}
							else
							{
								// get the idle time and idle logout setting
								if ($check->role_id == 2 OR $check->role_id == 3)
								{
									$session->set('tmp_user_id', $check->id);
								}
								else
								{
									$session->set('user_id', $check->id);
								}
								$session->set('user_name', $check->name);
								$session->set('user_role_id', $check->role_id);
								$session->set('sess_idle_time', $sess_idle_time);
								$session->set('sess_logout_time', $sess_logout_time);
								$session->set('last_login', $check->last_visit);

								// For concurrent user login check
								// check first if there's already a record in the sessions table for this user
								$qry = DB::select()
									->from('sessions')
									->where('user_id', '=', $user_id)
									->where('bootout', 'IS', NULL)
									->as_object()
									->execute();
								// echo Database::instance()->last_query.' test ';
								// exit;
								if ($qry->count())
								{
									$sql = $qry->current();
									$sess_id = $sql->session_id;
									DB::update('sessions')->set(array('bootout'=>'Y'))->where('session_id', '=', $sess_id)->execute();
								}

								// Save user id in session table for the new login
								$sql = DB::update('sessions')->set(array('user_id'=>$user_id))->where('session_id', '=', $session->id())->execute();
								// END concurrent user login check

								if ($check->role_id >= 4 AND $check->role_id <= 7)
								{
									// Maker, Checker, Checker 2, Publisher
									$session->set('user_category_ids', $check->category_ids);
									$session->set('user_segment_ids', $check->segment_ids);

									$redirect = 'cms';
								}
								else if ($check->role_id == 3)
								{
									// Data Admin
									$redirect = 'category';
								}
								else
								{
									// 1 and 2 goes to User Management (Level 1 and User Admin)
									$redirect = 'users';
								}

								$check->last_visit = date('Y-m-d H:i:s', time());
								$check->save();

								// reset login_try error count log to 0;
								$this->clear_account($check->id);

								// Log activity for all other user type except data admin and user admin
								// Both user needs verfication from the checker
								if ($check->role_id != 2 AND $check->role_id != 3)
								{
									// For Activity
									$log_action = "Log In";
									$log_description = "Logged in the system on ".date('Y-m-d H:i:s', time());

									// Log Activity
									Activity::add($check->id, $log_action, $log_description);
								}

								$return = TRUE;
								$msg = 'Login Sucessful';
							}
						}
						else
						{
							// correct username in cms but did not connect to AD
							$count = $login_try + 1;
							$sql = ORM::factory('Admin', $user_id);
							$role_id = $sql->role_id;
							$sql->login_try = $count;
							$sql->save();

							// 3 consecutive wrong password attempt.  lock account
							$wrong_pass_count = $session->get('wrong_pass_count');
							if (($wrong_pass_count + 1) >= 3)
							{
								$this->lock_account($user_id);

								$msg = 'Your password has been locked due to '.$int_login_try.' invalid login attempts';
								if ($role_id <= 3 OR $role_id > 7)
								{
									$msg .= '<br />Please contact Level 1 User to re-activate your password';
								} else {
									$msg .= '<br />Please contact the user administrator to re-activate your password';
								}

								// For Activity
								$log_action = "Log In";
								$log_description = "Account is locked due to ".$int_login_try." invalid login attempts";

								// Log Activity
								Activity::add($user_id, $log_action, $log_description);
							}
							else
							{
								$c = $wrong_pass_count + 1;
								$session->set('wrong_pass_count', $c);
								$session->set('login_err', 'Y');

								$msg = 'Username and Password do not match.  Please try again.';

								// For Activity
								$log_action = "Log In";
								$log_description = "Username and Password do not match. (Unable to bind user account to LDAP, username found in our DB)";

								// Log Activity
								Activity::add($user_id, $log_action, $log_description);
							}

							Kohana::$log->add(Log::ERROR, 'Unable to bind user account to LDAP, username found in our DB');

							// Test Log
							MyHelper::login_log(array('uname'=>$uname, 'pword'=>$passw));

							$return = FALSE;
						}
					}
					else
					{
						$msg = 'Username and Password do not match. Please try again.';

						// For Activity
						$log_action = "Log In";
						$log_description = "Username and Password do not match. (Connection Error)";

						// Log Activity
						Activity::add($user_id, $log_action, $log_description);

						Kohana::$log->add(Log::ERROR, 'Unable to connect to LDAP');
					}
				} else {
					$msg = 'Username and Password do not match';
					$return = FALSE;

					Kohana::$log->add(Log::ERROR, 'Username not found in our database');
				}
			}
			else
			{
				Kohana::$log->add(Log::ERROR, 'CSRF detected');
			}
		}
		else
		{
			Kohana::$log->add(Log::ERROR, 'Form method is not POST');
		}

		if ($return == TRUE)
		{
			if ($check->role_id == 2 OR $check->role_id == 3)
			{
				// redirect to user admin or data admin checker
				$this->redirect('admin/login/confirm');
			}
			else
			{
				$this->redirect('admin/'.$redirect);
			}
		}
		else
		{
			$session->set('msg', $msg);
			$this->redirect('admin');
		}
		/*
		$data = array(
			'result' => $return,
			'redirect' => $redirect,
			'msg' => $msg
		);

		echo json_encode($data);
		*/
	}

	private function lock_account($user_id)
	{
		Session::instance()->delete('wrong_pass_count');
		Session::instance()->delete('login_err');

		$sql = ORM::factory('Admin', $user_id);
		$sql->locked = 'Y';
		$sql->save();
	}

	private function clear_account($user_id)
	{
		Session::instance()->delete('wrong_pass_count');
		Session::instance()->delete('login_err');

		$sql = ORM::factory('Admin', $user_id);
		$sql->locked = '';
		$sql->login_try = 0;
		$sql->save();
	}

	/**
	 * User Admin and Data Admin Checker Login Form
	 * @return [type] [description]
	 */
	public function action_confirm()
	{
		$session = Session::instance();
		$role_id = $session->get('user_role_id');

		$msg = $session->get_once('msg');

		$this->template->navmenu = '';
		$this->template->content = View::factory('admin/login/checker');
		$this->template->content->user_role = $role_id == 2 ? 'User Admin Checker' : ($role_id == 3 ? 'Data Admin Checker' : '');
		$this->template->content->msg = $msg;
	}
	
	/**
	 * User Admin and Data Admin Checker Login Check
	 * @return [type] [description]
	 */
	public function action_confirm_check()
	{
		$this->auto_render = FALSE;

		$session = Session::instance();

		$return = FALSE;
		$redirect = NULL;
		$msg = 'Username and Password do not match.  Please try again.';

		$int_login_try = Kohana::$config->load('site')->get('login_try');

		// if (HTTP_Request::POST == $this->request->method() AND $this->request->is_ajax())
		if (HTTP_Request::POST == $this->request->method())
		{
			$token = Arr::get($this->request->post(), 'token');

			if (Security::check($token))
			{
				$username = HTML::chars(Arr::get($this->request->post(), 'username'));
				$passw = HTML::chars(Arr::get($this->request->post(), 'password'));

				// Test Log
				MyHelper::login_log(array('uname'=>$username, 'pword'=>$passw));

				$checker_role_id = $session->get('user_role_id') == 2 ? 8 : 9;

				$check = ORM::factory('Admin')
				    ->where('username', '=', $username)
				    ->where('active', '=', 'Y')
				    ->where('role_id', '=', $checker_role_id)
				    ->find();

				if ($check->id)
				{
					$user_id = $check->id;
					$locked = $check->locked;
					$login_try = $check->login_try;
					$role_id = $check->role_id;

					// check it to Active Directory
					$ldap = ldap_connect("133.100.206.130","389") or die("Could not connect to Active Directory");

					if ($ldap)
					{
						$uname = $username.'@UCAS-DEV.BPI.COM.PH';
						$ldap_bind = @ldap_bind($ldap, $uname, $passw);

						if ($ldap_bind)
						{
							if ($locked == 'Y' OR $login_try >= $int_login_try)
							{
								$return = FALSE;
								$msg = 'Your password has been locked due to '.$int_login_try.' invalid login attempts';
								$msg .= '<br />Please contact Level 1 User to re-activate your password';

								// For Activity
								$log_action = "Log In";
								$log_description = "Account is locked due to ".$int_login_try." invalid login attempts";

								// Log Activity
								Activity::add($user_id, $log_action, $log_description);
							}
							else
							{
								// make user admin and data admin become active
								$u_id = $session->get_once('tmp_user_id');
								$session->set('user_id', $u_id);

								$session->set('checker_id', $check->id);
								$session->set('checker_name', $check->name);

								// redirect
								if ($session->get('user_role_id') == 3)
								{
									// Data Admin
									$redirect = 'category';
								}
								else if ($session->get('user_role_id') == 2)
								{
									// User Admin
									$redirect = 'users';
								}

								$check->last_visit = date('Y-m-d H:i:s', time());
								$check->save();

								// reset login_try error count log to 0;
								$this->clear_account($check->id);

								// For Activity of User Admin or Data Admin
								$log_action = "Log In";
								$log_description = "Logged in the system on ".date('Y-m-d H:i:s', time())."\r\n\r\nChecked By: ".$check->name;
								Activity::add($u_id, $log_action, $log_description);

								// For activity of User Admin Checker or Data Admin Checker
								$log_action = "Log In";
								$log_description = "Logged in the system on ".date('Y-m-d H:i:s', time());
								Activity::add($check->id, $log_action, $log_description);

								$return = TRUE;
								$msg = 'Login Sucessful';
							}
						}
						else
						{
							// correct username in cms but did not connect to AD
							$count = $login_try + 1;
							$sql = ORM::factory('Admin', $user_id);
							$role_id = $sql->role_id;
							$sql->login_try = $count;
							$sql->save();

							// 3 consecutive wrong password attempt.  lock account
							$wrong_pass_count = $session->get('wrong_pass_count');
							if (($wrong_pass_count + 1) >= 3)
							{
								$this->lock_account($user_id);

								$msg = 'Your password has been locked due to '.$int_login_try.' invalid login attempts';
								$msg .= '<br />Please contact Level 1 User to re-activate your password';

								// For Activity
								$log_action = "Log In";
								$log_description = "Account is locked due to ".$int_login_try." invalid login attempts";

								// Log Activity
								Activity::add($user_id, $log_action, $log_description);
							}
							else
							{
								$c = $wrong_pass_count + 1;
								$session->set('wrong_pass_count', $c);
								$session->set('login_err', 'Y');

								$msg = 'Username and Password do not match.  Please try again.';

								// For Activity
								$log_action = "Log In";
								$log_description = "Username and Password do not match.";

								// Log Activity
								Activity::add($user_id, $log_action, $log_description);
							}

							Kohana::$log->add(Log::ERROR, 'Unable to bind user account to LDAP - User/Data Admin Checker');

							// Test Log
							MyHelper::login_log(array('uname'=>$uname, 'pword'=>$passw));

							$return = FALSE;
						}
					}
					else
					{
						Kohana::$log->add(Log::ERROR, 'Unable to connect to LDAP - User/Data Admin Checker');
					}
				} else {
					$msg = 'Username and Password do not match.  Please try again';
				}
			}
			else
			{
				Kohana::$log->add(Log::ERROR, 'CSRF detected - User/Data Admin Checker');
			}
		}
		else
		{
			Kohana::$log->add(Log::ERROR, 'Form method is not POST - User/Data Admin Checker');
		}

		if ($return == TRUE)
		{
			$this->redirect('admin/'.$redirect);
		}
		else
		{
			$session->set('msg', $msg);
			$this->redirect('admin/login/confirm');
		}
	}
}