<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Admin_Login extends Controller_Template {

	public $template = 'template/login_tpl';

	public function action_index()
	{
		$session = Session::instance();
		$msg = $session->get_once('msg');

		$this->template->navmenu = '';
		$this->template->content = View::factory('admin/login/index');
		$this->template->content->msg = $msg;
	}

	public function action_check2()
	{
		$this->auto_render = FALSE;

		$session = Session::instance();

		$return = FALSE;
		$redirect = NULL;
		$msg = 'Username and Password do not match.  Please try again.';
		// if (HTTP_Request::POST == $this->request->method() AND $this->request->is_ajax())
		if (HTTP_Request::POST == $this->request->method())
		{
			$token = Arr::get($this->request->post(), 'token');

			if (Security::check($token))
			{
				$username = HTML::chars(Arr::get($this->request->post(), 'username'));
				$passw = HTML::chars(Arr::get($this->request->post(), 'password'));
				$password = crypt($passw, Cookie::$salt);

				$check = ORM::factory('Admin')
				    ->where('username', '=', $username)
				    ->where('active', '=', 'Y')
				    ->find();

				if ($check->id)
				{
					$user_id = $check->id;
					$locked = $check->locked;
					$login_try = $check->login_try;
					$role_id = $check->role_id;

					if ($locked == 'Y' OR $login_try >= 3)
					{
						$return = FALSE;
						$msg = 'Your password has been locked due to 3 invalid login attempts';
						if ($role_id <= 3)
						{
							$msg .= '<br />Please contact Level 1 User to re-activate your password';
						} else {
							$msg .= '<br />Please contact the user administrator to re-activate your password';
						}

						// For Activity
						$log_action = "Log In";
						$log_description = "Account is locked due to 3 invalid login attempts";

						// Log Activity
						Activity::add($user_id, $log_action, $log_description);
					}
					else
					{
						$user = ORM::factory('Admin')
						    ->where('username', '=', $username)
						    ->and_where('password', '=', $password)
						    ->and_where('active', '=', 'Y')
						    ->find();

						if ($user->id)
						{
							// get the idle time and idle logout setting
							$sql = ORM::factory('setting', 1);
							if ($sql->loaded())
							{
								$sess_idle_time = $sql->sess_time_warn * 1000;
								$sess_logout_time = $sql->sess_time_logout * 1000;
							}
							else
							{
								$sess_idle_time = 240000; // raise alert after 240 seconds (default) of being idle
								$sess_logout_time = 60000; // auto logout 60 seconds (default) after idle time
							}

							$session->set('user_id', $user->id);
							$session->set('user_name', $user->name);
							$session->set('user_role_id', $user->role_id);
							$session->set('sess_idle_time', $sess_idle_time);
							$session->set('sess_logout_time', $sess_logout_time);

							// For concurrent user login check
							// check first if there's already a record in the sessions table for this user
							$qry =DB::select()
								->from('sessions')
								->where('user_id', '=', $user->id)
								->where('bootout', 'IS', NULL)
								->as_object()
								->execute();
							// echo Database::instance()->last_query.' test ';
							// exit;
							if ($qry->count())
							{
								$sql = $qry->current();
								$sess_id = $sql->session_id;
								DB::update('sessions')->set(array('bootout'=>'Y'))->where('session_id', '=', $sess_id)->execute();
							}

							// Save user id in session table for the new login
							$sql = DB::update('sessions')->set(array('user_id'=>$user->id))->where('session_id', '=', $session->id())->execute();
							// END concurrent user login check

							if ($user->role_id >= 4)
							{
								// Maker, Checker, Checker 2, Publisher
								$session->set('user_category_ids', $user->category_ids);
								$session->set('user_segment_ids', $user->segment_ids);
							}

							if ($user->role_id >= 4)
							{
								// Maker, Checker, Checker 2, Publisher
								$redirect = 'cms';
							}
							else if ($user->role_id == 3)
							{
								// Data Admin
								$redirect = 'category';
							}
							else
							{
								// 1 and 2 goes to User Management (Level 1 and User Admin)
								$redirect = 'users';
							}

							$user->last_visit = date('Y-m-d H:i:s', time());
							$user->save();

							// reset login_try error count log to 0;
							$this->clear_account($user->id);

							// For Activity
							$log_action = "Log In";
							$log_description = "Logged in the system on ".date('Y-m-d H:i:s', time());

							// Log Activity
							Activity::add($user->id, $log_action, $log_description);

							$return = TRUE;
							$msg = 'Login Sucessful';
						}
						else
						{
							// correct username but wrong password
							$count = $login_try + 1;
							$sql = ORM::factory('Admin', $user_id);
							$role_id = $sql->role_id;
							$sql->login_try = $count;
							$sql->save();

							// 3 consecutive wrong password attempt.  lock account
							$wrong_pass_count = $session->get('wrong_pass_count');
							if (($wrong_pass_count + 1) >= 3)
							{
								$this->lock_account($user_id);

								$msg = 'Your password has been locked due to 3 invalid login attempts';
								if ($role_id <= 3)
								{
									$msg .= '<br />Please contact Level 1 User to re-activate your password';
								} else {
									$msg .= '<br />Please contact the User Administrator to re-activate your password';
								}

								// For Activity
								$log_action = "Log In";
								$log_description = "Account is locked due to 3 invalid login attempts";

								// Log Activity
								Activity::add($user_id, $log_action, $log_description);
							}
							else
							{
								$c = $wrong_pass_count + 1;
								$session->set('wrong_pass_count', $c);
								$session->set('login_err', 'Y');

								$msg = 'Username and Password do not match.  Please try again.';

								// For Activity
								$log_action = "Log In";
								$log_description = "Username and Password do not match.";

								// Log Activity
								Activity::add($user_id, $log_action, $log_description);
							}

							$return = FALSE;
						}
					}
				} else {
					$msg = 'Username and Password does not match.  Please try again';
				}
			}
		}

		if ($return == TRUE)
		{
			$this->redirect('admin/'.$redirect);
		}
		else
		{
			$session->set('msg', $msg);
			$this->redirect('admin');
		}
		/*
		$data = array(
			'result' => $return,
			'redirect' => $redirect,
			'msg' => $msg
		);

		echo json_encode($data);
		*/
	}

	public function action_check()
	{
		$this->auto_render = FALSE;

		$session = Session::instance();

		$return = FALSE;
		$redirect = NULL;
		$msg = 'Username and Password do not match.  Please try again.';
		// if (HTTP_Request::POST == $this->request->method() AND $this->request->is_ajax())
		if (HTTP_Request::POST == $this->request->method())
		{
			$token = Arr::get($this->request->post(), 'token');

			if (Security::check($token))
			{
				$username = HTML::chars(Arr::get($this->request->post(), 'username'));
				$passw = HTML::chars(Arr::get($this->request->post(), 'password'));
				// $password = crypt($passw, Cookie::$salt);

				$check = ORM::factory('Admin')
				    ->where('username', '=', $username)
				    ->where('active', '=', 'Y')
				    ->find();

				if ($check->id)
				{
					$user_id = $check->id;
					$locked = $check->locked;
					$login_try = $check->login_try;
					$role_id = $check->role_id;

					// check it to Active Directory
					$ldap = ldap_connect("133.100.206.130","389") or die("Could not connect to Active Directory");

					if ($ldap)
					{
						$uname = $username.'@UCAS-DEV.BPI.COM.PH';
						$ldap_bind = @ldap_bind($ldap, $uname, $passw);

						if ($ldap_bind)
						{
							if ($locked == 'Y' OR $login_try >= 3)
							{
								$return = FALSE;
								$msg = 'Your password has been locked due to 3 invalid login attempts';
								if ($role_id <= 3)
								{
									$msg .= '<br />Please contact Level 1 User to re-activate your password';
								} else {
									$msg .= '<br />Please contact the user administrator to re-activate your password';
								}

								// For Activity
								$log_action = "Log In";
								$log_description = "Account is locked due to 3 invalid login attempts";

								// Log Activity
								Activity::add($user_id, $log_action, $log_description);
							}
							else
							{
								// get the idle time and idle logout setting
								$sql = ORM::factory('setting', 1);
								if ($sql->loaded())
								{
									$sess_idle_time = $sql->sess_time_warn * 1000;
									$sess_logout_time = $sql->sess_time_logout * 1000;
								}
								else
								{
									$sess_idle_time = 240000; // raise alert after 240 seconds (default) of being idle
									$sess_logout_time = 60000; // auto logout 60 seconds (default) after idle time
								}

								$session->set('user_id', $check->id);
								$session->set('user_name', $check->name);
								$session->set('user_role_id', $check->role_id);
								$session->set('sess_idle_time', $sess_idle_time);
								$session->set('sess_logout_time', $sess_logout_time);

								// For concurrent user login check
								// check first if there's already a record in the sessions table for this user
								$qry =DB::select()
									->from('sessions')
									->where('user_id', '=', $user_id)
									->where('bootout', 'IS', NULL)
									->as_object()
									->execute();
								// echo Database::instance()->last_query.' test ';
								// exit;
								if ($qry->count())
								{
									$sql = $qry->current();
									$sess_id = $sql->session_id;
									DB::update('sessions')->set(array('bootout'=>'Y'))->where('session_id', '=', $sess_id)->execute();
								}

								// Save user id in session table for the new login
								$sql = DB::update('sessions')->set(array('user_id'=>$user_id))->where('session_id', '=', $session->id())->execute();
								// END concurrent user login check

								if ($check->role_id >= 4)
								{
									// Maker, Checker, Checker 2, Publisher
									$session->set('user_category_ids', $check->category_ids);
									$session->set('user_segment_ids', $check->segment_ids);
								}

								if ($check->role_id >= 4)
								{
									// Maker, Checker, Checker 2, Publisher
									$redirect = 'cms';
								}
								else if ($check->role_id == 3)
								{
									// Data Admin
									$redirect = 'category';
								}
								else
								{
									// 1 and 2 goes to User Management (Level 1 and User Admin)
									$redirect = 'users';
								}

								$check->last_visit = date('Y-m-d H:i:s', time());
								$check->save();

								// reset login_try error count log to 0;
								$this->clear_account($check->id);

								// For Activity
								$log_action = "Log In";
								$log_description = "Logged in the system on ".date('Y-m-d H:i:s', time());

								// Log Activity
								Activity::add($check->id, $log_action, $log_description);

								$return = TRUE;
								$msg = 'Login Sucessful';
							}
						}
						else
						{
							// correct username in cms but did not connect to AD
							$count = $login_try + 1;
							$sql = ORM::factory('Admin', $user_id);
							$role_id = $sql->role_id;
							$sql->login_try = $count;
							$sql->save();

							// 3 consecutive wrong password attempt.  lock account
							$wrong_pass_count = $session->get('wrong_pass_count');
							if (($wrong_pass_count + 1) >= 3)
							{
								$this->lock_account($user_id);

								$msg = 'Your password has been locked due to 3 invalid login attempts';
								if ($role_id <= 3)
								{
									$msg .= '<br />Please contact Level 1 User to re-activate your password';
								} else {
									$msg .= '<br />Please contact the user administrator to re-activate your password';
								}

								// For Activity
								$log_action = "Log In";
								$log_description = "Account is locked due to 3 invalid login attempts";

								// Log Activity
								Activity::add($user_id, $log_action, $log_description);
							}
							else
							{
								$c = $wrong_pass_count + 1;
								$session->set('wrong_pass_count', $c);
								$session->set('login_err', 'Y');

								$msg = 'Username and Password do not match.  Please try again.';

								// For Activity
								$log_action = "Log In";
								$log_description = "Username and Password do not match.";

								// Log Activity
								Activity::add($user_id, $log_action, $log_description);
							}

							$return = FALSE;
						}
					}
				} else {
					$msg = 'Username and Password do not match';
					$return = FALSE;
				}
			}
		}

		if ($return == TRUE)
		{
			$this->redirect('admin/'.$redirect);
		}
		else
		{
			$session->set('msg', $msg);
			$this->redirect('admin');
		}
		/*
		$data = array(
			'result' => $return,
			'redirect' => $redirect,
			'msg' => $msg
		);

		echo json_encode($data);
		*/
	}

	private function lock_account($user_id)
	{
		Session::instance()->delete('wrong_pass_count');
		Session::instance()->delete('login_err');

		$sql = ORM::factory('Admin', $user_id);
		$sql->locked = 'Y';
		$sql->save();
	}

	private function clear_account($user_id)
	{
		Session::instance()->delete('wrong_pass_count');
		Session::instance()->delete('login_err');

		$sql = ORM::factory('Admin', $user_id);
		$sql->locked = '';
		$sql->login_try = 0;
		$sql->save();
	}
}