<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Api extends Controller {
	/*
	public function action_get_client_updates()
	{
		$arr_params = $this->request->query();

		// $limit = array_key_exists('numberOfNotifications', $arr_params) ? $arr_params['numberOfNotifications'] : 10;

		// default to personal on first load
		if ( ! isset($segment_id))
		{
			$segment_id = 1;
		}

		$current_date = date('Y-m-d', time());

		$sql = DB::select('id', 'control_no', 'title', 'category_id', 'status_date')
			->from('pages')
			->where('content_type_id', '=', 5)
			->where('start_date', '<=', $current_date)
			->where('end_date', '>=', $current_date)
			->where_open()
			->where('status', '=', 'published')
			->or_where('status', '=', 'request-archive')
			->or_where('status', '=', 'pending-archive')
			->or_where('status', '=', 'check-archive')
			->or_where('status', '=', 'rework-archive')
			->where_close()
			->where(DB::expr('\',\'+').'segment_ids'.DB::expr('+\',\''), 'LIKE', "%,$segment_id,%");

		if (array_key_exists('numberOfNotifications', $arr_params))
		{
			$sql->limit($arr_params['numberOfNotifications'])
				->offset(0);
		}

		// $qry = $sql->order_by('id', 'DESC')
		$qry = $sql->order_by('status_date', 'DESC')
			->as_object()
			->execute();

		$xml = new SimpleXMLElement('<response/>');

		foreach ($qry as $res)
		{
			$id = $res->id;
			$title = $res->title;
			$url = URL::site('page/client_update/'.$id, true);

			$track = $xml->addChild('url-list');
			$track->addChild('notification', $title);
			$track->addChild('urlnotification', $url);
		}

		$xml->addChild('url-view-more', URL::site('page/client_updates', true));

		$this->response->headers(array('Content-Type'=>'application/xml', 'Cache-Control'=>'no-cache'));
		$this->response->body($xml->asXML());
	}
	*/

	public function action_get_client_updates()
	{
		$current_date = date('Y-m-d', time());

		// personal segment (get latest 5)
		$segment_id = 1;
		$sql = DB::select('id', 'control_no', 'title', 'body1')
			->from('pages')
			->where('content_type_id', '=', 5)
			->where('start_date', '<=', $current_date)
			->where('end_date', '>=', $current_date)
			->where_open()
			->where('status', '=', 'published')
			->or_where('status', '=', 'request-archive')
			->or_where('status', '=', 'pending-archive')
			->or_where('status', '=', 'check-archive')
			->or_where('status', '=', 'rework-archive')
			->where_close()
			->where(DB::expr('\',\'+').'segment_ids'.DB::expr('+\',\''), 'LIKE', "%,$segment_id,%")
			->limit(5)
			->order_by('start_date', 'DESC')
			->as_object()
			->execute();

		// overseas filipino segment
		$segment_id = 5;
		$sql2 = DB::select('id', 'control_no', 'title', 'body1')
			->from('pages')
			->where('content_type_id', '=', 5)
			->where('start_date', '<=', $current_date)
			->where('end_date', '>=', $current_date)
			->where_open()
			->where('status', '=', 'published')
			->or_where('status', '=', 'request-archive')
			->or_where('status', '=', 'pending-archive')
			->or_where('status', '=', 'check-archive')
			->or_where('status', '=', 'rework-archive')
			->where_close()
			->where(DB::expr('\',\'+').'segment_ids'.DB::expr('+\',\''), 'LIKE', "%,$segment_id,%")
			->limit(1)
			->order_by('start_date', 'DESC')
			->as_object()
			->execute();

		$arr_client_updates = array();
		// if there's an OF segment result
		if ($sql2->count())
		{
			$i = 0;
			foreach ($sql as $res)
			{
				if ($i < 4)
				{
					$id = $res->id;
					$title = strip_tags(html_entity_decode($res->title));
					$body = html_entity_decode($res->body1);
					if ($body)
					{
						$url = URL::site('cms/page/'.$id.'/'.URL::title($title), true);
					}
					else
					{
						$url = '#';
					}

					$arr_client_updates[$id] = array(
						'title' => $title,
						'url' => $url
					);
				}

				$i++;
			}

			$of = $sql2->current();
			$id = $of->id;
			$title = strip_tags(html_entity_decode($of->title));
			$body = html_entity_decode($of->body1);
			if ($body)
			{
				$url = URL::site('cms/page/'.$id.'/'.URL::title($title), true);
			}
			else
			{
				$url = '#';
			}

			if ( ! array_key_exists($id, $arr_client_updates))
			{
				$arr_client_updates[$id] = array(
					'title' => $title,
					'url' => $url
				);
			}
		}
		else
		{
			foreach ($sql as $res)
			{
				$id = $res->id;
				$title = strip_tags(html_entity_decode($res->title));
				$body = html_entity_decode($res->body1);
				if ($body)
				{
					$url = URL::site('cms/page/'.$id.'/'.URL::title($title), true);
				}
				else
				{
					$url = '#';
				}

				$arr_client_updates[$id] = array(
					'title' => $title,
					'url' => $url
				);
			}
		}

		$xml = new SimpleXMLElement('<response/>');

		foreach ($arr_client_updates as $k => $v)
		{
			$id = $k;
			$title = $v['title'];
			$url = $v['url'];

			$track = $xml->addChild('url-list');
			$track->addChild('notification', $title);
			$track->addChild('urlnotification', $url);
		}

		$xml->addChild('url-view-more', URL::site('page/client_updates', true));

		$this->response->headers(array('Content-Type'=>'application/xml', 'Cache-Control'=>'no-cache'));
		$this->response->body($xml->asXML());
	}
}