<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Cms extends Controller_Template {

	public $template = 'template/main_tpl';

	public function before()
	{
		parent::before();
	}

	/**
	 * CMS Page Content (Info Pages)
	 * @return [type] [description]
	 */
	public function action_view()
	{
		$categ_level = $this->request->param('level');
		$category_id = $this->request->param('categ_id');
		$blurb = $this->request->param('blurb');

		$current_date = date('Y-m-d', time());

		$sql = ORM::factory('Page')
			->where('start_date', '<=', $current_date)
			->where('end_date', '>=', $current_date)
			->where_open()
			->where('status', '=', 'published')
			->or_where('status', '=', 'request-archive')
			->or_where('status', '=', 'pending-archive')
			->or_where('status', '=', 'check-archive')
			->or_where('status', '=', 'rework-archive')
			->where_close()
			->where_open()
			->where('content_type_id', '=', 1)
			->or_where('content_type_id', '>', 7)
			->where_close();

		if ($categ_level == 0)
		{
			// Category Level
			$sql->where('category_id', '=', $category_id)
				->where_open()
				->where('sub_category1', 'IS', NULL)
				->or_where('sub_category1', '=', 0)
				->where_close()
				->where_open()
				->where('sub_category2', 'IS', NULL)
				->or_where('sub_category2', '=', 0)
				->where_close()
				->where_open()
				->where('sub_category3', 'IS', NULL)
				->or_where('sub_category3', '=', 0)
				->where_close();
		}
		else if ($categ_level == 1)
		{
			$sql->where('category_id', '!=', 0)
				->where('sub_category1', '=', $category_id)
				->where_open()
				->where('sub_category2', 'IS', NULL)
				->or_where('sub_category2', '=', 0)
				->where_close()
				->where_open()
				->where('sub_category3', 'IS', NULL)
				->or_where('sub_category3', '=', 0)
				->where_close();
		}
		else if ($categ_level == 2)
		{
			$sql->where('category_id', '!=', 0)
				->where('sub_category1', '!=', 0)
				->where('sub_category2', '=', $category_id)
				->where_open()
				->where('sub_category3', 'IS', NULL)
				->or_where('sub_category3', '=', 0)
				->where_close();
		}
		else if ($categ_level == 3)
		{
			$sql->where('category_id', '!=', 0)
				->where('sub_category1', '!=', 0)
				->where('sub_category2', '!=', 0)
				->where('sub_category3', '=', $category_id);
		}

		$sql->order_by('id', 'DESC')
			->find();
		// echo Database::instance()->last_query;
		$return = FALSE;
		if ($sql->id)
		{
			// get the template used
			$tpl_id = $sql->template_id;
			$content_type_id = $sql->content_type_id;

			if ($tpl_id)
			{
				// get the fields used for this template and the php filename associated with it
				$sections = array();
				$t = ORM::factory('Template', $tpl_id);
				if ($t->id)
				{
					$tpl_view = View::factory('templates/'.$t->file_name);

					$tpl_view->category_id = $sql->category_id;
					$tpl_view->sub_category1 = $sql->sub_category1;
					$tpl_view->sub_category2 = $sql->sub_category2;
					$tpl_view->sub_category3 = $sql->sub_category3;

					$sections = $t->sections ? json_decode($t->sections, true) : array();

					// for dynamic fields
					$field_label = $sql->field_label ? json_decode($sql->field_label, true) : array();
					$field_content = $sql->field_content ? json_decode($sql->field_content, true) : array();

					$docroot = DOCROOT.'media/uploads';
					foreach ($sections as $fieldname => $label)
					{
						$type =  MyHelper::field_type($fieldname);

						// check if field is part of the original 5 regular fields or new field
						if (in_array($fieldname, MyHelper::regular_fields()))
						{
							$field_value = $sql->{$fieldname} ? html_entity_decode($sql->{$fieldname}) : '';
						}
						else
						{
							$field_value = array_key_exists($fieldname, $field_content) ? html_entity_decode(Arr::get($field_content, $fieldname)) : '';
						}

						if ($type == 'text' OR $type == 'textarea' OR $type == 'embed' )
						{
							$tpl_view->{$fieldname} = $field_value;
						}
						else if ($type == 'file_img')
						{
							if (is_file($docroot.'/'.$field_value) AND file_exists($docroot.'/'.$field_value))
							// if (MyHelper::check_file($this->filepath.'/'.$field_value))
							{
								$tpl_view->{$fieldname} = URL::site('media/uploads/'.$field_value);
								// $tpl_view->{$fieldname} = $this->filesite.'/media/uploads/'.$field_value;
							}
							else
							{
								$tpl_view->{$fieldname} = NULL;
							}
						}
						else if ($type == 'file_doc')
						{
							if (is_file($docroot.'/'.$field_value) AND file_exists($docroot.'/'.$field_value))
							// if (MyHelper::check_file($this->filepath.'/'.$field_value))
							{
								$t = substr($fieldname, 3, 1);
								$fieldlabel = 'doc_label'.$t;
								$filelabelname = array_key_exists($fieldlabel, $field_content) ? html_entity_decode(Arr::get($field_content, $fieldlabel)) : '';

								if ($filelabelname)
								{
									$file_labelname = $filelabelname;
								}
								else
								{
									$file_labelname = URL::site('media/uploads/'.$field_value, true);
								}

								$tpl_view->{$fieldname} = $field_value ? '<a href="'.URL::site('media/uploads/'.$field_value, true).'">'.html_entity_decode($file_labelname).'</a>' : '';
								// $tpl_view->{$fieldname} = $field_value ? '<a href="'.$this->filesite.'/media/uploads/'.$field_value.'">'.html_entity_decode($sql->{$fieldlabel}).'</a>' : '';
							}
							else
							{
								$tpl_view->{$fieldname} = NULL;
							}
						}
						else if ($type == 'link')
						{
							// $tpl_view->{$fieldname} = $field_value ? '<a href="'.$field_value.'">'.$field_value.'</a>' : '';
							$tpl_view->{$fieldname} = $field_value ? $field_value : '';
						}
					}

					$return = TRUE;
				}
			}

			if ($sql->meta_title)
			{
				$this->template->meta_title = html_entity_decode($sql->meta_title);
			}
			if ($sql->meta_description)
			{
				$this->template->meta_description = html_entity_decode($sql->meta_description);
			}
			if ($sql->meta_keyword)
			{
				$this->template->meta_keyword = html_entity_decode($sql->meta_keyword);
			}
		}

		if ($return == TRUE)
		{
			// $this->template = View::factory('template/body_tpl');
			$this->template->content = $tpl_view;
		}
		else
		{
			throw HTTP_Exception::factory(404, 'URL not found!');
		}
	}

	/**
	 * Promo Category Index
	 * @return [type] [description]
	 */
	public function action_promo_index()
	{
		// $product_category = MyHelper::product_category();
		$sql = DB::select()
			->from('promo_header_img')
			->where('id', '=', 1)
			->as_object()
			->execute();
		if ($sql->count())
		{
			$res = $sql->current();
			$header_img = '<img src="'.URL::site('media/uploads/'.$res->image).'" style="width:698px; height:148px;" />';
			// $header_img = '<img src="'.$this->filesite.'/media/uploads/'.$res->image.'" style="width:698px; height:148px;" />';
		}
		else
		{
			$header_img = '<img src="'.URL::site('assets/img/promos-main-banner.jpg').'" style="width:698px; height:148px;" />';
			// $header_img = '<img src="'.$this->filesite.'assets/img/promos-main-banner.jpg'.'" style="width:698px; height:148px;" />';
		}

		$sql = ORM::factory('PromoCategory')
			->find_all();

		$view = View::factory('promos_index');
		$view->promo_category = $sql;
		$view->header_img = $header_img;

		$this->template->content = $view;
	}

	/**
	 * Promo Product List
	 * @return [type] [description]
	 */
	public function action_product_category()
	{
		$content_type_id = 4;
		$product_category = $this->request->param('id');

		$sql = DB::select()
			->from('promo_header_img')
			->where('id', '=', 1)
			->as_object()
			->execute();
		if ($sql->count())
		{
			$res = $sql->current();
			$header_img = '<img src="'.URL::site('media/uploads/'.$res->image).'" style="width:698px; height:148px;" />';
			// $header_img = '<img src="'.$this->filesite.'/media/uploads/'.$res->image.'" style="width:698px; height:148px;" />';
		}
		else
		{
			$header_img = '<img src="'.URL::site('assets/img/promos-main-banner.jpg').'" style="width:698px; height:148px;" />';
			// $header_img = '<img src="'.$this->filesite.'/assets/img/promos-main-banner.jpg'.'" style="width:698px; height:148px;" />';
		}

		$current_date = date('Y-m-d', time());

		$sql = ORM::factory('Page')
			->where('content_type_id', '=', $content_type_id)
			->where('product_category', '=', $product_category)
			->where('start_date', '<=', $current_date)
			->where('end_date', '>=', $current_date)
			->where_open()
			->where('status', '=', 'published')
			->or_where('status', '=', 'request-archive')
			->or_where('status', '=', 'pending-archive')
			->or_where('status', '=', 'check-archive')
			->or_where('status', '=', 'rework-archive')
			->where_close()
			->order_by('published_date', 'DESC')
			->find_all();

		$view = View::factory('promos_product_list');
		$view->prod_categ = $product_category;
		$view->product_category = MyHelper::product_category();
		$view->sql = $sql;
		$view->header_img = $header_img;
		$view->preview = FALSE;

		$this->template->content = $view;
	}

	/**
	 * Promo Details Page
	 * @return [type] [description]
	 */
	public function action_details()
	{
		$content_type_id = 4;
		$product_category = $this->request->param('id');
		$page_id = $this->request->param('id2');

		$current_date = date('Y-m-d', time());

		$sql = ORM::factory('Page')
			->where('content_type_id', '=', $content_type_id)
			->where('product_category', '=', $product_category)
			->where('start_date', '<=', $current_date)
			->where('end_date', '>=', $current_date)
			// ->where('status', '=', 'published')
			->where('id', '=', $page_id)
			->find();

		if ($sql->id)
		{
			$tpl_id = $sql->template_id;

			if ($tpl_id)
			{
				// get the fields used for this template and the php filename associated with it
				$sections = array();
				$t = ORM::factory('Template', $tpl_id);
				if ($t->id)
				{
					$prod_categ = MyHelper::product_category();
					$str_product_categories = '<ul><li><a href="'.URL::site('promos').'">Main</a></li>';
					foreach ($prod_categ as $cid => $cname)
					{
						$active = $cid == $product_category ? ' class="active"' : '';
						$str_product_categories .= '<li'.$active.'><a href="'.URL::site('promos/product_category/'.$cid).'">'.$cname.'</a></li>';
					}
					$str_product_categories .= '</ul>';

					$tpl_view = View::factory('templates/'.$t->file_name);

					$tpl_view->title = $sql->title;
					$tpl_view->category_id = $sql->category_id;
					$tpl_view->sub_category1 = $sql->sub_category1;
					$tpl_view->sub_category2 = $sql->sub_category2;
					$tpl_view->sub_category3 = $sql->sub_category3;
					$tpl_view->product_categories = $str_product_categories;
					$tpl_view->body4 = html_entity_decode($sql->body4);

					$sections = $t->sections ? json_decode($t->sections, true) : array();

					$docroot = DOCROOT.'media/uploads';
					/*
					foreach ($sections as $fieldname => $label)
					{
						$type =  MyHelper::field_type($fieldname);

						if ($type == 'text' OR $type == 'textarea' OR $type == 'embed' )
						{
							$tpl_view->{$fieldname} = $sql->{$fieldname} ? html_entity_decode($sql->{$fieldname}) : '';
						}
						else if ($type == 'file_img')
						{
							if (is_file($docroot.'/'.$sql->{$fieldname}) AND file_exists($docroot.'/'.$sql->{$fieldname}))
							{
								// $tpl_view->{$fieldname} = $sql->{$fieldname} ? '<img src="'.URL::site('media/uploads/'.$sql->{$fieldname}).'" style="width:698px; height:148px;">' : '';
								$tpl_view->{$fieldname} = $sql->{$fieldname} ? URL::site('media/uploads/'.$sql->{$fieldname}) : '';
							}
							else
							{
								$tpl_view->{$fieldname} = NULL;
							}
						}
						else if ($type == 'file_doc')
						{
							if (is_file($docroot.'/'.$sql->{$fieldname}) AND file_exists($docroot.'/'.$sql->{$fieldname}))
							{
								$t = substr($fieldname, 3, 1);
								$fieldlabel = 'doc_label'.$t;
								$tpl_view->{$fieldname} = $sql->{$fieldname} ? '<a href="'.URL::site('media/uploads/'.$sql->{$fieldname}, true).'">'.$sql->{$fieldlabel}.'</a>' : '';
							}
							else
							{
								$tpl_view->{$fieldname} = NULL;
							}
						}
						else if ($type == 'link')
						{
							$tpl_view->{$fieldname} = $sql->{$fieldname} ? '<a href="'.html_entity_decode($sql->{$fieldname}).'">'.html_entity_decode($sql->{$fieldname}).'</a>' : '';
						}
					}
					*/

					foreach ($sections as $fieldname => $label)
					{
						$type =  MyHelper::field_type($fieldname);

						// check if field is part of the original 5 regular fields or new field
						if (in_array($fieldname, MyHelper::regular_fields()))
						{
							$field_value = $sql->{$fieldname} ? html_entity_decode($sql->{$fieldname}) : '';
						}
						else
						{
							$field_value = array_key_exists($fieldname, $field_content) ? html_entity_decode(Arr::get($field_content, $fieldname)) : '';
						}

						if ($type == 'text' OR $type == 'textarea' OR $type == 'embed' )
						{
							$tpl_view->{$fieldname} = $field_value;
						}
						else if ($type == 'file_img')
						{
							if (is_file($docroot.'/'.$field_value) AND file_exists($docroot.'/'.$field_value))
							// if (MyHelper::check_file($this->filepath.'/'.$field_value))
							{
								$tpl_view->{$fieldname} = URL::site('media/uploads/'.$field_value);
								// $tpl_view->{$fieldname} = $this->filesite.'/media/uploads/'.$field_value;
							}
							else
							{
								$tpl_view->{$fieldname} = NULL;
							}
						}
						else if ($type == 'file_doc')
						{
							if (is_file($docroot.'/'.$field_value) AND file_exists($docroot.'/'.$field_value))
							// if (MyHelper::check_file($this->filepath.'/'.$field_value))
							{
								$t = substr($fieldname, 3, 1);
								$fieldlabel = 'doc_label'.$t;
								$tpl_view->{$fieldname} = $field_value ? '<a href="'.URL::site('media/uploads/'.$field_value, true).'">'.$sql->{$fieldlabel}.'</a>' : '';
								// $tpl_view->{$fieldname} = $field_value ? '<a href="'.$this->filesite.'/media/uploads/'.$field_value.'">'.html_entity_decode($sql->{$fieldlabel}).'</a>' : '';
							}
							else
							{
								$tpl_view->{$fieldname} = NULL;
							}
						}
						else if ($type == 'link')
						{
							$tpl_view->{$fieldname} = $field_value ? '<a href="'.$field_value.'">'.$field_value.'</a>' : '';
						}
					}

					$return = TRUE;
					$this->template->content = $tpl_view;

					if ($sql->meta_title)
					{
						$this->template->meta_title = html_entity_decode($sql->meta_title);
					}
					if ($sql->meta_description)
					{
						$this->template->meta_description = html_entity_decode($sql->meta_description);
					}
					if ($sql->meta_keyword)
					{
						$this->template->meta_keyword = html_entity_decode($sql->meta_keyword);
					}
				}
			}
		}
	}

	/**
	 * Search Result Details page
	 * @return [type] [description]
	 */
	public function action_page()
	{
		$page_id = $this->request->param('id');

		$current_date = date('Y-m-d', time());

		$sql = ORM::factory('Page')
			->where('id', '=', $page_id)
			->where('start_date', '<=', $current_date)
			->where('end_date', '>=', $current_date)
			->find();

		$return = FALSE;
		if ($sql->id)
		{
			// get the template used
			$tpl_id = $sql->template_id;
			$content_type_id = $sql->content_type_id;

			// for Splash Banner
			if ($content_type_id == 2)
			{
				$current_date = date('Y-m-d', time());

				$page = ORM::factory('Page')
					->where('content_type_id', '=', 2)
					->where('start_date', '<=', $current_date)
					->where('end_date', '>=', $current_date)
					->where_open()
					->where('status', '=', 'published')
					->or_where('status', '=', 'request-archive')
					->or_where('status', '=', 'pending-archive')
					->or_where('status', '=', 'check-archive')
					->or_where('status', '=', 'rework-archive')
					->where_close()
					->find_all();

				$arr_main = array();
				$arr_thumb = array();
				$arr_main[] = array('link'=>$sql->link1, 'image'=>$sql->image1);
				$arr_thumb[] = array('title'=>$sql->title, 'thumbnail'=>$sql->image2);
				foreach ($page as $res)
				{
					$arr_main[] = array('link'=>$res->link1, 'image'=>$res->image1);
					$arr_thumb[] = array('title'=>$res->title, 'thumbnail'=>$res->image2);
				}

				// get client updates
				$sql = ORM::factory('Page')
					->where('content_type_id', '=', 5)
					->where('start_date', '<=', $current_date)
					->where('end_date', '>=', $current_date)
					->where_open()
					->where('status', '=', 'published')
					->or_where('status', '=', 'request-archive')
					->or_where('status', '=', 'pending-archive')
					->or_where('status', '=', 'check-archive')
					->or_where('status', '=', 'rework-archive')
					->where_close()
					->find_all();

				$view = View::factory('homepage');
				$view->arr_main = $arr_main;
				$view->arr_thumb = $arr_thumb;
				$view->sql = $sql;

				$return = TRUE;
				$this->template->content = $view;
			}
			else if ($content_type_id == 3)
			{
				// Ad Banner
				$t = ORM::factory('Template', $tpl_id);
				if ($t->id)
				{
					$tpl_view = View::factory('templates/'.$t->file_name);
					$tpl_view->image1 = '<a href="'.$sql->link1.'"><img src="'.URL::site('media/uploads/'.$sql->image1).'"></a>';
					// $tpl_view->image1 = '<a href="'.$sql->link1.'"><img src="'.$this->filesite.'/media/uploads/'.$sql->image1.'"></a>';
					$tpl_view->title = html_entity_decode($sql->title);

					$return = TRUE;
					$this->template->content = "<div class=\"main\" style=\"margin-top:30px;\">".$tpl_view."</div>";
				}
			}
			else if ($content_type_id == 4)
			{
				// Promo Details Page
				/*
				$tpl_view = View::factory('template/promo_default_tpl');
				$tpl_view->title = $sql->title;
				$tpl_view->body4 = html_entity_decode($sql->body4);

				$return = TRUE;
				$this->template->content = $tpl_view;
				*/

				$product_category = $sql->product_category;

				// if this page has a template id we are previewing the promo details page else we'll preview the promo products page.
				if ($tpl_id)
				{
					// get the fields used for this template and the php filename associated with it
					$sections = array();
					$t = ORM::factory('Template', $tpl_id);
					if ($t->id)
					{
						$prod_categ = MyHelper::product_category();
						$str_product_categories = '<ul><li><a href="'.URL::site('promos').'">Main</a></li>';
						foreach ($prod_categ as $cid => $cname)
						{
							$active = $cid == $product_category ? ' class="active"' : '';
							$str_product_categories .= '<li'.$active.'><a href="'.URL::site('promos/product_category/'.$cid).'">'.$cname.'</a></li>';
						}
						$str_product_categories .= '</ul>';

						$tpl_view = View::factory('templates/'.$t->file_name);

						$tpl_view->title = $sql->title;
						$tpl_view->category_id = $sql->category_id;
						$tpl_view->sub_category1 = $sql->sub_category1;
						$tpl_view->sub_category2 = $sql->sub_category2;
						$tpl_view->sub_category3 = $sql->sub_category3;
						$tpl_view->product_categories = $str_product_categories;
						$tpl_view->body4 = html_entity_decode($sql->body4);

						$sections = $t->sections ? json_decode($t->sections, true) : array();

						$docroot = DOCROOT.'media/uploads';

						foreach ($sections as $fieldname => $label)
						{
							$type =  MyHelper::field_type($fieldname);

							// check if field is part of the original 5 regular fields or new field
							if (in_array($fieldname, MyHelper::regular_fields()))
							{
								$field_value = $sql->{$fieldname} ? html_entity_decode($sql->{$fieldname}) : '';
							}
							else
							{
								$field_value = array_key_exists($fieldname, $field_content) ? html_entity_decode(Arr::get($field_content, $fieldname)) : '';
							}

							if ($type == 'text' OR $type == 'textarea' OR $type == 'embed' )
							{
								$tpl_view->{$fieldname} = $field_value;
							}
							else if ($type == 'file_img')
							{
								if (is_file($docroot.'/'.$field_value) AND file_exists($docroot.'/'.$field_value))
								// if (MyHelper::check_file($this->filepath.'/'.$field_value))
								{
									$tpl_view->{$fieldname} = URL::site('media/uploads/'.$field_value);
									// $tpl_view->{$fieldname} = $this->filesite.'/media/uploads/'.$field_value;
								}
								else
								{
									$tpl_view->{$fieldname} = NULL;
								}
							}
							else if ($type == 'file_doc')
							{
								if (is_file($docroot.'/'.$field_value) AND file_exists($docroot.'/'.$field_value))
								// if (MyHelper::check_file($this->filepath.'/'.$field_value))
								{
									$t = substr($fieldname, 3, 1);
									$fieldlabel = 'doc_label'.$t;
									$tpl_view->{$fieldname} = $field_value ? '<a href="'.URL::site('media/uploads/'.$field_value, true).'">'.$sql->{$fieldlabel}.'</a>' : '';
									// $tpl_view->{$fieldname} = $field_value ? '<a href="'.$this->filesite.'/media/uploads/'.$field_value.'">'.html_entity_decode($sql->{$fieldlabel}).'</a>' : '';
								}
								else
								{
									$tpl_view->{$fieldname} = NULL;
								}
							}
							else if ($type == 'link')
							{
								$tpl_view->{$fieldname} = $field_value ? '<a href="'.$field_value.'">'.$field_value.'</a>' : '';
							}
						}

						$return = TRUE;
						$this->template->content = $tpl_view;
					}
				}
				else
				{
					$title = $sql->title;
					$short_desc = html_entity_decode($sql->body4);
					$thumbnail = $sql->image5;
					$date_published = date('m/d/y', time());
					$link5 = $sql->link5;
					if ($link5)
					{
						if (strpos(strtolower($link5), 'http') === 0)  {
							$link = $link5;
						} else {
							$link = 'http://'.$link5;
						}
					} else {
						$link = URL::site('promos/details/'.$product_category.'/'.$sql->id);
					}
					$current_date = date('Y-m-d', time());

					$sql = ORM::factory('Page')
						->where('content_type_id', '=', $content_type_id)
						->where('product_category', '=', $product_category)
						->where('start_date', '<=', $current_date)
						->where('end_date', '>=', $current_date)
						->where_open()
						->where('status', '=', 'published')
						->or_where('status', '=', 'request-archive')
						->or_where('status', '=', 'pending-archive')
						->or_where('status', '=', 'check-archive')
						->or_where('status', '=', 'rework-archive')
						->where_close()
						->order_by('status_date', 'DESC')
						->find_all();

					$view = View::factory('promos_product_list');
					$view->prod_categ = $product_category;
					$view->product_category = MyHelper::product_category();
					$view->title = $title;
					$view->short_desc = $short_desc;
					$view->date_published = $date_published;
					$view->thumbnail = $thumbnail;
					$view->link = $link;
					$view->sql = $sql;
					$view->preview = TRUE;
					$return = TRUE;

					$this->template->content = $view;
				}
			}
			else if ($tpl_id AND ($content_type_id == 1 OR $content_type_id >= 5))
			{
				// get the fields used for this template and the php filename associated with it
				$sections = array();
				$t = ORM::factory('Template', $tpl_id);
				if ($t->id)
				{
					$tpl_view = View::factory('templates/'.$t->file_name);
					$tpl_view->category_id = $sql->category_id;
					$tpl_view->sub_category1 = $sql->sub_category1;
					$tpl_view->sub_category2 = $sql->sub_category2;
					$tpl_view->sub_category3 = $sql->sub_category3;

					$sections = $t->sections ? json_decode($t->sections, true) : array();

					$docroot = DOCROOT.'media/uploads';

					foreach ($sections as $fieldname => $label)
					{
						$type =  MyHelper::field_type($fieldname);

						// check if field is part of the original 5 regular fields or new field
						if (in_array($fieldname, MyHelper::regular_fields()))
						{
							$field_value = $sql->{$fieldname} ? html_entity_decode($sql->{$fieldname}) : '';
						}
						else
						{
							$field_value = array_key_exists($fieldname, $field_content) ? html_entity_decode(Arr::get($field_content, $fieldname)) : '';
						}

						if ($type == 'text' OR $type == 'textarea' OR $type == 'embed' )
						{
							$tpl_view->{$fieldname} = $field_value;
						}
						else if ($type == 'file_img')
						{
							if (is_file($docroot.'/'.$field_value) AND file_exists($docroot.'/'.$field_value))
							// if (MyHelper::check_file($this->filepath.'/'.$field_value))
							{
								$tpl_view->{$fieldname} = URL::site('media/uploads/'.$field_value);
								// $tpl_view->{$fieldname} = $this->filesite.'/media/uploads/'.$field_value;
							}
							else
							{
								$tpl_view->{$fieldname} = NULL;
							}
						}
						else if ($type == 'file_doc')
						{
							if (is_file($docroot.'/'.$field_value) AND file_exists($docroot.'/'.$field_value))
							// if (MyHelper::check_file($this->filepath.'/'.$field_value))
							{
								$t = substr($fieldname, 3, 1);
								$fieldlabel = 'doc_label'.$t;
								$tpl_view->{$fieldname} = $field_value ? '<a href="'.URL::site('media/uploads/'.$field_value, true).'">'.$sql->{$fieldlabel}.'</a>' : '';
								// $tpl_view->{$fieldname} = $field_value ? '<a href="'.$this->filesite.'/media/uploads/'.$field_value.'">'.html_entity_decode($sql->{$fieldlabel}).'</a>' : '';
							}
							else
							{
								$tpl_view->{$fieldname} = NULL;
							}
						}
						else if ($type == 'link')
						{
							$tpl_view->{$fieldname} = $field_value ? '<a href="'.$field_value.'">'.$field_value.'</a>' : '';
						}
					}

					$return = TRUE;
					$this->template->content = $tpl_view;
				}
			}

			if ($sql->meta_title)
			{
				$this->template->meta_title = html_entity_decode($sql->meta_title);
			}
			if ($sql->meta_description)
			{
				$this->template->meta_description = html_entity_decode($sql->meta_description);
			}
			if ($sql->meta_keyword)
			{
				$this->template->meta_keyword = html_entity_decode($sql->meta_keyword);
			}
		}

		if ($return != TRUE)
		{
			throw HTTP_Exception::factory(404, 'URL not found!');
		}
	}
}