<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Cron extends Controller {

	public function action_purge()
	{
		$current_date = date('Y-m-d', time());

		$purge_ids = array();

		// get the purge setting
		$sql = DB::select('purge_draft', 'purge_denied', 'purge_archived')
			->from('setting')
			->as_object()
			->execute();

		if ($sql->count())
		{
			$p = $sql->current();
			$purge_draft = $p->purge_draft;
			$purge_denied = $p->purge_denied;
			$purge_archived = $p->purge_archived;

			$draft_ts = mktime(0, 0, 0, date('n')-$purge_draft, date('j'), date('Y'));
			$draft_d8 = date('Y-m-d', $draft_ts);
			//get pages where status is draft and status date is less than the computed purge date
			$qry = DB::select()
				->from('pages')
				->where('status', '=', 'draft')
				->where('status_date', '<', $draft_d8)
				->as_object()
				->execute();

			if ($qry->count())
			{
				foreach ($qry as $res)
				{
					$page_id = $res->id;
					$purge_ids[] = $page_id;
					// remove records from the media table based on the page id
					/*
					$query = DB::delete('media')
						->where('page_id', '=', $page_id)
						->execute();
					*/
				}
				// process now the deletion of the page
				// DB::delete('pages')
				// 	->where('status', '=', 'draft')
				// 	->where('status_date', '<', $draft_d8)
				// 	->execute();
			}
			// end purge draft

			$denied_ts = mktime(0, 0, 0, date('n')-$purge_denied, date('j'), date('Y'));
			$denied_d8 = date('Y-m-d', $denied_ts);

			$qry = DB::select()
				->from('pages')
				->where('status', '=', 'denied')
				->where('status_date', '<', $denied_d8)
				->as_object()
				->execute();

			if ($qry->count())
			{
				foreach ($qry as $res)
				{
					$page_id = $res->id;
					$purge_ids[] = $page_id;
					// remove records from the media table based on the page id
					/*
					$query = DB::delete('media')
						->where('page_id', '=', $page_id)
						->execute();
					*/
				}
				// process now the deletion of the page
				// DB::delete('pages')
				// 	->where('status', '=', 'denied')
				// 	->where('status_date', '<', $denied_d8)
				// 	->execute();
			}
			// end purge denied

			$archive_ts = mktime(0, 0, 0, date('n')-$purge_archived, date('j'), date('Y'));
			$archive_d8 = date('Y-m-d', $archive_ts);

			$qry = DB::select()
				->from('pages')
				->where('status', '=', 'archived')
				->where('status_date', '<', $archive_d8)
				->as_object()
				->execute();

			if ($qry->count())
			{
				foreach ($qry as $res)
				{
					$page_id = $res->id;
					$purge_ids[] = $page_id;
					// remove records from the media table based on the page id
					/*
					$query = DB::delete('media')
						->where('page_id', '=', $page_id)
						->execute();
					*/
				}
				// process now the deletion of the page
				// DB::delete('pages')
				// 	->where('status', '=', 'archived')
				// 	->where('status_date', '<', $archive_d8)
				// 	->execute();
			}
			// end purge archived
			echo count($purge_ids);
			// Remove records in the media table together with the files associated to it (accross all load balance servers)
			if (count($purge_ids) > 0)
			{
				$str_purge_ids = implode(',', $purge_ids);

				$sql = DB::select()
					->from('media')
					->where('page_id', 'IN', DB::expr('('.$str_purge_ids.')'))
					->as_object()
					->execute();
				/*
				$directory = DOCROOT.'media/uploads';
				foreach ($sql as $res)
				{
					$file_name = $res->filename;
					if (is_file($directory.'/'.$file_name) AND file_exists($directory.'/'.$file_name))
					{
						@unlink($directory.'/'.$file_name);
					}
				}

				// remove records in the media table
				$query = DB::delete('media')
					->where('page_id', 'IN',  DB::expr('('.$str_purge_ids.')'))
					->execute();
				*/
			}
		}
	}

	public function action_test_purge()
	{
		// $lbsites = Kohana::$config->load('site')->get('lb_sites');

		$current_date = date('Y-m-d', time());

		$purge_ids = array();

		// get the purge setting
		$sql = DB::select('purge_draft', 'purge_denied', 'purge_archived')
			->from('setting')
			->as_object()
			->execute();

		if ($sql->count())
		{
			$p = $sql->current();
			$purge_draft = $p->purge_draft;
			$purge_denied = $p->purge_denied;
			$purge_archived = $p->purge_archived;

			$draft_ts = mktime(0, 0, 0, date('n')-$purge_draft, date('j'), date('Y'));
			$draft_d8 = date('Y-m-d', $draft_ts);
			//get pages where status is draft and status date is less than the computed purge date
			$qry = DB::select()
				->from('pages')
				->where('status', '=', 'draft')
				->where('status_date', '<', $draft_d8)
				->as_object()
				->execute();

			if ($qry->count())
			{
				foreach ($qry as $res)
				{
					$page_id = $res->id;
					$purge_ids[] = $page_id;
					// remove records from the media table based on the page id
					/*
					$query = DB::delete('media')
						->where('page_id', '=', $page_id)
						->execute();
					*/
				}
				// process now the deletion of the page
				DB::delete('pages')
					->where('status', '=', 'draft')
					->where('status_date', '<', $draft_d8)
					->execute();
			}
			// end purge draft

			$denied_ts = mktime(0, 0, 0, date('n')-$purge_denied, date('j'), date('Y'));
			$denied_d8 = date('Y-m-d', $denied_ts);

			$qry = DB::select()
				->from('pages')
				->where('status', '=', 'denied')
				->where('status_date', '<', $denied_d8)
				->as_object()
				->execute();

			if ($qry->count())
			{
				foreach ($qry as $res)
				{
					$page_id = $res->id;
					$purge_ids[] = $page_id;
					// remove records from the media table based on the page id
					/*
					$query = DB::delete('media')
						->where('page_id', '=', $page_id)
						->execute();
					*/
				}
				// process now the deletion of the page
				DB::delete('pages')
					->where('status', '=', 'denied')
					->where('status_date', '<', $denied_d8)
					->execute();
			}
			// end purge denied

			$archive_ts = mktime(0, 0, 0, date('n')-$purge_archived, date('j'), date('Y'));
			$archive_d8 = date('Y-m-d', $archive_ts);

			$qry = DB::select()
				->from('pages')
				->where('status', '=', 'archived')
				->where('status_date', '<', $archive_d8)
				->as_object()
				->execute();

			if ($qry->count())
			{
				foreach ($qry as $res)
				{
					$page_id = $res->id;
					$purge_ids[] = $page_id;
					// remove records from the media table based on the page id
					/*
					$query = DB::delete('media')
						->where('page_id', '=', $page_id)
						->execute();
					*/
				}
				// process now the deletion of the page
				DB::delete('pages')
					->where('status', '=', 'archived')
					->where('status_date', '<', $archive_d8)
					->execute();
			}
			// end purge archived

			// Remove records in the media table together with the files associated to it (accross all load balance servers)
			if (count($purge_ids) > 0)
			{
				$str_purge_ids = implode(',', $purge_ids);

				$sql = DB::select()
					->from('media')
					->where('page_id', 'IN', DB::expr('('.$str_purge_ids.')'))
					->as_object()
					->execute();

				$directory = DOCROOT.'media/uploads';
				foreach ($sql as $res)
				{
					$file_name = $res->filename;
					if (is_file($directory.'/'.$file_name) AND file_exists($directory.'/'.$file_name))
					{
						@unlink($directory.'/'.$file_name);
					}

					/*
					Enable this block of code for load balance server setup
					// start CURL Delete
					$post = array('file_name'=>$file_name);
					if (count($lbsites) > 0)
					{
						foreach($lbsites as $k => $site)
						{
							$target_url = $site.'/fileupload/file_remove';
							$ch = curl_init();
							curl_setopt($ch, CURLOPT_URL, $target_url);
							curl_setopt($ch, CURLOPT_POST, 1);
							curl_setopt($ch, CURLOPT_POSTFIELDS, $post);
							$result = curl_exec ($ch);

							curl_close ($ch);
						}
					}
					*/
				}

				// remove records in the media table
				$query = DB::delete('media')
					->where('page_id', 'IN',  DB::expr('('.$str_purge_ids.')'))
					->execute();
			}
		}
	}

	public function action_auto_archive()
	{
		$current_date = date('Y-m-d', time());
		$status_date = date('Ymd h:i:s A', time());

		//get pages where status is published and end date is less than the current date
		$qry = DB::select()
			->from('pages')
			->where('status', '=', 'published')
			->where('end_date', '<', $current_date)
			->execute();

		if ($qry->count())
		{
			DB::update('pages')
				->set(array('status'=>'archived', 'status_date'=>$status_date))
				->where('status', '=', 'published')
				->where('end_date', '<', $current_date)
				->execute();

			echo 'Finish Auto Archive';
		}

		echo "<br />Complete";
	}

	public function action_test_cron()
	{
		$current_date = date('Y-m-d', time());
		$status_date = date('Ymd h:i:s A', time());

		/** AUTO ARCHIVE **/
		//get pages where status is published and end date is less than the current date
		$qry = DB::select()
			->from('pages')
			->where('status', '=', 'published')
			->where('end_date', '<', $current_date)
			->execute();

		// echo Database::instance()->last_query;
		// exit;
		if ($qry->count())
		{
			/*
			DB::update('pages')
				->set(array('status'=>'archived', 'status_date'=>$status_date))
				->where('status', '=', 'published')
				->where('end_date', '<', $current_date)
				->execute();
			*/
			// echo 'Finish Auto Archive';
		}

		/*
		// Delete Create Copy articles that was not completed
		DB::delete('pages')
			->where('status', '=', 'create-new-copy')
			->where('control_no', 'IS', NULL)
			->execute();
		*/
		// Mark superseded page as Archived once the page superseding it becomes active
		$qry = DB::select()
			->from('pages')
			->where('status', '=', 'published')
			->where('start_date', '<=', $current_date)
			->where('control_no_supersede', 'IS NOT', NULL)
			->where('cron_status', 'IS', NULL)
			->as_object()
			->execute();

		foreach($qry as $res)
		{
			$page_id = $res->id;
			$copy_from = $res->copy_from;
			$control_no = $res->control_no;

			$p = ORM::factory('Page')
				->where('status', '=', 'published')
				->where('id', '=', $copy_from)
				->find();
			if ($p->loaded())
			{
				$p->status = 'archived';
				$p->status_date = date('Ymd h:i:s A', time());
				$p->save();
			}
			unset($p);

			// mark the record's cron_status to 'Y' which means it has been processed
			DB::update('pages')
				->set(array('cron_status'=>'Y'))
				->where('id', '=', $page_id)
				->execute();
		}
	}

	public function action_test_reminder()
	{
		// $current_date = date('Y-m-d', time());
		$current_date = '2014-05-30';

		$int_reminder = Kohana::$config->load('site')->get('email_reminder');

		$sql = ORM::factory('Page')
			->where(DB::expr("DATEADD(day, $int_reminder, end_date)"), '=', $current_date)
			->where('status', '=', 'published')
			->order_by('category_id')
			->find_all();

		$subject = 'EOL CMS pages expiring 1 month from now';
		$pages = '';
		$categ = 0;
		if ($sql->count())
		{
			foreach ($sql as $res)
			{
				$page_id = $res->id;
				$control_no = $res->control_no;
				$category_id = $res->category_id;
				$title = html_entity_decode($res->title);
				$content_type = Arr::get(MyHelper::content_types(), $res->content_type_id);

				if ($categ != $category_id AND $categ != 0)
				{
					if ($pages)
					{
						$message = 'Reminder!<p>Listed below are the EOL CMS pages that will expire in 1 month.</p>';
						$message .= '<table><tr><td>Control No.</td><td>Title</td><td>Content Type</td></tr>'.$pages.'</table>';
						$message .= '<p>This is an auto generated email.  Please do not reply.</p>';
					}

					if ($message)
					{
						// echo "<p>".$categ."<br />".$message."</p>";
						// send email to maker, checker, checker 2 that has access to the p
						Email::reminder(array(4, 5, 6), $categ, $subject, $message);
					}

					$pages = '';
				}

				$pages .= '<tr><td>'.$control_no.'</td><td>'.$title.'</td><td>'.$content_type.'</td></tr>';

				$categ = $category_id;
			}

			if ($pages)
			{
				$message = 'Reminder!<p>Listed below are the EOL CMS pages that will expire in 1 month.</p>';
				$message .= '<table><tr><td>Control No.</td><td>Title</td><td>Content Type</td></tr>'.$pages.'</table>';
				$message .= '<p>This is an auto generated email.  Please do not reply.</p>';
			}

			if ($message)
			{
				// echo "<p>".$category_id."<br />".$message."</p>";
				// send email to maker, checker, checker 2 that has access to the p
				Email::reminder(array(4, 5, 6), $category_id, $subject, $message);
			}
		}

		$int_reminder2 = Kohana::$config->load('site')->get('email_reminder2');

		$sql = ORM::factory('Page')
			->where(DB::expr("DATEADD(day, $int_reminder2, end_date)"), '=', $current_date)
			->where('status', '=', 'published')
			->order_by('category_id')
			->find_all();

		$subject = "Your EOL posting will expire in ".$int_reminder2." days";
		$pages = '';
		$categ = 0;
		if ($sql->count())
		{
			foreach ($sql as $res)
			{
				$page_id = $res->id;
				$control_no = $res->control_no;
				$category_id = $res->category_id;
				$title = html_entity_decode($res->title);
				$content_type = Arr::get(MyHelper::content_types(), $res->content_type_id);

				if ($categ != $category_id AND $categ != 0)
				{
					if ($pages)
					{
						$message = 'Reminder!<p>Listed below are the EOL CMS pages that will expire in '.$int_reminder2.' days.</p>';
						$message .= '<table><tr><td>Control No.</td><td>Title</td><td>Content Type</td></tr>'.$pages.'</table>';
						$message .= '<p>This is an auto generated email.  Please do not reply.</p>';
					}

					if ($message)
					{
						Email::reminder(array(4, 5, 6), $categ, $subject, $message);
					}

					$pages = '';
				}

				$pages .= '<tr><td>'.$control_no.'</td><td>'.$title.'</td><td>'.$content_type.'</td></tr>';

				$categ = $category_id;
			}

			if ($pages)
			{
				$message = 'Reminder!<p>Listed below are the EOL CMS pages that will expire in 1 month.</p>';
				$message .= '<table><tr><td>Control No.</td><td>Title</td><td>Content Type</td></tr>'.$pages.'</table>';
				$message .= '<p>This is an auto generated email.  Please do not reply.</p>';
			}

			if ($message)
			{
				Email::reminder(array(4, 5, 6), $category_id, $subject, $message);
			}
		}
	}
}