<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Forms extends Controller_Template {

	public $template = 'template/main_tpl';

	public function before()
	{
		parent::before();

		$this->template->splash_block = NULL;
	}

	public function action_ayala_plans()
	{
		$view = View::factory('template/forms_tpl');

		$view->title = "Pre-Need<br />Contact Us/Email Us";
		$view->header_image = URL::site('assets/images/ayalaplans.gif');
		$view->form_content = View::factory('forms/ayala_plans');
		$view->form_content->form_type = 'ayala_plans';

		$this->template->content = $view;
	}

	public function action_corporate_email_inquiry()
	{
		$view = View::factory('template/forms_tpl');

		$view->title = "Corporate Email Inquiry";
		$view->header_image = URL::site('assets/images/corporate_email.jpg');
		$view->form_content = View::factory('forms/corporate_email');
		$view->form_content->form_type = 'corporate_email';

		$this->template->content = $view;
	}

	public function action_cc_appointment()
	{
		$view = View::factory('template/forms_tpl');

		$arr_yn = array(''=>'-----', 'Y'=>'Yes', 'N'=>'No');

		$view->title = "Appointment Form";
		$view->header_image = URL::site('assets/images/cc_corporate.jpg');
		$view->form_content = View::factory('forms/cc_appointment');
		$view->form_content->form_type = 'cc_appointment';
		$view->form_content->arr_yn = $arr_yn;

		$this->template->content = $view;
	}

	public function action_remittance_form()
	{
		$view = View::factory('template/forms_tpl');

		$view->title = "Appointment Form";
		$view->header_image = URL::site('assets/images/remittance.gif');
		$view->form_content = View::factory('forms/remittance');
		$view->form_content->form_type = 'remittance';

		$this->template->content = $view;
	}

	public function action_sustainability_form()
	{
		$view = View::factory('template/forms_tpl');

		$arr_year[''] = '';
		for ($y = 2008; $y <= 2030; $y++)
		{
			$arr_year[$y] = $y;
		}
		$view->title = "BPI Sustainability Report<br />Feedback Form";
		$view->header_image = URL::site('assets/images/sustainability.jpg');
		$view->form_content = View::factory('forms/sustainability');
		$view->form_content->form_type = 'sustainability';
		$view->form_content->arr_year = $arr_year;

		$this->template->content = $view;
	}

	public function action_annual_report()
	{
		$view = View::factory('template/forms_tpl');

		$arr_year[''] = '';
		for ($y = 2008; $y <= 2030; $y++)
		{
			$arr_year[$y] = $y;
		}
		$view->title = "BPI Integrated Annual and Sustainability Report Feedback Form";
		$view->header_image = URL::site('assets/images/annualreportform.jpg');
		$view->form_content = View::factory('forms/annual_report');
		$view->form_content->form_type = 'annual_report';
		$view->form_content->arr_year = $arr_year;

		$this->template->content = $view;
	}

	public function action_bpi_philam()
	{
		$view = View::factory('template/forms_tpl');

		$view->title = "Contact Us/Email Us";
		$view->header_image = URL::site('assets/images/bpiphilaminsurance.jpg');
		$view->form_content = View::factory('forms/bpi_philam');
		$view->form_content->form_type = 'bpi_philam';

		$this->template->content = $view;
	}

	public function action_auto_insurance()
	{
		$view = View::factory('template/forms_tpl');

		$bpims_branch = array(
			'' => '--BPI MS Branch--',
			'Dagupan' => 'Dagupan',
			'Pampanga' => 'Pampanga',
			'Quezon City' => 'Quezon City',
			'Lipa' => 'Lipa',
			'Imus' => 'Imus',
			'Cebu' => 'Cebu',
			'Bacolod' => 'Bacolod',
			'Iloilo' => 'Iloilo',
			'CDO' => 'CDO',
			'Davao' => 'Davao',
			'Makati' => 'Makati'
		);

		$makesql = DB::select(DB::expr('DISTINCT(make)'))
			->from('car_matrix')
			->as_object()
			->execute();
		$arr_make[''] = '--Make--';
		foreach ($makesql as $res)
		{
			$arr_make[$res->make] = $res->make;
		}

		$view->title = "Automobile Insurance Request";
		$view->header_image = URL::site('assets/images/bpimsform.gif');
		$view->form_content = View::factory('forms/auto_insurance');
		$view->form_content->form_type = 'auto_insurance';
		$view->form_content->bpims_branch = $bpims_branch;
		$view->form_content->arr_make = $arr_make;

		$this->template->content = $view;
	}

	public function action_get_vehicle_model()
	{
		$this->auto_render = FALSE;

		if (HTTP_Request::POST == $this->request->method() AND $this->request->is_ajax())
		{
			$make = Arr::get($this->request->post(), 'make');

			$modelsql = DB::select()
				->from('car_matrix')
				->where('make', '=', $make)
				->as_object()
				->execute();
			$arr_model[''] = '--Model and Submodel--';
			foreach ($modelsql as $res)
			{
				$model = $res->model.' '.$res->submodel;
				$arr_model[$model] = $model;
			}

			echo json_encode($arr_model);
		}
	}

	public function action_send()
	{
		$this->auto_render = FALSE;

		if (HTTP_Request::POST == $this->request->method())
		{
			$token = Arr::get($this->request->post(), 'token');
			// check csrf
			if (Security::check($token))
			{
			}
		}
	}
}