<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Forms extends Controller_Template {

	public $template = 'template/main_tpl';

	public function before()
	{
		parent::before();

		$this->template->splash_block = NULL;
	}

	public function action_ayala_plans()
	{
		$view = View::factory('template/forms_tpl');

		$view->title = "Pre-Need<br />Contact Us/Email Us";
		$view->header_image = URL::site('assets/images/ayalaplans.gif');
		$view->form_content = View::factory('forms/ayala_plans');
		$view->form_content->form_type = 'ayala_plans';

		$this->template->content = $view;
	}

	public function action_corporate_email_inquiry()
	{
		$view = View::factory('template/forms_tpl');

		$view->title = "Corporate Email Inquiry";
		$view->header_image = URL::site('assets/images/corporate_email.jpg');
		$view->form_content = View::factory('forms/corporate_email');
		$view->form_content->form_type = 'corporate_email';

		$this->template->content = $view;
	}

	public function action_cc_appointment()
	{
		$view = View::factory('template/forms_tpl');

		$arr_yn = array(''=>'-----', 'Yes'=>'Yes', 'No'=>'No');

		$view->title = "Appointment Form";
		$view->header_image = URL::site('assets/images/cc_corporate.jpg');
		$view->form_content = View::factory('forms/cc_appointment');
		$view->form_content->form_type = 'cc_appointment';
		$view->form_content->arr_yn = $arr_yn;

		$this->template->content = $view;
	}

	public function action_remittance_form()
	{
		$view = View::factory('template/forms_tpl');

		$view->title = "Appointment Form";
		$view->header_image = URL::site('assets/images/remittance.gif');
		$view->form_content = View::factory('forms/remittance');
		$view->form_content->form_type = 'remittance';

		$this->template->content = $view;
	}

	public function action_sustainability_form()
	{
		$view = View::factory('template/forms_tpl');

		$arr_year[''] = '';
		for ($y = 2008; $y <= 2030; $y++)
		{
			$arr_year[$y] = $y;
		}
		$view->title = "BPI Sustainability Report<br />Feedback Form";
		$view->header_image = URL::site('assets/images/sustainability.jpg');
		$view->form_content = View::factory('forms/sustainability');
		$view->form_content->form_type = 'sustainability';
		$view->form_content->arr_year = $arr_year;

		$this->template->content = $view;
	}

	public function action_annual_report()
	{
		$view = View::factory('template/forms_tpl');

		$arr_year[''] = '';
		for ($y = 2008; $y <= 2030; $y++)
		{
			$arr_year[$y] = $y;
		}
		$view->title = "BPI Integrated Annual and Sustainability Report Feedback Form";
		$view->header_image = URL::site('assets/images/annualreportform.jpg');
		$view->form_content = View::factory('forms/annual_report');
		$view->form_content->form_type = 'annual_report';
		$view->form_content->arr_year = $arr_year;

		$this->template->content = $view;
	}

	public function action_bpi_philam()
	{
		$view = View::factory('template/forms_tpl');

		$view->title = "Contact Us/Email Us";
		$view->header_image = URL::site('assets/images/bpiphilaminsurance.jpg');
		$view->form_content = View::factory('forms/bpi_philam');
		$view->form_content->form_type = 'bpi_philam';

		$this->template->content = $view;
	}

	public function action_auto_insurance()
	{
		$view = View::factory('template/forms_tpl');

		$bpims_branch = array(
			'' => '--BPI MS Branch--',
			'Dagupan' => 'Dagupan',
			'Pampanga' => 'Pampanga',
			'Quezon City' => 'Quezon City',
			'Lipa' => 'Lipa',
			'Imus' => 'Imus',
			'Cebu' => 'Cebu',
			'Bacolod' => 'Bacolod',
			'Iloilo' => 'Iloilo',
			'CDO' => 'CDO',
			'Davao' => 'Davao',
			'Makati' => 'Makati'
		);

		$makesql = DB::select(DB::expr('DISTINCT(make)'))
			->from('car_matrix')
			->as_object()
			->execute();
		$arr_make[''] = '--Make--';
		foreach ($makesql as $res)
		{
			$arr_make[$res->make] = $res->make;
		}

		$view->title = "Automobile Insurance Request";
		$view->header_image = URL::site('assets/images/bpimsform.gif');
		$view->form_content = View::factory('forms/auto_insurance');
		$view->form_content->form_type = 'auto_insurance';
		$view->form_content->bpims_branch = $bpims_branch;
		$view->form_content->arr_make = $arr_make;

		$this->template->content = $view;
	}

	public function action_get_vehicle_model()
	{
		$this->auto_render = FALSE;

		if (HTTP_Request::POST == $this->request->method() AND $this->request->is_ajax())
		{
			$make = Arr::get($this->request->post(), 'make');

			$modelsql = DB::select()
				->from('car_matrix')
				->where('make', '=', $make)
				->as_object()
				->execute();
			$arr_model[''] = '--Model and Submodel--';
			foreach ($modelsql as $res)
			{
				$model = $res->model.' '.$res->submodel;
				$arr_model[$model] = $model;
			}

			echo json_encode($arr_model);
		}
	}

	public function action_send()
	{
		$this->auto_render = FALSE;

		if (HTTP_Request::POST == $this->request->method())
		{
			$token = Arr::get($this->request->post(), 'token');
			// check csrf
			if (Security::check($token))
			{
				$form_type = Arr::get($this->request->post(), 'form_type');

				$from_email = 'feedback@bpi.com.ph';
				$from_name = 'Feedback Form';
				switch ($form_type)
				{
					case 'ayala_plans':
						$subject = "Ayala Plans Form (Pre-need plans)";
						$body = "<table>
						<tr><td><strong>Last Name</strong></td><td>".Arr::get($this->request->post(), 'last_name')."</td></tr>
						<tr><td><strong>First Name</strong></td><td>".Arr::get($this->request->post(), 'first_name')."</td></tr>
						<tr><td><strong>Middle Initial</strong></td><td>".Arr::get($this->request->post(), 'middle_initial')."</td></tr>
						<tr><td><strong>Landline No.</strong></td><td>".Arr::get($this->request->post(), 'landline')."</td></tr>
						<tr><td><strong>Mobile Phone No.</strong></td><td>".Arr::get($this->request->post(), 'mobile')."</td></tr>
						<tr><td><strong>Email Address</strong></td><td>".Arr::get($this->request->post(), 'email')."</td></tr>
						<tr><td><strong>Plan Number</strong></td><td>".Arr::get($this->request->post(), 'plan_number')."</td></tr>
						<tr><td colspan=\"2\"><strong>Message</strong></td><tr>
						<tr><td colspan=\"2\"><strong>".Arr::get($this->request->post(), 'message')."</td></tr>
						</table>";
						break;
					case 'corporate_email':
						$subject = "Corporate Email Inquiry Form";
						$body = "<table>
						<tr><td><strong>Name</strong></td><td>".Arr::get($this->request->post(), 'name')."</td></tr>
						<tr><td><strong>Address</strong></td><td>".Arr::get($this->request->post(), 'address')."</td></tr>
						<tr><td><strong>Company Name</strong></td><td>".Arr::get($this->request->post(), 'company_name')."</td></tr>
						<tr><td><strong>Industry</strong></td><td>".Arr::get($this->request->post(), 'industry')."</td></tr>
						<tr><td><strong>E-mail Address</strong></td><td>".Arr::get($this->request->post(), 'email')."</td></tr>
						<tr><td><strong>Contact Tel. No.</strong></td><td>".Arr::get($this->request->post(), 'telno')."</td></tr>
						<tr><td><strong>Referred By</strong></td><td>".Arr::get($this->request->post(), 'referred_by')."</td></tr>
						<tr><td colspan=\"2\"><strong>I'm Interested in</strong></td><tr>
						<tr><td colspan=\"2\"><strong>".Arr::get($this->request->post(), 'interested_in')."</td></tr>
						</table>";
						break;
					case 'cc_appointment':
						$subject = "Corporate Cards Appointment Form";
						$body = "<table>
						<tr><td><strong>Name</strong></td><td>".Arr::get($this->request->post(), 'name')."</td></tr>
						<tr><td><strong>Address</strong></td><td>".Arr::get($this->request->post(), 'address')."</td></tr>
						<tr><td><strong>Company Name</strong></td><td>".Arr::get($this->request->post(), 'company_name')."</td></tr>
						<tr><td><strong>E-mail Address</strong></td><td>".Arr::get($this->request->post(), 'email')."</td></tr>
						<tr><td><strong>Contact Tel. No.</strong></td><td>".Arr::get($this->request->post(), 'telno')."</td></tr>
						<tr><td><strong>Remarks</strong></td><td>".Arr::get($this->request->post(), 'remarks')."</td></tr>
						<tr><td><strong>Is your company an existing Corporate Banking client?</strong></td><td>".Arr::get($this->request->post(), 'cb_client')."</td></tr>
						<tr><td><strong>If so, please specify your account officer</strong></td><td>".Arr::get($this->request->post(), 'account_officer')."</td></tr>
						<tr><td><strong>Does your company maintain a BPI Deposit Account?</strong></td><td>".Arr::get($this->request->post(), 'bpi_deposit_acct')."</td></tr>
						<tr><td><strong>If so, please specify your Branch</strong></td><td>".Arr::get($this->request->post(), 'branch')."</td></tr>
						</table>";
						break;
					case 'remittance':
						$subject = "Remittance Appointment Form";
						$body = "<table>
						<tr><td><strong>Inquiry on:</strong></td><td>".Arr::get($this->request->post(), 'inquiry')."</td></tr>
						<tr><td><strong>Name</strong></td><td>".Arr::get($this->request->post(), 'name')."</td></tr>
						<tr><td><strong>Address</strong></td><td>".Arr::get($this->request->post(), 'address')."</td></tr>
						<tr><td><strong>Company Name</strong></td><td>".Arr::get($this->request->post(), 'company_name')."</td></tr>
						<tr><td><strong>E-mail Address</strong></td><td>".Arr::get($this->request->post(), 'email')."</td></tr>
						<tr><td><strong>Contact Tel. No.</strong></td><td>".Arr::get($this->request->post(), 'telno')."</td></tr>
						<tr><td><strong>Referred By</strong></td><td>".Arr::get($this->request->post(), 'referred_by')."</td></tr>
						</table>";
						break;
					case 'sustainability':
						$stakeholder = Arr::get($this->request->post(), 'stakeholder');
						if (Arr::get($this->request->post(), 'stakeholder_other'))
						{
							$stakeholder[] = Arr::get($this->request->post(), 'stakeholder_other');
						}
						$stakeholder = implode(", ", $stakeholder);

						$obtain = Arr::get($this->request->post(), 'obtain');
						if (Arr::get($this->request->post(), 'obtain_other'))
						{
							$obtain[] = Arr::get($this->request->post(), 'obtain_other');
						}
						$obtain = implode(", ", $obtain);

						$most_interesting = Arr::get($this->request->post(), 'most_interesting');
						if (Arr::get($this->request->post(), 'most_interesting_other'))
						{
							$most_interesting[] = Arr::get($this->request->post(), 'most_interesting_other');
						}
						$most_interesting = implode(", ", $most_interesting);

						$subject = "Sustainability Report Feedback Form";
						$body = "<table>
						<tr><td><strong>Report year subject of this feedback form</strong></td><td>".Arr::get($this->request->post(), 'report_year')."</td></tr>
						<tr><td><strong>To which stakeholder group do you belong?</strong></td><td>".$stakeholder."</td></tr>
						<tr><td><strong>How did you obtain a copy of the BPI Sustainability Report?</strong></td><td>".$obtain."</td></tr>
						<tr><td><strong>What are your general comments about the report?</strong></td><td>
						<i>The report is well-structured and easy to understand:</i> ".Arr::get($this->request->post(), 'well_structured')."
						<i>The report is written in a reader-friendly way and is interesting to read:</i> ".Arr::get($this->request->post(), 'reader_friendly')."</td></tr>
						<tr><td><strong>What is your overall impression of the report?</strong></td><td>
						<i>Content and Scope:</i> ".Arr::get($this->request->post(), 'content_scope')."
						<i>Layout and Design:</i> ".Arr::get($this->request->post(), 'layout')."</td></tr>
						<tr><td><strong>Which part of the report did you find most interesting and helpful?</strong></td><td>".$most_interesting."</td></tr>
						<tr><td><strong>Did the report address the issue relevant to you?</strong></td><td>".Arr::get($this->request->post(), 'address_issue')."</td></tr>
						<tr><td><strong>Please indicate other issues which should be addressed and included in the next report.</strong></td><td>".Arr::get($this->request->post(), 'other_issues')."</td></tr>
						<tr><td><strong>Other comments and suggestions?</strong></td><td>".Arr::get($this->request->post(), 'comments')."</td></tr>
						<tr><td><strong>Last Name</strong></td><td>".Arr::get($this->request->post(), 'last_name')."</td></tr>
						<tr><td><strong>First Name</strong></td><td>".Arr::get($this->request->post(), 'first_name')."</td></tr>
						<tr><td><strong>Middle Name</strong></td><td>".Arr::get($this->request->post(), 'middle_name')."</td></tr>
						<tr><td><strong>Contact Nos.</strong></td><td>".Arr::get($this->request->post(), 'contact_nos')."</td></tr>
						<tr><td><strong>E-mail Address</strong></td><td>".Arr::get($this->request->post(), 'email')."</td></tr>
						</table>";
						break;
					case 'annual_report':
						$stakeholder = Arr::get($this->request->post(), 'stakeholder');
						if (Arr::get($this->request->post(), 'stakeholder_other'))
						{
							$stakeholder[] = Arr::get($this->request->post(), 'stakeholder_other');
						}
						$stakeholder = implode(", ", $stakeholder);

						$obtain = Arr::get($this->request->post(), 'obtain');
						if (Arr::get($this->request->post(), 'obtain_other'))
						{
							$obtain[] = Arr::get($this->request->post(), 'obtain_other');
						}
						$obtain = implode(", ", $obtain);

						$most_interesting = Arr::get($this->request->post(), 'most_interesting');
						if (Arr::get($this->request->post(), 'most_interesting_other'))
						{
							$most_interesting[] = Arr::get($this->request->post(), 'most_interesting_other');
						}
						$most_interesting = implode(", ", $most_interesting);

						$subject = "BPI Integrated Annual and Sustainability Report Feedback Form";
						$body = "<table>
						<tr><td><strong>Report year subject of this feedback form</strong></td><td>".Arr::get($this->request->post(), 'report_year')."</td></tr>
						<tr><td><strong>To which stakeholder group do you belong?</strong></td><td>".$stakeholder."</td></tr>
						<tr><td><strong>How did you obtain a copy of the BPI Sustainability Report?</strong></td><td>".$obtain."</td></tr>
						<tr><td><strong>What are your general comments about the report?</strong></td><td>
						<i>The report is well-structured and easy to understand:</i> ".Arr::get($this->request->post(), 'well_structured')."
						<i>The report is written in a reader-friendly way and is interesting to read:</i> ".Arr::get($this->request->post(), 'reader_friendly')."</td></tr>
						<tr><td><strong>What is your overall impression of the report?</strong></td><td>
						<i>Content and Scope:</i> ".Arr::get($this->request->post(), 'content_scope')."
						<i>Layout and Design:</i> ".Arr::get($this->request->post(), 'layout')."</td></tr>
						<tr><td><strong>Which part of the report did you find most interesting and helpful?</strong></td><td>".$most_interesting."</td></tr>
						<tr><td><strong>Did the report address the issue relevant to you?</strong></td><td>".Arr::get($this->request->post(), 'address_issue')."</td></tr>
						<tr><td><strong>Please indicate other issues which should be addressed and included in the next report.</strong></td><td>".Arr::get($this->request->post(), 'other_issues')."</td></tr>
						<tr><td><strong>Other comments and suggestions?</strong></td><td>".Arr::get($this->request->post(), 'comments')."</td></tr>
						<tr><td><strong>Last Name</strong></td><td>".Arr::get($this->request->post(), 'last_name')."</td></tr>
						<tr><td><strong>First Name</strong></td><td>".Arr::get($this->request->post(), 'first_name')."</td></tr>
						<tr><td><strong>Middle Name</strong></td><td>".Arr::get($this->request->post(), 'middle_name')."</td></tr>
						<tr><td><strong>Contact Nos.</strong></td><td>".Arr::get($this->request->post(), 'contact_nos')."</td></tr>
						<tr><td><strong>E-mail Address</strong></td><td>".Arr::get($this->request->post(), 'email')."</td></tr>
						</table>";
						break;
					case 'bpi_philam':
						$subject = "BPI Philam Contact Us/Email Us";
						$body = "<table>
						<tr><td><strong>Last Name</strong></td><td>".Arr::get($this->request->post(), 'last_name')."</td></tr>
						<tr><td><strong>First Name</strong></td><td>".Arr::get($this->request->post(), 'first_name')."</td></tr>
						<tr><td><strong>Middle Initial</strong></td><td>".Arr::get($this->request->post(), 'middle_initial')."</td></tr>
						<tr><td><strong>Landline No.</strong></td><td>".Arr::get($this->request->post(), 'landline')."</td></tr>
						<tr><td><strong>Mobile Phone No.</strong></td><td>".Arr::get($this->request->post(), 'mobile')."</td></tr>
						<tr><td><strong>Email Address</strong></td><td>".Arr::get($this->request->post(), 'email')."</td></tr>
						<tr><td><strong>Plan Number</strong></td><td>".Arr::get($this->request->post(), 'plan_number')."</td></tr>
						<tr><td colspan=\"2\"><strong>Message</strong></td><tr>
						<tr><td colspan=\"2\"><strong>".Arr::get($this->request->post(), 'message')."</td></tr>
						</table>";
						break;
					case 'auto_insurance':
						$subject = "Automobile Insurance Request";
						$body = "<table>
						<tr><td><strong>Are you an existing BPI/MS Client?<br />If yes, please indicate policy number.</strong></td><td>".Arr::get($this->request->post(), 'policy_number')."</td></tr>
						<tr><td><strong>Is your vehicle mortgaged?<br />If yes, please indicate your bank.</strong></td><td>".Arr::get($this->request->post(), 'bank_mortgage')."</td></tr>
						<tr><td colspan=\"2\"><strong>About Myself</strong></td></tr>
						<tr><td><strong>Title</strong></td><td>".Arr::get($this->request->post(), 'title')."</td></tr>
						<tr><td><strong>Last Name</strong></td><td>".Arr::get($this->request->post(), 'last_name')."</td></tr>
						<tr><td><strong>First Name</strong></td><td>".Arr::get($this->request->post(), 'first_name')."</td></tr>
						<tr><td><strong>Middle Name</strong></td><td>".Arr::get($this->request->post(), 'middle_name')."</td></tr>
						<tr><td><strong>T.I.N.</strong></td><td>".Arr::get($this->request->post(), 'tin')."</td></tr>
						<tr><td colspan=\"2\"><strong>My Contact Information</strong></td></tr>
						<tr><td><strong>Residence Address</strong></td><td>".Arr::get($this->request->post(), 'address')."</td></tr>
						<tr><td><strong>Residence Tel. No./s</strong></td><td>".Arr::get($this->request->post(), 'tel_no')."</td></tr>
						<tr><td><strong>Mobile No.</strong></td><td>".Arr::get($this->request->post(), 'mobile_no')."</td></tr>
						<tr><td><strong>E-mail Address</strong></td><td>".Arr::get($this->request->post(), 'email')."</td></tr>
						<tr><td colspan=\"2\"><strong>My Automobile Information</strong></td></tr>
						<tr><td><strong>Vehicle Make</strong></td><td>".Arr::get($this->request->post(), 'vehicle_make')."</td></tr>
						<tr><td><strong>Vehicle Model and Sub Model</strong></td><td>".Arr::get($this->request->post(), 'vehicle_model')."</td></tr>
						<tr><td><strong>Vehicle Year</strong></td><td>".Arr::get($this->request->post(), 'mobile_no')."</td></tr>
						<tr><td><strong>Vehicle Use</strong></td><td>".Arr::get($this->request->post(), 'vehicle_use')."</td></tr>
						<tr><td><strong>Plate No.</strong></td><td>".Arr::get($this->request->post(), 'plate_no')."</td></tr>
						<tr><td><strong>Chassis No.</strong></td><td>".Arr::get($this->request->post(), 'chassis_no')."</td></tr>
						<tr><td colspan=\"2\"><strong>My Referral Details</strong></td></tr>
						<tr><td><strong>Please indicate your referror</strong></td><td>".Arr::get($this->request->post(), 'referror')."</td></tr>
						<tr><td><strong>Employeed Name</strong></td><td>".Arr::get($this->request->post(), 'employee_name')."</td></tr>
						<tr><td><strong>Employee ID No.</strong></td><td>".Arr::get($this->request->post(), 'employee_id_no')."</td></tr>
						<tr><td><strong>Employee Mobile</strong></td><td>".Arr::get($this->request->post(), 'employee_mobile')."</td></tr>
						<tr><td><strong>Employee Email Address</strong></td><td>".Arr::get($this->request->post(), 'employee_email')."</td></tr>
						<tr><td colspan=\"2\"><strong>My Insurance Information</strong></td></tr>
						<tr><td><strong>Accomplished by</strong></td><td>".Arr::get($this->request->post(), 'accomplished_by')."</td></tr>
						<tr><td><strong>Relationship to Owner</strong></td><td>".Arr::get($this->request->post(), 'relationship_owner')."</td></tr>
						<tr><td><strong>Contact Nos.</strong></td><td>".Arr::get($this->request->post(), 'contact_nos')."</td></tr>
						<tr><td colspan=\"2\">&nbsp;</td></tr>
						<tr><td>Customer's RM Number</td><td>".Arr::get($this->request->post(), 'rm_number')."</td></tr>
						</table>";
						break;
				}

				$em = Email::feedback($subject, $body, $from_email, $from_name, $form_type);

				$session = Session::instance();
				$session->set('em', $em);
				$session->set('form_type', $form_type);

				$this->redirect('forms/submitted');
			}
		}
	}

	public function action_submitted()
	{
		$session = Session::instance();
		$em = $session->get_once('em');
		$form_type = $session->get_once('form_type');

		$view = View::factory('template/forms_tpl');
		$view->form_content = View::factory('forms/submitted');
		$view->form_content->em = $em;

		switch ($form_type)
		{
			case 'ayala_plans':
				$view->title = "Pre-Need<br />Contact Us/Email Us";
				$view->header_image = URL::site('assets/images/ayalaplans.gif');
				break;
			case 'corporate_email':
				$view->title = "Corporate Email Inquiry";
				$view->header_image = URL::site('assets/images/corporate_email.jpg');
				break;
			case 'cc_appointment':
				$view->title = "Appointment Form";
				$view->header_image = URL::site('assets/images/cc_corporate.jpg');
				break;
			case 'remittance':
				$view->title = "Appointment Form";
				$view->header_image = URL::site('assets/images/remittance.gif');
				break;
			case 'sustainability':
				$view->title = "BPI Sustainability Report<br />Feedback Form";
				$view->header_image = URL::site('assets/images/sustainability.jpg');
				break;
			case 'annual_report':
				$view->title = "BPI Integrated Annual and Sustainability Report Feedback Form";
				$view->header_image = URL::site('assets/images/annualreportform.jpg');
				break;
			case 'bpi_philam':
				$view->title = "Contact Us/Email Us";
				$view->header_image = URL::site('assets/images/bpiphilaminsurance.jpg');
				break;
			case 'auto_insurance':
				$view->title = "Automobile Insurance Request";
				$view->header_image = URL::site('assets/images/bpimsform.gif');
				break;
		}

		$this->template->content = $view;
	}
}