<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Home extends Controller_Template {

	public $template = 'template/front_tpl';

	public function before()
	{
		parent::before();

		$this->session = Session::instance();

		$this->template->splash_block = $this->splash_block();
	}

	public function action_index()
	{
		$menu_active = $this->session->get('menu_active');
		if ($menu_active != 'personal|menu_1_0' AND $menu_active != 'business|menu_4_0' AND $menu_active != 'filip|menu_5_0')
		{
			$this->session->delete('menu_active');
		}

		$this->session->delete('menu_active2');

		$current_date = date('Y-m-d', time());

		$segment_id = $this->session->get('segment');

		// default to personal on first load
		if ( ! isset($segment_id))
		{
			$segment_id = 1;
		}

		$sql = ORM::factory('Page')
			->where('content_type_id', '=', 2)
			->where('start_date', '<=', $current_date)
			->where('end_date', '>=', $current_date)
			->where_open()
			->where('status', '=', 'published')
			->or_where('status', '=', 'request-archive')
			->or_where('status', '=', 'pending-archive')
			->or_where('status', '=', 'check-archive')
			->or_where('status', '=', 'rework-archive')
			->where_close()
			->where(DB::expr('\',\'+').'segment_ids'.DB::expr('+\',\''), 'LIKE', "%,$segment_id,%")
			->order_by(DB::expr('NEWID()'));

		$page = $sql->find_all();

		$arr_main = array();
		$arr_thumb = array();
		foreach ($page as $res)
		{
			$link = '';
			if ($res->link1 AND $res->link1 != '#')
			{
				// $link = strstr($res->link1, 'http://') ? $res->link1 : 'http://'.$res->link1;
				$link = $res->link1;
			}
			$arr_main[] = array('link'=>$link, 'image'=>$res->image1);
			$arr_thumb[] = array('title'=>$res->title, 'thumbnail'=>$res->image2, 'link'=>$link);
		}

		// splash page violator
		$qry = ORM::factory('Page')
			->where('content_type_id', '=', 6)
			->where('start_date', '<=', $current_date)
			->where('end_date', '>=', $current_date)
			->where_open()
			->where('status', '=', 'published')
			->or_where('status', '=', 'request-archive')
			->or_where('status', '=', 'pending-archive')
			->or_where('status', '=', 'check-archive')
			->or_where('status', '=', 'rework-archive')
			->where_close()
			->find_all();

		$splash_page = '';
		if ($qry->count())
		{
			$splash_page = '<div id="notice" class="splash-page-violator" style="margin-bottom:3px; margin-top: 6px; margin-right:auto; margin-left: auto; width:950px; text-align:center; background-color: #333; font-weight:bold;color: #fff;font-size:11px;padding:5px;"><ul class="marquee">';

			foreach ($qry as $res)
			{
				$id = $res->id;
				$title = html_entity_decode($res->title);
				$body = html_entity_decode($res->body1);

				if ($body)
				{
					$splash_page .= '<li><div style="width:950px;"><a style="color:white" href="'.URL::site('cms/page/'.$id.'/'.URL::title($title)).'">'.$title.'</a></div></li>';
				} else {
					$splash_page .= '<li><div style="width:950px;">'.$title.'</div></li>';
				}
			}
			$splash_page .= '</ul></div>';
		}

		// get client updates
		$cu = ORM::factory('Page')
			->where('content_type_id', '=', 5)
			->where('start_date', '<=', $current_date)
			->where('end_date', '>=', $current_date)
			->where_open()
			->where('status', '=', 'published')
			->or_where('status', '=', 'request-archive')
			->or_where('status', '=', 'pending-archive')
			->or_where('status', '=', 'check-archive')
			->or_where('status', '=', 'rework-archive')
			->where_close()
			->where(DB::expr('\',\'+').'segment_ids'.DB::expr('+\',\''), 'LIKE', "%,$segment_id,%")
			->order_by(DB::expr('NEWID()'));

		$sql = $cu->find_all();

		$view = View::factory('homepage');
		$view->arr_main = $arr_main;
		$view->arr_thumb = $arr_thumb;
		$view->sql = $sql;
		$view->login_box = MyHelper::login_box($segment_id);

		$this->template->content = $view;
		if ($splash_page)
		{
			$this->template->splash_page = $splash_page;
		}
	}

	public function action_preview()
	{
		$this->auto_render = FALSE;

		$page_id = $this->request->param('id');

		$current_date = date('Y-m-d', time());

		$page = ORM::factory('Page')
			->where_open()
			->where('content_type_id', '=', 2)
			->where('start_date', '<=', $current_date)
			->where('end_date', '>=', $current_date)
			->where_open()
			->where('status', '=', 'published')
			->or_where('status', '=', 'request-archive')
			->or_where('status', '=', 'pending-archive')
			->where_close()
			->where_close()
			->or_where('id', '=', $page_id)
			->find_all();

		$arr_main = array();
		$arr_thumb = array();
		foreach ($page as $res)
		{
			$arr_main[] = array('link'=>$res->link1, 'image'=>$res->image1);
			$arr_thumb[] = array('title'=>$res->title, 'thumbnail'=>$res->image2);
		}

		$view = View::factory('homepage');
		$view->arr_main = $arr_main;
		$view->arr_thumb = $arr_thumb;

		$this->response->body($view);
	}

	public function action_client_updates()
	{
		$this->auto_render = FALSE;

		$current_date = date('Y-m-d', time());

		// get client updates
		$sql = ORM::factory('Page')
			->where('content_type_id', '=', 5)
			->where('start_date', '<=', $current_date)
			->where('end_date', '>=', $current_date)
			->where_open()
			->where('status', '=', 'published')
			->or_where('status', '=', 'request-archive')
			->or_where('status', '=', 'pending-archive')
			->or_where('status', '=', 'check-archive')
			->or_where('status', '=', 'rework-archive')
			->where_close()
			->order_by(DB::expr('NEWID()'))
			->limit(3)
			->find_all();

		$view = View::factory('client_updates');
		$view->sql = $sql;

		$this->response->body($view);
	}

	public function action_menu()
	{
		$this->session->delete('menu_active');
		$this->session->delete('menu_active2');

		$menu = $this->request->param('id');

		$this->session->set('navclass', $menu);

		switch ($menu)
		{
			case 'personal':
				$segment_id = 1;
				$this->session->set('menu_active', 'personal|menu_1_0');
				break;
			/*
			case 'preferred-banking':
				$segment_id = 2;
				break;
			case 'private-banking':
				$segment_id = 3;
				break;
			*/
			case 'business':
				$segment_id = 4;
				$this->session->set('menu_active', 'business|menu_4_0');
				break;
			case 'overseas-filipino':
				$segment_id = 5;
				$this->session->set('menu_active', 'filip|menu_5_0');
				break;
		}

		$this->session->set('segment', $segment_id);

		$this->redirect('/');
	}

	private function login_box($segment_id)
	{
		$view = View::factory('login_box');
		$view->segment_id = $segment_id;

		return $view;
	}

	private function splash_block()
	{
		$current_date = date('Y-m-d', time());

		$segment_id = $this->session->get('segment') ? $this->session->get('segment') : 1;

		$sql = ORM::factory('Page')
			->where('content_type_id', '=', 7)
			->where('segment_ids', '=', $segment_id)
			->where('start_date', '<=', $current_date)
			->where('end_date', '>=', $current_date)
			->where_open()
			->where('status', '=', 'published')
			->or_where('status', '=', 'request-archive')
			->or_where('status', '=', 'pending-archive')
			->or_where('status', '=', 'check-archive')
			->or_where('status', '=', 'rework-archive')
			->where_close()
			->find();

		if ($sql->loaded())
		{
			$view = View::factory('splash_block');

			$field_content = $sql->field_content ? json_decode($sql->field_content, true) : array();

			$view->title = $sql->title ? html_entity_decode($sql->title) : '';
			$view->intro_text = $sql->body1 ? html_entity_decode($sql->body1) : '';
			$view->featured_1_title = html_entity_decode(Arr::get($field_content, 'title1'));
			$view->featured_1_img = $sql->image1 ? URL::site('media/uploads/'.$sql->image1) : '';
			$view->featured_1_text = html_entity_decode($sql->body2);
			$view->featured_1_link = $sql->link1 ? $sql->link1 : '';
			$view->featured_2_title = html_entity_decode(Arr::get($field_content, 'title2'));
			$view->featured_2_img = $sql->image2 ? URL::site('media/uploads/'.$sql->image2) : '';
			$view->featured_2_text = html_entity_decode($sql->body3);
			$view->featured_2_link = $sql->link2 ? $sql->link2 : '';
			$view->featured_3_title = html_entity_decode(Arr::get($field_content, 'title3'));
			$view->featured_3_img = $sql->image3 ? URL::site('media/uploads/'.$sql->image3) : '';
			$view->featured_3_text = html_entity_decode($sql->body4);
			$view->featured_3_link = $sql->link3 ? $sql->link3 : '';
			$view->top_right_text = html_entity_decode(Arr::get($field_content, 'body6'));
			$view->bottom_right_text = html_entity_decode(Arr::get($field_content, 'body7'));

			if ($sql->meta_title)
			{
				$this->template->meta_title = html_entity_decode($sql->meta_title);
			}
			if ($sql->meta_description)
			{
				$this->template->meta_description = html_entity_decode($sql->meta_description);
			}
			if ($sql->meta_keyword)
			{
				$this->template->meta_keyword = html_entity_decode($sql->meta_keyword);
			}
		}
		else
		{
			$view = NULL;
		}

		return $view;
	}
}