<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Nav extends Controller {

	public function before()
	{
		parent::before();

		$this->toplinks = array(
			'related_sites' => 'Related Sites',
			'about_us' => 'About Us',
			'apply_now' => 'Apply Now',
			'promos' => 'Promos',
			'rates' => 'Rates',
			'locator' => 'Locator',
			'contact_us' => 'Contact Us',
			'product_services' => 'Product & Services',
			'market_watcher' => 'Market Watcher',
			'careers' => 'Careers',
			'security' => 'Security',
			'preferred_banking' => 'Preferred Banking',
			'private_banking' => 'Private Banking'
		);
	}

	public function action_top_links()
	{
		$label = $this->request->param('id');

		$sql = ORM::factory('TopLink')
			->where('label', '=', $label)
			->find_all();

		$view = '';
		if ($sql->count())
		{
			$c = $sql->current();
			if ($c->type == 'menu')
			// if ($sql->count() > 1)
			{
				$view .= '<li><a id="'.$label.'" class="menu-main" href="#">'.Arr::get($this->toplinks, $label).'</a><div class="menu-dropdown" id="'.$label.'-dropdown">';
				foreach ($sql as $res)
				{
					$view .= '<div><a href="'.html_entity_decode($res->menu_link).'">'.html_entity_decode($res->menu_label).'</a></div>';
				}
				$view .= '</div></li>';
			}
			else
			{
				$res = $sql->current();
				if ($label == 'preferred_banking' OR $label == 'private_banking')
				{
					$active = '';
					if ($label == Session::instance()->get('menu_active2'))
					{
						$active = ' current';
					}
					$view .= '<li><a href="'.html_entity_decode($res->page_link).'" id="'.$label.'" class="page-link'.$active.'">'.Arr::get($this->toplinks, $label).'</a></li>';
				}
				else
				{
					$view .= '<li><a href="'.html_entity_decode($res->page_link).'" id="'.$label.'" class="page-link">'.Arr::get($this->toplinks, $label).'</a></li>';
				}
			}
		}
		else
		{
			$view .= '<li><a href="#">'.Arr::get($this->toplinks, $label).'</a></li>';
		}

		$this->response->body($view);
	}

	public function action_bottom_links()
	{
		$label = $this->request->param('id');

		$sql = ORM::factory('TopLink')
			->where('label', '=', $label)
			->find_all();

		$view = '';
		if ($sql->count())
		{
			$c = $sql->current();
			if ($c->type == 'menu')
			// if ($sql->count() > 1)
			{
				$view .= '<a id="'.$label.'" class="menu-main" href="#">'.Arr::get($this->toplinks, $label).'</a><div class="menu-dropdown" id="'.$label.'-dropdown">';
				foreach ($sql as $res)
				{
					$view .= '<div><a href="'.html_entity_decode($res->menu_link).'">'.html_entity_decode($res->menu_label).'</a></div>';
				}
				$view .= '</div>';
			}
			else
			{
				$res = $sql->current();
				$view .= '<a href="'.html_entity_decode($res->page_link).'">'.Arr::get($this->toplinks, $label).'</a>';
			}
		}
		else
		{
			$view .= '<a href="#">'.Arr::get($this->toplinks, $label).'</a>';
		}

		$this->response->body($view);
	}

	public function action_set_active()
	{
		$this->auto_render = FALSE;

		if (HTTP_Request::POST == $this->request->method() AND $this->request->is_ajax())
		{
			$element = Arr::get($this->request->post(), 'element');

			$el = explode("|", $element);
			switch ($el[0])
			{
				case 'personal':
					$segment_id = 1;
					break;
				case 'business':
					$segment_id = 4;
					break;
				case 'overseas-filipino':
					$segment_id = 5;
					break;
			}
			Session::instance()->set('navclass', $el[0]);
			Session::instance()->set('segment', $segment_id);
			Session::instance()->delete('menu_active2');
			Session::instance()->set('menu_active', $element);
		}
	}

	public function action_set_active2()
	{
		$this->auto_render = FALSE;

		if (HTTP_Request::POST == $this->request->method() AND $this->request->is_ajax())
		{
			$element = Arr::get($this->request->post(), 'element');

			Session::instance()->delete('menu_active');
			Session::instance()->delete('navclass');
			Session::instance()->delete('segment');
			Session::instance()->set('menu_active2', $element);
		}
	}
}