<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Page extends Controller_Template {

	public $template = 'template/main_tpl';

	public function before()
	{
		parent::before();

		// $this->filesite = Kohana::$config->load('site')->get('dbserver');
		// $this->filepath = $this->filesite.'/media/uploads';
	}

	public function action_preview()
	{
		$control_no = $this->request->param('controlno');
		$blurb = $this->request->param('blurb');

		$current_date = date('Y-m-d', time());

		$sql = ORM::factory('Page')
			->where('control_no', '=', $control_no)
			->where('start_date', '<=', $current_date)
			->where('end_date', '>=', $current_date)
			->find();

		$return = FALSE;
		if ($sql->id)
		{
			// get the template used
			$tpl_id = $sql->template_id;

			if ($tpl_id)
			{
				// get the fields used for this template and the php filename associated with it
				$sections = array();
				$t = ORM::factory('Template', $tpl_id);
				if ($t->id)
				{
					$tpl_view = View::factory('templates/'.$t->file_name);

					$tpl_view->category_id = $sql->category_id;
					$tpl_view->sub_category1 = $sql->sub_category1;
					$tpl_view->sub_category2 = $sql->sub_category2;
					$tpl_view->sub_category3 = $sql->sub_category3;

					$sections = $t->sections ? json_decode($t->sections, true) : array();

					$docroot = DOCROOT.'media/uploads';
					foreach ($sections as $fieldname => $label)
					{
						$type =  MyHelper::field_type($fieldname);

						if (in_array($fieldname, MyHelper::regular_fields()))
						{
							$field_value = $sql->{$fieldname} ? html_entity_decode($sql->{$fieldname}) : '';
						}
						else
						{
							$field_value = array_key_exists($fieldname, $field_content) ? html_entity_decode(Arr::get($field_content, $fieldname)) : '';
						}

						if ($type == 'text' OR $type == 'textarea' OR $type == 'embed' )
						{
							$tpl_view->{$fieldname} = $field_value;
						}
						else if ($type == 'file_img')
						{
							if (is_file($docroot.'/'.$field_value) AND file_exists($docroot.'/'.$field_value))
							// if (MyHelper::check_file($this->filepath.'/'.$field_value))
							{
								// $tpl_view->{$fieldname} = $sql->{$fieldname} ? '<img src="'.URL::site('media/uploads/'.$sql->{$fieldname}).'" style="width:698px; height:148px;">' : '';
								$tpl_view->{$fieldname} = URL::site('media/uploads/'.$field_value);
								// $tpl_view->{$fieldname} = $this->filesite.'/media/uploads/'.$field_value;
							}
							else
							{
								$tpl_view->{$fieldname} = NULL;
							}

						}
						else if ($type == 'file_doc')
						{
							if (is_file($docroot.'/'.$field_value) AND file_exists($docroot.'/'.$field_value))
							// if (MyHelper::check_file($this->filepath.'/'.$field_value))
							{
								$t = substr($fieldname, 3, 1);
								$fieldlabel = 'doc_label'.$t;
								$tpl_view->{$fieldname} = $field_value ? '<a href="'.URL::site('media/uploads/'.$field_value, true).'">'.$sql->{$fieldlabel}.'</a>' : '';
								// $tpl_view->{$fieldname} = $field_value ? '<a href="'.$this->filesite.'/media/uploads/'.$field_value.'">'.$sql->{$fieldlabel}.'</a>' : '';
							}
							else
							{
								$tpl_view->{$fieldname} = NULL;
							}
						}
						else if ($type == 'link')
						{
							$tpl_view->{$fieldname} = $field_value ? '<a href="'.$field_value.'">'.$field_value.'</a>' : '';
						}
					}

					$return = TRUE;
				}
			}
		}

		if ($return == TRUE)
		{
			$this->template->content = $tpl_view;
		}
		else
		{
			throw HTTP_Exception::factory(404, 'URL not found!');
		}
	}

	public function action_contact_us()
	{
		// use Info Page template
		$view = View::factory('template/info_page');

		$view->tpl_header = 'Contact Us';
		$view->tpl_left_menu = View::factory('contact_us/left_menu');
		$view->tpl_ads = View::factory('contact_us/ads');
		$view->tpl_page_banner = View::factory('contact_us/page_banner');

		$view->tpl_content = View::factory('contact_us/content');

		$this->template->content = $view;
	}

	public function action_toll_free_number()
	{
		// use Info Page template
		$view = View::factory('template/info_page');

		$view->tpl_header = 'Contact Us';
		$view->tpl_left_menu = View::factory('contact_us/left_menu');
		$view->tpl_ads = View::factory('contact_us/ads');
		$view->tpl_page_banner = View::factory('contact_us/page_banner');

		$view->tpl_content = View::factory('contact_us/toll_free_number');

		$this->template->content = $view;
	}

	public function action_send_a_message()
	{
		// use Info Page template
		$view = View::factory('template/info_page');

		$view->tpl_header = 'Contact Us';
		$view->tpl_left_menu = View::factory('contact_us/left_menu');
		$view->tpl_ads = View::factory('contact_us/ads');
		$view->tpl_page_banner = View::factory('contact_us/page_banner');

		$arr_subjects = array(
			'Please Select',
			'Deposits' => 'Deposits',
			'Credit Cards' => 'Credit Cards',
			'Prepaid Cards' => 'Prepaid Cards',
			'Loans' => 'Loans',
			'Remittance' => 'Remittance',
			'Branch/Internet/Mobile/Phone Banking' => 'Branch/Internet/Mobile/Phone Banking',
			'Insurance' => 'Insurance',
			'Investment' => 'Investment'
		);

		$captcha = Captcha::instance();

		$view->tpl_content = View::factory('contact_us/send_a_message');
		$view->tpl_content->arr_subjects = $arr_subjects;
		$view->tpl_content->captcha = $captcha->render();

		$this->template->content = $view;
	}

	/**
	 * Based on the Subject selected, show/hide additional fields
	 * @return [type] [description]
	 */
	public function action_subject_form()
	{
		$this->auto_render = FALSE;

		if (HTTP_Request::POST == $this->request->method() AND $this->request->is_ajax())
		{
			$subject = Arr::get($this->request->post(), 'subject');

			switch ($subject)
			{
				case 'Deposits':
					$view = View::factory('contact_us/form/deposits');
					$arr_concerns = array(
						'Please Select',
						'Account Opening Inquiry' => 'Account Opening Inquiry',
						'ATM/Debit Cards/EPS' => 'ATM/Debit Cards/EPS',
						'Others' => 'Others'
					);
					$view->arr_concerns = $arr_concerns;
					break;
				case 'Credit Cards':
					$view = View::factory('contact_us/form/credit_cards');
					$arr_concerns = array(
						'Please Select',
						'Application Inquiry' => 'Application Inquiry',
						'Others' => 'Others'
					);
					$view->arr_concerns = $arr_concerns;
					break;
				case 'Prepaid Cards':
					$view = View::factory('contact_us/form/prepaid_cards');
					$arr_concerns = array(
						'Please Select',
						'Application Inquiry' => 'Application Inquiry',
						'Others' => 'Others'
					);
					$view->arr_concerns = $arr_concerns;
					break;
				case 'Loans':
					$view = View::factory('contact_us/form/loans');
					$arr_concerns = array(
						'Please Select',
						'Application Inquiry' => 'Application Inquiry',
						'Others' => 'Others'
					);
					$view->arr_concerns = $arr_concerns;
					break;
				case 'Remittance':
					$view = View::factory('contact_us/form/remittance');
					break;
				case 'Branch/Internet/Mobile/Phone Banking':
					$view = View::factory('contact_us/form/banking');
					$arr_concerns = array(
						'Please Select',
						'Internet Banking' => 'Internet Banking',
						'Mobile Banking' => 'Mobile Banking',
						'Phone Banking' => 'Phone Banking'
					);
					$view->arr_concerns = $arr_concerns;
					break;
			}

			$this->response->body($view);
		}
	}

	/**
	 * Display additional field when "subject" selected is Deposits and Concern is Account Opening Inquiry
	 * @return [type] [description]
	 */
	public function action_deposits_concern()
	{
		$this->auto_render = FALSE;

		$arr_fi = array(
			'Please Select',
			'BPI' => 'BPI',
			'BPI Family Savings Bank' => 'BPI Family Savings Bank',
			'BPI Direct' => 'BPI Direct'
		);

		$arr_account_type = array(
			'Please Select',
			'Savings' => 'Savings',
			'Checking' => 'Checking',
			'Time Deposit' => 'Time Deposit',
			'Others' => 'Others'
		);

		$view = View::factory('contact_us/form/deposits_sub');
		$view->arr_fi = $arr_fi;
		$view->arr_account_type = $arr_account_type;

		$this->response->body($view);
	}

	/**
	 * Display additional field when "subject" selected is Credit Cards
	 * @return [type] [description]
	 */
	public function action_credit_cards_concern()
	{
		$this->auto_render = FALSE;

		$arr_application_submit = array(
			'Please Select',
			'Branch' => 'Branch',
			'Express Online' => 'Express Online'
		);

		$arr_cc_type = array(
			'Please Select',
			'BPI Express Credit Classic' => 'BPI Express Credit Classic',
			'BPI Express Blue MC' => 'BPI Express Blue MC',
			'BPI Express Gold MC' => 'BPI Express Gold MC',
			'Petron BPI MC' => 'Petron BPI MC',
			'BPI Skymiles MC' => 'BPI Skymiles MC',
			'BPI Family Bank Credit Card' => 'BPI Family Bank Credit Card'
		);

		$view = View::factory('contact_us/form/credit_cards_sub');
		$view->arr_application_submit = $arr_application_submit;
		$view->arr_cc_type = $arr_cc_type;

		$this->response->body($view);
	}

	/**
	 * Display additional field when "subject" selected is Loans
	 * @return [type] [description]
	 */
	public function action_loans_concern()
	{
		$this->auto_render = FALSE;

		$arr_application_submit = array(
			'Please Select',
			'Branch' => 'Branch',
			'Online' => 'Online'
		);

		$arr_loan_type = array(
			'Please Select',
			'Auto Loan' => 'Auto Loan',
			'Housing Loan' => 'Housing Loan',
			'Personal Loan' => 'Personal Loan',
			'Ka-Negosyo Loan' => 'Ka-Negosyo Loan'
		);

		$view = View::factory('contact_us/form/loans_sub');
		$view->arr_application_submit = $arr_application_submit;
		$view->arr_loan_type = $arr_loan_type;

		$this->response->body($view);
	}

	/**
	 * Display additional field when "subject" selected is Prepaid Cards
	 * @return [type] [description]
	 */
	public function action_prepaid_cards_concern()
	{
		$this->auto_render = FALSE;

		$arr_application_submit = array(
			'Please Select',
			'Branch' => 'Branch',
			'Online' => 'Online',
			'Others' => 'Others'
		);

		$arr_prepaid_type = array(
			'Please Select',
			'Express Cash' => 'Express Cash',
			'Express Money Order' => 'Express Money Order',
			'My e-Prepaid MasterCard' => 'My e-Prepaid MasterCard'
		);

		$view = View::factory('contact_us/form/prepaid_cards_sub');
		$view->arr_application_submit = $arr_application_submit;
		$view->arr_prepaid_type = $arr_prepaid_type;

		$this->response->body($view);
	}

	/**
	 * Display additional field when "subject" selected is Internet/Phone/Mobile Banking
	 * @return [type] [description]
	 */
	public function action_banking_concern()
	{
		$this->auto_render = FALSE;

		$banking_type = $this->request->param('id');

		$arr_country = array(
			'Please Select',
		);

		$sql = ORM::factory('Country')
			->find_all();
		foreach ($sql as $c)
		{
			$arr_country[$c->id] = $c->name;
		}

		if ($banking_type == 'internet')
		{
			$view = View::factory('contact_us/form/banking_sub_internet');
			$view->arr_country = $arr_country;
		}
		else if ($banking_type == 'mobile')
		{
			$view = View::factory('contact_us/form/banking_sub_mobile');
		}

		$this->response->body($view);
	}

	public function action_submit_message()
	{
		$this->auto_render = FALSE;

		if (HTTP_Request::POST == $this->request->method())
		{
			$captcha = Arr::get($this->request->post(), 'captcha');
			$token = Arr::get($this->request->post(), 'token');

			if (Captcha::valid($captcha) AND Security::check($token))
			{
				$subject = HTML::chars(Arr::get($this->request->post(), 'subject'));
				$title = HTML::chars(Arr::get($this->request->post(), 'title'));
				$first_name = HTML::chars(Arr::get($this->request->post(), 'first_name'));
				$middle_name = HTML::chars(Arr::get($this->request->post(), 'middle_name'));
				$last_name = HTML::chars(Arr::get($this->request->post(), 'last_name'));
				$email_address = HTML::chars(Arr::get($this->request->post(), 'email_address'));
				$phone = HTML::chars(Arr::get($this->request->post(), 'phone'));
				$message = HTML::chars(Arr::get($this->request->post(), 'message'));

				// based on the selected subject, get fields related to it
				switch ($subject)
				{
					case 'Deposits':
						$concern = HTML::chars(Arr::get($this->request->post(), 'concern'));
						$financial_institution = HTML::chars(Arr::get($this->request->post(), 'financial_institution'));
						$account_type = HTML::chars(Arr::get($this->request->post(), 'account_type'));

						$content = View::factory('contact_us/form/email/deposits');
						$content->concern = $concern;
						$content->financial_institution = $financial_institution;
						$content->account_type = $account_type;

						break;
					case 'Credit Cards':
						$concern = HTML::chars(Arr::get($this->request->post(), 'concern'));
						$birthdate = HTML::chars(Arr::get($this->request->post(), 'birthdate'));
						$application_date = HTML::chars(Arr::get($this->request->post(), 'application_date'));
						$application_submitted = HTML::chars(Arr::get($this->request->post(), 'application_submitted'));
						$branch_location = HTML::chars(Arr::get($this->request->post(), 'branch_location'));
						$application_reference_no = HTML::chars(Arr::get($this->request->post(), 'application_reference_no'));
						$credit_card_type = HTML::chars(Arr::get($this->request->post(), 'credit_card_type'));

						$content = View::factory('contact_us/form/email/credit_cards');
						$content->concern = $concern;
						$content->birthdate = $birthdate;
						$content->application_date = $application_date;
						$content->application_submitted = $application_submitted;
						$content->branch_location = $branch_location;
						$content->application_reference_no = $application_reference_no;
						$content->credit_card_type = $credit_card_type;

						break;
					case 'Prepaid Cards':
						$concern = HTML::chars(Arr::get($this->request->post(), 'concern'));
						$application_date = HTML::chars(Arr::get($this->request->post(), 'application_date'));
						$application_submitted = HTML::chars(Arr::get($this->request->post(), 'application_submitted'));
						$branch_location = HTML::chars(Arr::get($this->request->post(), 'branch_location'));
						$application_reference_no = HTML::chars(Arr::get($this->request->post(), 'application_reference_no'));
						$application_others = HTML::chars(Arr::get($this->request->post(), 'application_others'));
						$prepaid_card_type = HTML::chars(Arr::get($this->request->post(), 'prepaid_card_type'));

						$content = View::factory('contact_us/form/email/prepaid_cards');
						$content->concern = $concern;
						$content->application_date = $application_date;
						$content->application_submitted = $application_submitted;
						$content->branch_location = $branch_location;
						$content->application_reference_no = $application_reference_no;
						$content->application_others = $application_others;
						$content->prepaid_card_type = $prepaid_card_type;

						break;
					case 'Loans':
						$concern = HTML::chars(Arr::get($this->request->post(), 'concern'));
						$application_date = HTML::chars(Arr::get($this->request->post(), 'application_date'));
						$application_submitted = HTML::chars(Arr::get($this->request->post(), 'application_submitted'));
						$branch_location = HTML::chars(Arr::get($this->request->post(), 'branch_location'));
						$application_reference_no = HTML::chars(Arr::get($this->request->post(), 'application_reference_no'));
						$loan_type = HTML::chars(Arr::get($this->request->post(), 'loan_type'));

						$content = View::factory('contact_us/form/email/loans');
						$content->concern = $concern;
						$content->application_date = $application_date;
						$content->application_submitted = $application_submitted;
						$content->branch_location = $branch_location;
						$content->application_reference_no = $application_reference_no;
						$content->loan_type = $loan_type;

						break;
					case 'Remittance':
						$concern = 'Remittance';
						$sending_date = HTML::chars(Arr::get($this->request->post(), 'sending_date'));
						$remittance_amt = HTML::chars(Arr::get($this->request->post(), 'remittance_amt'));
						$originating_country = HTML::chars(Arr::get($this->request->post(), 'originating_country'));
						$sending_bank = HTML::chars(Arr::get($this->request->post(), 'sending_bank'));

						$content = View::factory('contact_us/form/email/remittance');
						$content->concern = $concern;
						$content->remittance_amt = $remittance_amt;
						$content->originating_country = $originating_country;
						$content->sending_bank = $sending_bank;

						break;
					case 'Branch/Internet/Mobile/Phone Banking':
						$concern = HTML::chars(Arr::get($this->request->post(), 'concern'));
						$country = HTML::chars(Arr::get($this->request->post(), 'country'));
						$registered_email = HTML::chars(Arr::get($this->request->post(), 'registered_email'));
						$browser_type = HTML::chars(Arr::get($this->request->post(), 'browser_type'));
						$isp = HTML::chars(Arr::get($this->request->post(), 'isp'));
						$access_date = HTML::chars(Arr::get($this->request->post(), 'access_date'));
						$access_time = HTML::chars(Arr::get($this->request->post(), 'access_time'));
						$location = HTML::chars(Arr::get($this->request->post(), 'location'));

						$mobile_no = HTML::chars(Arr::get($this->request->post(), 'mobile_no'));
						$mobile_os = HTML::chars(Arr::get($this->request->post(), 'mobile_os'));
						$phone_model = HTML::chars(Arr::get($this->request->post(), 'phone_model'));
						$mobile_network = HTML::chars(Arr::get($this->request->post(), 'mobile_network'));

						$content = View::factory('contact_us/form/email/banking');
						$content->concern = $concern;
						$content->country = $country;
						$content->registered_email = $registered_email;
						$content->browser_type = $browser_type;
						$content->isp = $isp;
						$content->access_date = $access_date;
						$content->access_time = $access_time;
						$content->location = $location;

						$content->mobile_no = $mobile_no;
						$content->mobile_os = $mobile_os;
						$content->phone_model = $phone_model;
						$content->mobile_network = $mobile_network;

						break;
				}

				$view = View::factory('contact_us/form/email/content');
				$view->name = $title.' '.$first_name.' '.$middle_name.' '.$last_name;
				$view->email_address = $email_address;
				$view->phone = $phone;
				$view->content = $content;
				$view->subject = $subject;
				$view->concern = $concern;
				$view->message = $message;

				// process the data here and send email
				$email_subject = 'PRE - '.$subject.' - '.$concern;
				$send = Email::contact_us($email_subject, $view, $email_address, $first_name.' '.$middle_name.' '.$last_name);

				if ($send)
				{
					$this->redirect('message-sent');
				}
				else
				{
					$this->redirect('message-not-sent');
				}
			}
		}
	}

	public function action_message_sent()
	{
		// use Info Page template
		$view = View::factory('template/info_page');

		$view->tpl_header = 'Contact Us';
		$view->tpl_left_menu = View::factory('contact_us/left_menu');
		$view->tpl_ads = View::factory('contact_us/ads');
		$view->tpl_page_banner = View::factory('contact_us/page_banner');

		$view->tpl_content = "<h4>Thank you for your inquiry.<br /><br />We will respond to you as soon as we have evaluated your request.</h4>";

		$this->template->content = $view;
	}

	public function action_message_not_sent()
	{
		// use Info Page template
		$view = View::factory('template/info_page');

		$view->tpl_header = 'Contact Us';
		$view->tpl_left_menu = View::factory('contact_us/left_menu');
		$view->tpl_ads = View::factory('contact_us/ads');
		$view->tpl_page_banner = View::factory('contact_us/page_banner');

		$view->tpl_content = "<h4>Unfortunately your email was not sent due to an error.<br /><br />Please try again by click <a href=\"".URL::site('send-a-message')."\">here.</a></h4>";

		$this->template->content = $view;
	}

	public function action_client_update()
	{
		$page_id = $this->request->param('id');

		$page = ORM::factory('Page', $page_id);
		$tpl_id = $page->template_id;
		if ($tpl_id)
		{
			$t = ORM::factory('Template', $tpl_id);
			if ($t->id)
			{
				$view = View::factory('templates/'.$t->file_name);
				$view->title = html_entity_decode($page->title);
				$view->body1 = html_entity_decode($page->body1);
			}
		} else {
			$view = View::factory('page/client_update');
			$view->title = html_entity_decode($page->title);
			$view->body1 = html_entity_decode($page->body1);
		}

		$this->template->content = $view;
	}

	public function action_splash_page()
	{
		$page_id = $this->request->param('id');

		$page = ORM::factory('Page', $page_id);
		$tpl_id = $page->template_id;
		if ($tpl_id)
		{
			$t = ORM::factory('Template', $tpl_id);
			if ($t->id)
			{
				$view = View::factory('templates/'.$t->file_name);
				$view->title = html_entity_decode($page->title);
				$view->body1 = html_entity_decode($page->body1);
			}
		} else {
			$view = View::factory('page/client_update');
			$view->title = html_entity_decode($page->title);
			$view->body1 = html_entity_decode($page->body1);
		}

		$this->template->content = $view;
	}

	/**
	 * List of all client updates page
	 * @return [type] [description]
	 */
	public function action_client_updates()
	{
		$current_date = date('Y-m-d', time());

		$sql = ORM::factory('Page')
			->where('content_type_id', '=', 5)
			->where('start_date', '<=', $current_date)
			->where('end_date', '>=', $current_date)
			->where_open()
			->where('status', '=', 'published')
			->or_where('status', '=', 'request-archive')
			->or_where('status', '=', 'pending-archive')
			->or_where('status', '=', 'check-archive')
			->or_where('status', '=', 'rework-archive')
			->where_close();
		if (Session::instance()->get('segment_id'))
		{
			$segment_id = Session::instance()->get('segment_id');
			$sql->where(DB::expr('\',\'+').'segment_ids'.DB::expr('+\',\''), 'LIKE', "%,$segment_id,%");
		}

		$cu_sql = $sql->order_by('id', 'DESC')
			->find_all();

		$this->template->content = View::factory('page/client_updates');
		$this->template->content->cu_sql = $cu_sql;
	}


	public function action_search()
	{
		$this->auto_render = FALSE;

		if (HTTP_Request::POST == $this->request->method())
		{
			$search = HTML::chars(Arr::get($this->request->post(), 'search'));

			Session::instance()->set('search_keyword', trim($search));

			$this->redirect('page/search_result');
		}
	}

	public function action_search_result()
	{
		if (Session::instance()->get('search_keyword'))
		{
			$arr_s = explode(" ", Session::instance()->get('search_keyword'));

			$current_date = date('Y-m-d', time());

			$sql = ORM::factory('Page')
				->where_open()
				->where('content_type_id', '=', 1)
				->or_where('content_type_id', '>=', 4)
				->where_close()
				->where('start_date', '<=', $current_date)
				->where('end_date', '>=', $current_date)
				->where_open()
				->where('status', '=', 'published')
				->or_where('status', '=', 'request-archive')
				->or_where('status', '=', 'pending-archive')
				->or_where('status', '=', 'check-archive')
				->or_where('status', '=', 'rework-archive')
				->where_close()
				->where_open()
				->where_open();
			foreach ($arr_s as $k => $keyword)
			{
				$wildcard_search = str_replace('.', '%.%', $keyword);

				$sql->where('title', 'LIKE', "%".$wildcard_search."%");
			}
			$sql->where_close()
				->or_where_open();
			foreach ($arr_s as $k => $keyword)
			{
				$wildcard_search = str_replace('.', '%.%', $keyword);

				$sql->where('body1', 'LIKE', "%".$wildcard_search."%");
			}
			$sql->where_close()
				->or_where_open();
			foreach ($arr_s as $k => $keyword)
			{
				$wildcard_search = str_replace('.', '%.%', $keyword);

				$sql->where('body2', 'LIKE', "%".$wildcard_search."%");
			}
			foreach ($arr_s as $k => $keyword)
			{
				$wildcard_search = str_replace('.', '%.%', $keyword);

				$sql->where('body3', 'LIKE', "%".$wildcard_search."%");
			}
			$sql->where_close()
				->or_where_open();
			foreach ($arr_s as $k => $keyword)
			{
				$wildcard_search = str_replace('.', '%.%', $keyword);

				$sql->where('body4', 'LIKE', "%".$wildcard_search."%");
			}
			$sql->where_close()
				->or_where_open();
			foreach ($arr_s as $k => $keyword)
			{
				$wildcard_search = str_replace('.', '%.%', $keyword);

				$sql->where('body5', 'LIKE', "%".$wildcard_search."%");
			}

			$sql->where_close()
				->where_close();

			$page_query = clone $sql;
			$query = $page_query->find_all();
			$count = $query->count();
			// echo Database::instance()->last_query;
			$pagination = Pagination::factory(array(
			    'total_items'    => $count,
			    'view'           => 'pagination/floating',
			    'items_per_page' => 20
			));

			$page_links = $pagination->render();

			$sql->limit($pagination->items_per_page)
			    ->offset($pagination->offset);

			$qry = $sql->order_by('status_date', 'DESC')->find_all();

			// echo Database::instance()->last_query;
			// exit;
			$this->template->content = View::factory('page/search_result');
			$this->template->content->sql = $qry;
			$this->template->content->pagination = $page_links;
			$this->template->content->result_count = $count;
		}
		else
		{
			throw HTTP_Exception::factory(404, 'URL not found!');
		}
	}

	public function action_troubleshooting()
	{
		$view = View::factory('template/info_page');

		$view->tpl_header = 'Contact Us';
		$view->tpl_left_menu = View::factory('contact_us/left_menu');
		$view->tpl_ads = View::factory('contact_us/ads');
		$view->tpl_page_banner = View::factory('contact_us/page_banner');

		$view->tpl_content = '<h4>Troubleshooting Page</h4>';

		$this->template->content = $view;
	}
}