<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Preview extends Controller_Template {

	public $template = 'template/main_tpl';

	public function before()
	{
		parent::before();
	}

	/**
	 * Preview feature when creating new CMS (Page is still being created. User clicked the Preview Button)
	 * @return [type] [description]
	 */
	public function action_new_page()
	{
		if (HTTP_Request::POST == $this->request->method())
		{
			$content_type_id = Arr::get($this->request->post(), 'content_type');
			$category_id = Arr::get($this->request->post(), 'category');
			$sub_category1 = Arr::get($this->request->post(), 'sub_category1');
			$sub_category2 = Arr::get($this->request->post(), 'sub_category2');
			$sub_category3 = Arr::get($this->request->post(), 'sub_category3');

			$page_id = Arr::get($this->request->post(), 'id');

			$this->template->print = TRUE;

			$directory = DOCROOT.'media/preview';
			$data = new stdClass();

			$field_label = array();
			$field_content = array();
			switch ($content_type_id)
			{
				case 2: // Splash Banner
					$user_segments = Session::instance()->get('user_segment_ids');

					$data->title = HTML::chars(Arr::get($this->request->post(), 'title'));
					$data->link1 = HTML::chars(Arr::get($this->request->post(), 'link1'));

					if (Arr::get($this->request->post(), 'file_image1'))
					{
						$data->image1 = HTML::chars(Arr::get($this->request->post(), 'file_image1'));
					}
					else if (Arr::get($this->request->post(), 'image1_hid'))
					{
						$data->image1 = HTML::chars(Arr::get($this->request->post(), 'image1_hid'));
					}

					if (Arr::get($this->request->post(), 'file_image2'))
					{
						$data->image2 = HTML::chars(Arr::get($this->request->post(), 'file_image2'));
					}
					else if (Arr::get($this->request->post(), 'image2_hid'))
					{
						$data->image2 = HTML::chars(Arr::get($this->request->post(), 'image2_hid'));
					}
					break;
				case 3: // Ad Banner
					$template_id = Arr::get($this->request->post(), 'template_id');

					$data->title = HTML::chars(Arr::get($this->request->post(), 'title'));
					$data->link1 = HTML::chars(Arr::get($this->request->post(), 'link1'));
					if (Arr::get($this->request->post(), 'file_image1'))
					{
						$data->image1 = HTML::chars(Arr::get($this->request->post(), 'file_image1'));
					}
					else if (Arr::get($this->request->post(), 'image1_hid'))
					{
						$data->image1 = HTML::chars(Arr::get($this->request->post(), 'image1_hid'));
					}
					break;
				case 4: // Promo
					$template_id = Arr::get($this->request->post(), 'template_id');

					$mechanics_click = Arr::get($this->request->post(), 'mechanics_click');

					if (Arr::get($this->request->post(), 'file_image5'))
					{
						$data->image5 = HTML::chars(Arr::get($this->request->post(), 'file_image5'));
					}
					else if (Arr::get($this->request->post(), 'image5_hid'))
					{
						$data->image5 = HTML::chars(Arr::get($this->request->post(), 'image5_hid'));
					}

					$data->product_category = Arr::get($this->request->post(), 'product_category');

					$data->title = HTML::chars(Arr::get($this->request->post(), 'title'));
					// promo description
					$data->body4 = HTML::chars(Arr::get($this->request->post(), 'body4'));

					if ($mechanics_click == 'thumbnail-link')
					{
						// promo mechanics link
						$data->link5 = HTML::chars(Arr::get($this->request->post(), 'link5'));
					}
					else
					{
						// user selected mechanics link
						$data->link5 = NULL;

						$tpl = ORM::factory('Template', $template_id);
						$tpl_sections = $tpl->sections ? json_decode($tpl->sections, true) : array();

						foreach ($tpl_sections as $section => $label)
						{
							if (strstr($section, 'image'))
							{
								$regular_fields = array('image1', 'image2', 'image3', 'image4', 'image5');

								if (Arr::get($this->request->post(), 'file_'.$section))
								{
									$fname = HTML::chars(Arr::get($this->request->post(), 'file_'.$section));

									if (in_array($section, $regular_fields))
									{
										$data->$section = $fname;
									}
									else
									{
										$field_label[$section] = $label;
										$field_content[$section] = $fname;
									}
								}
							}
							else if (strstr($section, 'doc'))
							{
								$regular_fields = array('doc1', 'doc2', 'doc3', 'doc4', 'doc5');

								if (Arr::get($this->request->post(), 'file_'.$section))
								{
									$fname = HTML::chars(Arr::get($this->request->post(), 'file_'.$section));
									// Doc Link Label
									$t = substr($section, 3, 1);
									$fieldlabel = 'doc_label'.$t;
									$filedoc_data = HTML::chars(Arr::get($this->request->post(), $fieldlabel));

									if (in_array($section, $regular_fields))
									{
										$data->$section = $fname;
										$data->$fieldlabel = $filedoc_data;
									}
									else
									{
										$field_label[$section] = $label;
										$field_content[$section] = $fname;
										$field_label[$fieldlabel] = 'File Download Name';
										$field_content[$fieldlabel] = $filedoc_data;
									}
								}
							}
							else
							{
								$regular_fields = array('title', 'body1', 'body2', 'body3', 'body4', 'body5', 'link1', 'link2', 'link3', 'link4', 'link5', 'embed1', 'embed2', 'embed3', 'embed4', 'embed5');

								$fname = HTML::chars(Arr::get($this->request->post(), $section));

								if (in_array($section, $regular_fields))
								{
									$data->$section = $fname;
								}
								else
								{
									$field_label[$section] = $label;
									$field_content[$section] = $fname;
								}
							}
						}

						$data->field_label = count($field_label) > 0 ? json_encode($field_label) : NULL;
						$data->field_content = count($field_content) > 0 ? json_encode($field_content) : NULL;
					}

					$data->start_date = HTML::chars(Arr::get($this->request->post(), 'startdate'));
					$data->meta_title = HTML::chars(Arr::get($this->request->post(), 'meta_title'));
					$data->meta_description = HTML::chars(Arr::get($this->request->post(), 'meta_description'));
					$data->meta_keyword = HTML::chars(Arr::get($this->request->post(), 'meta_keyword'));

					break;
				case 7: // Splash Block
					$data->segment_ids = Arr::get($this->request->post(), 'segment_view');
					$data->title = HTML::chars(Arr::get($this->request->post(), 'title'));
					$data->body1 = HTML::chars(Arr::get($this->request->post(), 'body1'));

					// Featured 1 block
					$field_label['title1'] = 'Featured 1 Text';
					$field_content['title1'] = HTML::chars(Arr::get($this->request->post(), 'title1'));
					$data->link1 = HTML::chars(Arr::get($this->request->post(), 'link1'));
					if (Arr::get($this->request->post(), 'file_image1'))
					{
						$image1 = HTML::chars(Arr::get($this->request->post(), 'file_image1'));
						$data->image1 = $image1;
					}
					$data->body2 = HTML::chars(Arr::get($this->request->post(), 'body2'));

					// Featured 2 block
					$field_label['title2'] = 'Featured 2 Text';
					$field_content['title2'] = HTML::chars(Arr::get($this->request->post(), 'title2'));
					$data->link2 = HTML::chars(Arr::get($this->request->post(), 'link2'));
					if (Arr::get($this->request->post(), 'file_image2'))
					{
						$image2 = HTML::chars(Arr::get($this->request->post(), 'file_image2'));
						$data->image2 = $image2;
					}
					$data->body3 = HTML::chars(Arr::get($this->request->post(), 'body3'));

					// Featured 3 block
					$field_label['title3'] = 'Featured 3 Text';
					$field_content['title3'] = HTML::chars(Arr::get($this->request->post(), 'title3'));
					$data->link3 = HTML::chars(Arr::get($this->request->post(), 'link3'));
					if (Arr::get($this->request->post(), 'file_image3'))
					{
						$image3 = HTML::chars(Arr::get($this->request->post(), 'file_image3'));
						$data->image3 = $image3;
					}
					$data->body4 = HTML::chars(Arr::get($this->request->post(), 'body4'));

					$field_label['body6'] = 'Top Right Text';
					$field_content['body6'] = HTML::chars(Arr::get($this->request->post(), 'body6'));

					$field_label['body7'] = 'Bottom Right Text';
					$field_content['body7'] = HTML::chars(Arr::get($this->request->post(), 'body7'));

					$data->field_label = count($field_label) > 0 ? json_encode($field_label) : NULL;
					$data->field_content = count($field_content) > 0 ? json_encode($field_content) : NULL;

					break;
				default: // Client Update, Splash Page Violator, Info Page and new Info Page Content Type
					$template_id = Arr::get($this->request->post(), 'template_id');

					// Record the fields used for the Template
					$tpl = ORM::factory('Template', $template_id);
					$tpl_sections = $tpl->sections ? json_decode($tpl->sections, true) : array();
					foreach ($tpl_sections as $section => $label)
					{
						if (strstr($section, 'image'))
						{
							$regular_fields = array('image1', 'image2', 'image3', 'image4', 'image5');

							if (Arr::get($this->request->post(), 'file_'.$section))
							{
								$fname = HTML::chars(Arr::get($this->request->post(), 'file_'.$section));
							}
							else if (Arr::get($this->request->post(), $section.'_hid'))
							{
								$fname = HTML::chars(Arr::get($this->request->post(), $section.'_hid'));
							}

							if (in_array($section, $regular_fields))
							{
								$data->$section = $fname;
							}
							else
							{
								$field_label[$section] = $label;
								$field_content[$section] = $fname;
							}
						}
						else if (strstr($section, 'doc'))
						{
							$regular_fields = array('doc1', 'doc2', 'doc3', 'doc4', 'doc5');

							if (Arr::get($this->request->post(), 'file_'.$section))
							{
								$fname = HTML::chars(Arr::get($this->request->post(), 'file_'.$section));
							}
							else if (Arr::get($this->request->post(), $section.'_hid'))
							{
								$fname = HTML::chars(Arr::get($this->request->post(), $section.'_hid'));
							}

							// Doc Link Label
							$t = substr($section, 3, 1);
							$fieldlabel = 'doc_label'.$t;
							$filedoc_data = HTML::chars(Arr::get($this->request->post(), $fieldlabel));

							if (in_array($section, $regular_fields))
							{
								$data->$section = $fname;
								$data->$fieldlabel = $filedoc_data;
							}
							else
							{
								$field_label[$section] = $label;
								$field_content[$section] = $fname;
								$field_label[$fieldlabel] = 'File Download Name';
								$field_content[$fieldlabel] = $filedoc_data;
							}
						}
						else
						{
							$regular_fields = array('title', 'body1', 'body2', 'body3', 'body4', 'body5', 'link1', 'link2', 'link3', 'link4', 'link5', 'embed1', 'embed2', 'embed3', 'embed4', 'embed5');

							$fname = HTML::chars(Arr::get($this->request->post(), $section));

							if (in_array($section, $regular_fields))
							{
								$data->$section = $fname;
							}
							else
							{
								$field_label[$section] = $label;
								$field_content[$section] = $fname;
							}
						}
					}

					$data->field_label = count($field_label) > 0 ? json_encode($field_label) : NULL;
					$data->field_content = count($field_content) > 0 ? json_encode($field_content) : NULL;

					$data->meta_title = HTML::chars(Arr::get($this->request->post(), 'meta_title'));
					$data->meta_description = HTML::chars(Arr::get($this->request->post(), 'meta_description'));
					$data->meta_keyword = HTML::chars(Arr::get($this->request->post(), 'meta_keyword'));

					break;
			}
			// echo "<pre>";
			// var_dump($data);
			// echo "</pre>";
			// exit;

			// Process the preview page for Splash Banner
			if ($content_type_id == 2)
			{
				$current_date = date('Y-m-d', time());
				// Do not include exisitng splash banner in the preview
				/*
				$page = ORM::factory('Page')
					->where('content_type_id', '=', 2)
					->where('start_date', '<=', $current_date)
					->where('end_date', '>=', $current_date)
					->where('status', '=', 'published')
					->find_all();
				*/
				$arr_main = array();
				$arr_thumb = array();
				$arr_main[] = array('link'=>$data->link1, 'image'=>$data->image1);
				$arr_thumb[] = array('title'=>$data->title, 'thumbnail'=>$data->image2);
				/*
				foreach ($page as $res)
				{
					$arr_main[] = array('link'=>$res->link1, 'image'=>$res->image1);
					$arr_thumb[] = array('title'=>$res->title, 'thumbnail'=>$res->image2);
				}
				*/

				// get client updates
				$sql = ORM::factory('Page')
					->where('content_type_id', '=', 5)
					->where('start_date', '<=', $current_date)
					->where('end_date', '>=', $current_date)
					->where('status', '=', 'published')
					->find_all();

				$view = View::factory('homepage');
				$view->arr_main = $arr_main;
				$view->arr_thumb = $arr_thumb;
				$view->sql = $sql;
				$view->login_box = MyHelper::login_box(1);

				$this->template->content = $view;
			}
			else if ($content_type_id == 3)
			{
				// Ad Banner
				$t = ORM::factory('Template', $template_id);
				if ($t->id)
				{
					$header_footer = $t->header_footer;
					$tpl_view = View::factory('templates/'.$t->file_name);
					$ad_src = '';
					if ($data->image1)
					{
						$ad_src = URL::site('media/uploads/'.$data->image1);
					}
					$tpl_view->title = html_entity_decode($data->title);

					$tpl_view->ad_link = $data->link1 ? $data->link1 : '';
					$tpl_view->ad_src = $ad_src;

					if ($header_footer == 2)
					{
						$this->template = View::factory('template/body_tpl');
					}

					$this->template->content = "<div class=\"main\" style=\"margin-top:30px;\">".$tpl_view."</div>";
				}
			}
			else if ($content_type_id == 4)
			{
				if ($template_id)
				{
					$sections = array();
					$t = ORM::factory('Template', $template_id);
					if ($t->id)
					{
						$prod_categ = MyHelper::product_category();
						$str_product_categories = '<ul><li><a href="'.URL::site('promos').'">Main</a></li>';
						foreach ($prod_categ as $cid => $cname)
						{
							$active = $cid == $data->product_category ? ' class="active"' : '';
							$str_product_categories .= '<li'.$active.'><a href="'.URL::site('promos/product_category/'.$cid).'">'.$cname.'</a></li>';
						}
						$str_product_categories .= '</ul>';

						$tpl_view = View::factory('templates/'.$t->file_name);

						$tpl_view->category_id = $category_id;
						$tpl_view->sub_category1 = $sub_category1;
						$tpl_view->sub_category2 = $sub_category2;
						$tpl_view->sub_category3 = $sub_category3;

						$tpl_view->product_categories = $str_product_categories;
						$tpl_view->title = html_entity_decode($data->title);
						$tpl_view->body4 = html_entity_decode($data->body4);

						$sections = $t->sections ? json_decode($t->sections, true) : array();

						// $docroot = DOCROOT.'media/preview';
						$docroot = DOCROOT.'media/uploads';
						foreach ($sections as $fieldname => $label)
						{
							$type =  MyHelper::field_type($fieldname);

							if (in_array($fieldname, MyHelper::regular_fields()))
							{
								$field_value = $data->{$fieldname} ? html_entity_decode($data->{$fieldname}) : '';
							}
							else
							{
								$field_value = array_key_exists($fieldname, $field_content) ? html_entity_decode(Arr::get($field_content, $fieldname)) : '';
							}

							if ($type == 'text' OR $type == 'textarea' OR $type == 'embed' )
							{
								$tpl_view->{$fieldname} = $field_value;
							}
							else if ($type == 'file_img')
							{
								if (is_file($docroot.'/'.$field_value) AND file_exists($docroot.'/'.$field_value))
								// if (MyHelper::check_file($this->filepath.'/'.$field_value))
								{
									// $tpl_view->{$fieldname} = $sql->{$fieldname} ? '<img src="'.URL::site('media/uploads/'.$sql->{$fieldname}).'" style="width:698px; height:148px;">' : '';
									$tpl_view->{$fieldname} = URL::site('media/uploads/'.$field_value);
									// $tpl_view->{$fieldname} = $this->filesite.'/media/uploads/'.$field_value;
								}
								else
								{
									$tpl_view->{$fieldname} = NULL;
								}
							}
							else if ($type == 'file_doc')
							{
								// if (is_file($docroot.'/'.$field_value) AND file_exists($docroot.'/'.$field_value))
								if (MyHelper::check_file($this->filepath.'/'.$field_value))
								{
									$t = substr($fieldname, 3, 1);
									$fieldlabel = 'doc_label'.$t;
									if ($data->{$fieldlabel})
									{
										$file_labelname = $data->{$fieldlabel};
									}
									else
									{
										$file_labelname = URL::site('media/uploads/'.$field_value, true);
									}
									$tpl_view->{$fieldname} = $field_value ? '<a href="'.URL::site('media/uploads/'.$field_value, true).'">'.html_entity_decode($file_labelname).'</a>' : '';
									// $tpl_view->{$fieldname} = $field_value ? '<a href="'.$this->filesite.'/media/uploads/'.$field_value.'">'.html_entity_decode($data->{$fieldlabel}).'</a>' : '';
								}
								else
								{
									$tpl_view->{$fieldname} = NULL;
								}
							}
							else if ($type == 'link')
							{
								$tpl_view->{$fieldname} = $field_value ? '<a href="'.$field_value.'">'.$field_value.'</a>' : '';
							}

						}

						$this->template->content = $tpl_view;
					}
				} else {
					$product_category = $data->product_category;
					$title = $data->title;
					$short_desc = html_entity_decode($data->body4);
					$thumbnail = $data->image5;
					$date_published = date('m/d/y', strtotime($data->start_date));
					$link5 = $data->link5;
					if ($link5)
					{
						if (strpos(strtolower($link5), 'http') === 0)  {
							$link = $link5;
						} else {
							$link = 'http://'.$link5;
						}
					} else {
						$link = '#';
					}

					$current_date = date('Y-m-d', time());

					$sql = DB::select()
						->from('promo_header_img')
						->where('id', '=', 1)
						->as_object()
						->execute();
					if ($sql->count())
					{
						$res = $sql->current();
						// $header_img = '<img src="'.$this->filesite.'/media/uploads/'.$res->image.'" width="698" height="148" />';
						$header_img = '<img src="'.URL::site('media/uploads/'.$res->image).'" style="width:698px; height:148px;" />';
					}
					else
					{
						// $header_img = '<img src="'.$this->filesite.'/assets/img/promos-main-banner.jpg'.'" width="698" height="148" />';
						$header_img = '<img src="'.URL::site('assets/img/promos-main-banner.jpg').'" style="width:698px; height:148px;" />';
					}

					$sql = ORM::factory('Page')
						->where('content_type_id', '=', $content_type_id)
						->where('product_category', '=', $product_category)
						->where('start_date', '<=', $current_date)
						->where('end_date', '>=', $current_date)
						->where('status', '=', 'published')
						->order_by('start_date', 'DESC')
						->find_all();

					$view = View::factory('promos_product_list');
					$view->prod_categ = $product_category;
					$view->product_category = MyHelper::product_category();
					$view->title = $title;
					$view->short_desc = $short_desc;
					$view->date_published = $date_published;
					$view->thumbnail = $thumbnail;
					$view->link = $link;
					$view->sql = $sql;
					$view->header_img = $header_img;
					$view->preview = TRUE;
					$return = TRUE;

					$this->template->content = $view;
				}

				$this->template->meta_title = html_entity_decode($data->meta_title);
				$this->template->meta_description = html_entity_decode($data->meta_description);
				$this->template->meta_keyword = html_entity_decode($data->meta_keyword);
			}
			else if ($content_type_id == 7)
			{
				$this->template = View::factory('template/front_tpl');
				$view = View::factory('splash_block');

				$field_content = $data->field_content ? json_decode($data->field_content, true) : array();

				$view->title = html_entity_decode($data->title);
				$view->intro_text = html_entity_decode($data->body1);
				$view->featured_1_title = html_entity_decode(Arr::get($field_content, 'title1'));
				$view->featured_1_img = $data->image1 ? URL::site('media/uploads/'.$data->image1) : '';
				$view->featured_1_text = html_entity_decode($data->body2);
				$view->featured_1_link = $data->link1 ? $data->link1 : '';
				$view->featured_2_title = html_entity_decode(Arr::get($field_content, 'title2'));
				$view->featured_2_img = $data->image2 ? URL::site('media/uploads/'.$data->image2) : '';
				$view->featured_2_text = html_entity_decode($data->body3);
				$view->featured_2_link = $data->link2 ? $data->link2 : '';
				$view->featured_3_title = html_entity_decode(Arr::get($field_content, 'title3'));
				$view->featured_3_img = $data->image3 ? URL::site('media/uploads/'.$data->image3) : '';
				$view->featured_3_text = html_entity_decode($data->body4);
				$view->featured_3_link = $data->link3 ? $data->link3 : '';
				$view->top_right_text = html_entity_decode(Arr::get($field_content, 'body6'));
				$view->bottom_right_text = html_entity_decode(Arr::get($field_content, 'body7'));

				$return = TRUE;
				$this->template->splash_block = $view;

				$current_date = date('Y-m-d', time());

				$page = ORM::factory('Page')
					->where('content_type_id', '=', 2)
					->where('start_date', '<=', $current_date)
					->where('end_date', '>=', $current_date)
					->where('status', '=', 'published')
					->find_all();

				$arr_main = array();
				$arr_thumb = array();
				foreach ($page as $res)
				{
					$arr_main[] = array('link'=>$res->link1, 'image'=>$res->image1);
					$arr_thumb[] = array('title'=>$res->title, 'thumbnail'=>$res->image2);
				}

				// get client updates
				$sql = ORM::factory('Page')
					->where('content_type_id', '=', 5)
					->where('start_date', '<=', $current_date)
					->where('end_date', '>=', $current_date)
					->where('status', '=', 'published')
					->find_all();

				$view = View::factory('homepage');
				$view->arr_main = $arr_main;
				$view->arr_thumb = $arr_thumb;
				$view->sql = $sql;
				$view->login_box = MyHelper::login_box(1);

				$this->template->content = $view;
			}
			else if ($template_id AND ($content_type_id != 2 AND $content_type_id != 3))
			{
				// Applicable to all content type except Splash Banner and Ad Banner
				// get the fields used for this template and the php filename associated with it
				$sections = array();
				$t = ORM::factory('Template', $template_id);
				if ($t->id)
				{
					$tpl_view = View::factory('templates/'.$t->file_name);

					$tpl_view->category_id = $category_id;
					$tpl_view->sub_category1 = $sub_category1;
					$tpl_view->sub_category2 = $sub_category2;
					$tpl_view->sub_category3 = $sub_category3;

					$sections = $t->sections ? json_decode($t->sections, true) : array();

					$field_content = $data->field_content ? json_decode($data->field_content, true) : array();

					// $docroot = DOCROOT.'media/preview';
					$docroot = DOCROOT.'media/uploads';
					foreach ($sections as $fieldname => $label)
					{
						$type =  MyHelper::field_type($fieldname);

						if (in_array($fieldname, MyHelper::regular_fields()))
						{
							$field_value = $data->{$fieldname} ? html_entity_decode($data->{$fieldname}) : '';
						}
						else
						{
							$field_value = array_key_exists($fieldname, $field_content) ? html_entity_decode(Arr::get($field_content, $fieldname)) : '';
						}

						if ($type == 'text' OR $type == 'textarea' OR $type == 'embed' )
						{
							$tpl_view->{$fieldname} = $field_value;
						}
						else if ($type == 'file_img')
						{
							if (is_file($docroot.'/'.$field_value) AND file_exists($docroot.'/'.$field_value))
							{
								$tpl_view->{$fieldname} = URL::site('media/uploads/'.$field_value);
							}
							else
							{
								$tpl_view->{$fieldname} = NULL;
							}
						}
						else if ($type == 'file_doc')
						{
							if (is_file($docroot.'/'.$field_value) AND file_exists($docroot.'/'.$field_value))
							{
								$t = substr($fieldname, 3, 1);
								$fieldlabel = 'doc_label'.$t;
								$filelabelname = array_key_exists($fieldlabel, $field_content) ? html_entity_decode(Arr::get($field_content, $fieldlabel)) : '';

								if ($filelabelname)
								{
									$file_labelname = $filelabelname;
								}
								else
								{
									$file_labelname = URL::site('media/uploads/'.$field_value, true);
								}

								$tpl_view->{$fieldname} = $field_value ? '<a href="'.URL::site('media/uploads/'.$field_value).'">'.html_entity_decode($file_labelname).'</a>' : '';
							}
							else
							{
								$tpl_view->{$fieldname} = NULL;
							}
						}
						else if ($type == 'link')
						{
							// $tpl_view->{$fieldname} = $field_value ? '<a href="'.$field_value.'">'.$field_value.'</a>' : '';
							$tpl_view->{$fieldname} = $field_value ? $field_value : '';
						}
					}

					$this->template->content = $tpl_view;
				}

				$this->template->meta_title = html_entity_decode($data->meta_title);
				$this->template->meta_description = html_entity_decode($data->meta_description);
				$this->template->meta_keyword = html_entity_decode($data->meta_keyword);
			}
		}
	}

	/**
	 * Layout Preview particularly for Client Update and Splash Page Violator (Homepage Layout)
	 * @return [type] [description]
	 */
	public function action_layout_preview()
	{
		$control_no = $this->request->param('controlno');
		$blurb = $this->request->param('blurb');

		$this->template->print = TRUE;

		$current_date = date('Y-m-d', time());

		$sql = ORM::factory('Page')
			->where('control_no', '=', $control_no)
			// ->where('start_date', '<=', $current_date)
			// ->where('end_date', '>=', $current_date)
			->find();

		$return = FALSE;
		if ($sql->id)
		{
			// get the template used
			$tpl_id = $sql->template_id;
			$content_type_id = $sql->content_type_id;
			$page_id = $sql->id;
			$title = html_entity_decode($sql->title);

			if ($content_type_id == 5)
			{
				$current_date = date('Y-m-d', time());

				$page = ORM::factory('Page')
					->where('content_type_id', '=', 2)
					->where('start_date', '<=', $current_date)
					->where('end_date', '>=', $current_date)
					->where('status', '=', 'published')
					->find_all();

				$arr_main = array();
				$arr_thumb = array();
				foreach ($page as $res)
				{
					$arr_main[] = array('link'=>$res->link1, 'image'=>$res->image1);
					$arr_thumb[] = array('title'=>$res->title, 'thumbnail'=>$res->image2);
				}

				$view = View::factory('homepage');
				$view->arr_main = $arr_main;
				$view->arr_thumb = $arr_thumb;
				$view->new_client_update = '<li><p><a href="#" style="color:#fff;">'.$title.'</a></p></li>';
				$view->login_box = MyHelper::login_box(1);

				$return = TRUE;
				$this->template->content = $view;
			}
			else if ($content_type_id == 6)
			{
				$current_date = date('Y-m-d', time());

				$page = ORM::factory('Page')
					->where('content_type_id', '=', 2)
					->where('start_date', '<=', $current_date)
					->where('end_date', '>=', $current_date)
					->where('status', '=', 'published')
					->find_all();

				$arr_main = array();
				$arr_thumb = array();
				foreach ($page as $res)
				{
					$arr_main[] = array('link'=>$res->link1, 'image'=>$res->image1);
					$arr_thumb[] = array('title'=>$res->title, 'thumbnail'=>$res->image2);
				}

				// get client updates
				$sql = ORM::factory('Page')
					->where('content_type_id', '=', 5)
					->where('start_date', '<=', $current_date)
					->where('end_date', '>=', $current_date)
					->where('status', '=', 'published')
					->find_all();

				$view = View::factory('homepage');
				$view->arr_main = $arr_main;
				$view->arr_thumb = $arr_thumb;
				$view->sql = $sql;
				$view->login_box = MyHelper::login_box(1);

				$splash_page = '<div id="notice" class="splash-page-violator" style="margin-bottom:3px; margin-top: 6px; margin-right:auto; margin-left: auto; width:950px; text-align:center; background-color: #333; font-weight:bold;color: #fff;font-size:11px;padding:5px;"><ul class="marquee"><li><div style="width:950px;"><a style="color:white">'.$title.'</a></div></li></ul></div>';
				$return = TRUE;
				$this->template->content = $view;
				$this->template->splash_page = $splash_page;
			}
		}
	}

	/**
	 * Preview feature for an existing CMS (Page is already saved in the database)
	 * @return [type] [description]
	 */
	public function action_page()
	{
		$control_no = $this->request->param('controlno');
		$blurb = $this->request->param('blurb');

		$this->template->print = TRUE;

		$current_date = date('Y-m-d', time());

		$sql = ORM::factory('Page')
			->where('control_no', '=', $control_no)
			// ->where('start_date', '<=', $current_date)
			// ->where('end_date', '>=', $current_date)
			->find();

		$return = FALSE;
		if ($sql->id)
		{
			// get the template used
			$tpl_id = $sql->template_id;
			$content_type_id = $sql->content_type_id;

			// Process the preview page for Splash Banner
			if ($content_type_id == 2)
			{
				$current_date = date('Y-m-d', time());

				// do not include existing published splash banner in the preview
				/*
				$page = ORM::factory('Page')
					->where('content_type_id', '=', 2)
					->where('start_date', '<=', $current_date)
					->where('end_date', '>=', $current_date)
					->where('status', '=', 'published')
					->find_all();
				*/
				$arr_main = array();
				$arr_thumb = array();
				$arr_main[] = array('link'=>$sql->link1, 'image'=>$sql->image1);
				$arr_thumb[] = array('title'=>$sql->title, 'thumbnail'=>$sql->image2);
				/*
				foreach ($page as $res)
				{
					$arr_main[] = array('link'=>$res->link1, 'image'=>$res->image1);
					$arr_thumb[] = array('title'=>$res->title, 'thumbnail'=>$res->image2);
				}
				*/

				// get client updates
				$sql = ORM::factory('Page')
					->where('content_type_id', '=', 5)
					->where('start_date', '<=', $current_date)
					->where('end_date', '>=', $current_date)
					->where('status', '=', 'published')
					->find_all();

				$view = View::factory('homepage');
				$view->arr_main = $arr_main;
				$view->arr_thumb = $arr_thumb;
				$view->sql = $sql;
				$view->login_box = MyHelper::login_box(1);

				$this->template = View::factory('template/main_tpl');
				$return = TRUE;
				$this->template->content = $view;
			}
			else if ($content_type_id == 3)
			{
				// Preview Ad Banner
				$t = ORM::factory('Template', $tpl_id);
				if ($t->id)
				{
					$header_footer = $t->header_footer;
					$tpl_view = View::factory('templates/'.$t->file_name);
					$tpl_view->ad_link = $sql->link1 ? $sql->link1 : '';
					$tpl_view->ad_src = URL::site('media/uploads/'.$sql->image1);
					// $tpl_view->ad_src = $this->filesite.'/media/uploads/'.$sql->image1;
					// $tpl_view->image1 = '<a href="'.$sql->link1.'"><img src="'.URL::site('media/uploads/'.$sql->image1).'"></a>';
					$tpl_view->title = html_entity_decode($sql->title);

					$return = TRUE;

					if ($header_footer == 2)
					{
						$this->template = View::factory('template/body_tpl');
					}

					$this->template->content = "<div class=\"main\" style=\"margin-top:30px;\">".$tpl_view."</div>";
				}
			}
			else if ($content_type_id == 4)
			{
				// Promo Details Page
				$product_category = $sql->product_category;

				$title = $sql->title;
				$short_desc = html_entity_decode($sql->body4);
				$thumbnail = $sql->image5;
				// $date_published = $sql->published_date ? date('m/d/y', strtotime($sql->start_date)) : date('m/d/y', time());
				$date_published = date('m/d/y', strtotime($sql->start_date));
				$link5 = $sql->link5;
				if ($link5)
				{
					if (strpos(strtolower($link5), 'http') === 0)  {
						$link = $link5;
					} else {
						$link = 'http://'.$link5;
					}
				} else {
					$link = URL::site('promos/details/'.$product_category.'/'.$sql->id);
				}

				$current_date = date('Y-m-d', time());

				$sql = DB::select()
					->from('promo_header_img')
					->where('id', '=', 1)
					->as_object()
					->execute();
				if ($sql->count())
				{
					$res = $sql->current();
					$header_img = '<img src="'.URL::site('media/uploads/'.$res->image).'" style="width:698px; height:148px;" />';
				}
				else
				{
					$header_img = '<img src="'.URL::site('assets/img/promos-main-banner.jpg').'" style="width:698px; height:148px;" />';
				}

				$sql = ORM::factory('Page')
					->where('content_type_id', '=', $content_type_id)
					->where('product_category', '=', $product_category)
					->where('start_date', '<=', $current_date)
					->where('end_date', '>=', $current_date)
					->where('status', '=', 'published')
					->where('control_no', '!=', $control_no)
					->order_by('start_date', 'DESC')
					->find_all();

				$view = View::factory('promos_product_list');
				$view->prod_categ = $product_category;
				$view->product_category = MyHelper::product_category();
				$view->title = $title;
				$view->short_desc = $short_desc;
				$view->date_published = $date_published;
				$view->thumbnail = $thumbnail;
				$view->link = $link;
				$view->sql = $sql;
				$view->header_img = $header_img;
				$view->preview = TRUE;
				$return = TRUE;

				$this->template->content = $view;
			}
			else if ($content_type_id == 7)
			{
				$this->template = View::factory('template/front_tpl');
				$view = View::factory('splash_block');

				$field_content = $sql->field_content ? json_decode($sql->field_content, true) : array();

				$view->title = html_entity_decode($sql->title);
				$view->intro_text = html_entity_decode($sql->body1);
				$view->featured_1_title = html_entity_decode(Arr::get($field_content, 'title1'));
				$view->featured_1_img = $sql->image1 ? URL::site('media/uploads/'.$sql->image1) : '';
				$view->featured_1_text = html_entity_decode($sql->body2);
				$view->featured_1_link = $sql->link1 ? $sql->link1 : '';
				$view->featured_2_title = html_entity_decode(Arr::get($field_content, 'title2'));
				$view->featured_2_img = $sql->image2 ? URL::site('media/uploads/'.$sql->image2) : '';
				$view->featured_2_text = html_entity_decode($sql->body3);
				$view->featured_2_link = $sql->link2 ? $sql->link2 : '';
				$view->featured_3_title = html_entity_decode(Arr::get($field_content, 'title3'));
				$view->featured_3_img = $sql->image3 ? URL::site('media/uploads/'.$sql->image3) : '';
				$view->featured_3_text = html_entity_decode($sql->body4);
				$view->featured_3_link = $sql->link3 ? $sql->link3 : '';
				$view->top_right_text = html_entity_decode(Arr::get($field_content, 'body6'));
				$view->bottom_right_text = html_entity_decode(Arr::get($field_content, 'body7'));

				$return = TRUE;
				$this->template->splash_block = $view;

				$current_date = date('Y-m-d', time());

				$page = ORM::factory('Page')
					->where('content_type_id', '=', 2)
					->where('start_date', '<=', $current_date)
					->where('end_date', '>=', $current_date)
					->where('status', '=', 'published')
					->find_all();

				$arr_main = array();
				$arr_thumb = array();
				foreach ($page as $res)
				{
					$arr_main[] = array('link'=>$res->link1, 'image'=>$res->image1);
					$arr_thumb[] = array('title'=>$res->title, 'thumbnail'=>$res->image2);
				}

				// get client updates
				$sql = ORM::factory('Page')
					->where('content_type_id', '=', 5)
					->where('start_date', '<=', $current_date)
					->where('end_date', '>=', $current_date)
					->where('status', '=', 'published')
					->find_all();

				$view = View::factory('homepage');
				$view->arr_main = $arr_main;
				$view->arr_thumb = $arr_thumb;
				$view->sql = $sql;
				$view->login_box = MyHelper::login_box(1);

				$this->template->content = $view;
			}
			else if ($tpl_id AND ($content_type_id == 1 OR $content_type_id == 5 OR $content_type_id == 6 OR $content_type_id > 7))
			{
				// get the fields used for this template and the php filename associated with it
				$sections = array();

				$field_content = $sql->field_content ? json_decode($sql->field_content, true) : array();

				$t = ORM::factory('Template', $tpl_id);
				if ($t->id)
				{
					$tpl_view = View::factory('templates/'.$t->file_name);

					$tpl_view->category_id = $sql->category_id;
					$tpl_view->sub_category1 = $sql->sub_category1;
					$tpl_view->sub_category2 = $sql->sub_category2;
					$tpl_view->sub_category3 = $sql->sub_category3;

					$meta_title = html_entity_decode($sql->meta_title);
					$meta_description = html_entity_decode($sql->meta_description);
					$meta_keyword = html_entity_decode($sql->meta_keyword);
					$this->template->meta_title = $meta_title;
					$this->template->meta_description = $meta_description;
					$this->template->meta_keyword = $meta_keyword;

					$sections = $t->sections ? json_decode($t->sections, true) : array();

					$docroot = DOCROOT.'media/uploads';
					foreach ($sections as $fieldname => $label)
					{
						$type =  MyHelper::field_type($fieldname);

						// check if field is part of the original 5 regular fields or new field
						if (in_array($fieldname, MyHelper::regular_fields()))
						{
							$field_value = $sql->{$fieldname} ? html_entity_decode($sql->{$fieldname}) : '';
						}
						else
						{
							$field_value = array_key_exists($fieldname, $field_content) ? html_entity_decode(Arr::get($field_content, $fieldname)) : '';
						}

						if ($type == 'text' OR $type == 'textarea' OR $type == 'embed' )
						{
							$tpl_view->{$fieldname} = $field_value;
						}
						else if ($type == 'file_img')
						{
							if (is_file($docroot.'/'.$field_value) AND file_exists($docroot.'/'.$field_value))
							{
								$tpl_view->{$fieldname} = URL::site('media/uploads/'.$field_value);
							}
							else
							{
								$tpl_view->{$fieldname} = NULL;
							}
						}
						else if ($type == 'file_doc')
						{
							if (is_file($docroot.'/'.$field_value) AND file_exists($docroot.'/'.$field_value))
							{
								$t = substr($fieldname, 3, 1);
								$fieldlabel = 'doc_label'.$t;
								$filelabelname = array_key_exists($fieldlabel, $field_content) ? html_entity_decode(Arr::get($field_content, $fieldlabel)) : '';

								if ($filelabelname)
								{
									$file_labelname = $filelabelname;
								}
								else
								{
									$file_labelname = URL::site('media/uploads/'.$field_value, true);
								}

								$tpl_view->{$fieldname} = $field_value ? '<a href="'.URL::site('media/uploads/'.$field_value).'">'.html_entity_decode($file_labelname).'</a>' : '';
							}
							else
							{
								$tpl_view->{$fieldname} = NULL;
							}
						}
						else if ($type == 'link')
						{
							// $tpl_view->{$fieldname} = $field_value ? '<a href="'.$field_value.'">'.$field_value.'</a>' : '';
							$tpl_view->{$fieldname} = $field_value ? $field_value : '';
						}

					}

					$return = TRUE;
					$this->template->content = $tpl_view;
				}
			}
		}

		if ($return != TRUE)
		{
			throw HTTP_Exception::factory(404, 'URL not found!');
		} else{
			$this->template->print = TRUE;
		}
	}

	public function action_client_update()
	{
		$this->auto_render = FALSE;

		$page_id = $this->request->param('id');

		$page = ORM::factory('Page', $page_id);

		$view = View::factory('preview/client_update');
		$view->title = html_entity_decode($page->title);
		$view->body1 = html_entity_decode($page->body1);

		$this->response->body($view);
	}

	/**
	 * Layout Preview (Homepage)
	 * @return [type] [description]
	 */
	public function action_client_update_layout()
	{
		if (HTTP_Request::POST == $this->request->method())
		{
			$content_type_id = Arr::get($this->request->post(), 'content_type');
			$title = Arr::get($this->request->post(), 'title');

			$this->template->print = TRUE;

			$current_date = date('Y-m-d', time());

			$page = ORM::factory('Page')
				->where('content_type_id', '=', 2)
				->where('start_date', '<=', $current_date)
				->where('end_date', '>=', $current_date)
				->where('status', '=', 'published')
				->find_all();

			$arr_main = array();
			$arr_thumb = array();
			foreach ($page as $res)
			{
				$arr_main[] = array('link'=>$res->link1, 'image'=>$res->image1);
				$arr_thumb[] = array('title'=>$res->title, 'thumbnail'=>$res->image2);
			}

			$view = View::factory('homepage');
			$view->arr_main = $arr_main;
			$view->arr_thumb = $arr_thumb;
			$view->new_client_update = '<li><p><a href="#" style="color:#fff;">'.$title.'</a></p></li>';
			$view->login_box = MyHelper::login_box(1);

			$return = TRUE;
			$this->template->content = $view;
		}
	}

	/**
	 * Layout Preview.  Page is not saved yet. (Homepage)
	 * @return [type] [description]
	 */
	public function action_splash_page_layout()
	{
		if (HTTP_Request::POST == $this->request->method())
		{
			$content_type_id = Arr::get($this->request->post(), 'content_type');
			$title = Arr::get($this->request->post(), 'title');

			$this->template->print = TRUE;

			$current_date = date('Y-m-d', time());

			$page = ORM::factory('Page')
				->where('content_type_id', '=', 2)
				->where('start_date', '<=', $current_date)
				->where('end_date', '>=', $current_date)
				->where('status', '=', 'published')
				->find_all();

			$arr_main = array();
			$arr_thumb = array();
			foreach ($page as $res)
			{
				$arr_main[] = array('link'=>$res->link1, 'image'=>$res->image1);
				$arr_thumb[] = array('title'=>$res->title, 'thumbnail'=>$res->image2);
			}

			// get client updates
			$sql = ORM::factory('Page')
				->where('content_type_id', '=', 5)
				->where('start_date', '<=', $current_date)
				->where('end_date', '>=', $current_date)
				->where('status', '=', 'published')
				->find_all();

			$view = View::factory('homepage');
			$view->arr_main = $arr_main;
			$view->arr_thumb = $arr_thumb;
			$view->sql = $sql;
			$view->login_box = MyHelper::login_box(1);

			$splash_page = '<div id="notice" class="splash-page-violator" style="margin-bottom:3px; margin-top: 6px; margin-right:auto; margin-left: auto; width:950px; text-align:center; background-color: #333; font-weight:bold;color: #fff;font-size:11px;padding:5px;"><ul class="marquee"><li><div style="width:950px;"><a style="color:white" href="#">'.$title.'</a></div></li></ul></div>';
			$return = TRUE;
			$this->template->content = $view;
			$this->template->splash_page = $splash_page;
		}
	}

	/**
	 * Layout Preview.  Page is not saved yet.
	 * @return [type] [description]
	 */
	public function action_promo_layout()
	{
		if (HTTP_Request::POST == $this->request->method())
		{
			$content_type_id = Arr::get($this->request->post(), 'content_type');
			$product_category = Arr::get($this->request->post(), 'product_category');

			$this->template->print = TRUE;

			$title = Arr::get($this->request->post(), 'title');
			$short_desc = Arr::get($this->request->post(), 'body4');
			$date_published = date('m/d/y', strtotime(Arr::get($this->request->post(), 'startdate')));
			$link5 = Arr::get($this->request->post(), 'link5');
			if ($link5)
			{
				if (strpos(strtolower($link5), 'http') === 0)  {
					$link = $link5;
				} else {
					$link = 'http://'.$link5;
				}
			} else {
				$link = '#';
			}

			$thumbnail = '';
			if (Arr::get($this->request->post(), 'file_image5'))
			{
				$thumbnail = HTML::chars(Arr::get($this->request->post(), 'file_image5'));
			}
			/*
			if( ! empty($_FILES))
			{
				$directory = DOCROOT.'media/preview';
				$files = Validation::factory($_FILES)
				    ->rules('image5', array(
				        array('Upload::not_empty'),
				        array('Upload::valid'),
				        array('Upload::type', array(':value', array('gif', 'jpg', 'jpeg', 'png'))),
				        array('Upload::size', array(':value', '5M'))
			    	));
				if ($files->check())
				{
					$filename  = preg_replace('/\s+/u', '_', $files['image5']['name']);
					$image5 = uniqid().'_'.$filename;
					// Upload!
					Upload::save($files['image5'], $image5, $directory);
					$thumbnail = $image5;
				}
			}
			*/

			$sql = DB::select()
				->from('promo_header_img')
				->where('id', '=', 1)
				->as_object()
				->execute();
			if ($sql->count())
			{
				$res = $sql->current();
				$header_img = '<img src="'.URL::site('media/uploads/'.$res->image).'" style="width:698px; height:148px;" />';
				// $header_img = '<img src="'.$this->filesite.'/media/uploads/'.$res->image.'" width="698" height="148" />';
			}
			else
			{
				$header_img = '<img src="'.URL::site('assets/img/promos-main-banner.jpg').'" style="width:698px; height:148px;" />';
				// $header_img = '<img src="'.$this->filesite.'/assets/img/promos-main-banner.jpg'.'" width="698" height="148" />';
			}

			$category_id = Arr::get($this->request->post(), 'category');
			$sub_category1 = Arr::get($this->request->post(), 'sub_category1');
			$sub_category2 = Arr::get($this->request->post(), 'sub_category2');
			$sub_category3 = Arr::get($this->request->post(), 'sub_category3');

			$current_date = date('Y-m-d', time());

			$sql = ORM::factory('Page')
				->where('content_type_id', '=', $content_type_id)
				->where('product_category', '=', $product_category)
				->where('start_date', '<=', $current_date)
				->where('end_date', '>=', $current_date)
				->where('status', '=', 'published')
				->order_by('status_date', 'DESC')
				->find_all();

			$view = View::factory('promos_product_list');
			$view->prod_categ = $product_category;
			$view->product_category = MyHelper::product_category();
			$view->title = $title;
			$view->short_desc = $short_desc;
			$view->date_published = $date_published;
			$view->thumbnail = $thumbnail;
			$view->link = $link;
			$view->sql = $sql;
			$view->header_img = $header_img;
			$view->preview = TRUE;

			$this->template->content = $view;
		}
	}
}