<?php defined('SYSPATH') or die('No direct script access.');

class Model_Page extends ORM
{
	protected $_table_name = 'pages';

	public function page_copy($orig_id)
	{
		$sql = "
			INSERT INTO pages
			(
				title, body1, body2, body3, body4, body5, link1, link2, link3, link4, link5, image1, image2, image3, image4, image5, doc1, doc2, doc3, doc4, doc5,
				doc_label1, doc_label2, doc_label3, doc_label4, doc_label5, embed1, embed2, embed3, embed4, embed5, product_category, field_label, field_content,
				content_type_id, category_id, sub_category1, sub_category2, sub_category3, template_id, segment_ids, start_date, end_date, status, copy_from
			)
			SELECT
				title, body1, body2, body3, body4, body5, link1, link2, link3, link4, link5, image1, image2, image3, image4, image5, doc1, doc2, doc3, doc4, doc5,
				doc_label1, doc_label2, doc_label3, doc_label4, doc_label5, embed1, embed2, embed3, embed4, embed5, product_category, field_label, field_content,
				content_type_id, category_id, sub_category1, sub_category2, sub_category3, template_id, segment_ids, start_date, end_date, 'create-new-copy', $orig_id
			FROM
				pages
			WHERE
				id = $orig_id
		";

		$query = DB::query(Database::INSERT, $sql);
		$query->execute();

		// get last insert id
		$sql = "SELECT IDENT_CURRENT('pages') as insert_id";
		$query = DB::query(Database::SELECT, $sql);
		$res = $query->execute();

		return $res[0]['insert_id'];
	}

	public function page_copy_new($orig_id)
	{
		$directory = DOCROOT.'media/uploads';

		$sql = DB::select()
			->from('pages')
			->where('id', '=', $orig_id)
			->as_object()
			->execute();
		if ($sql->count())
		{
			$page = $sql->current();

			$new = ORM::factory('Page');
			$new->title = $page->title;
			$new->product_category = $page->product_category;
			$new->content_type_id = $page->content_type_id;
			$new->category_id = $page->category_id;
			$new->sub_category1 = $page->sub_category1;
			$new->sub_category2 = $page->sub_category2;
			$new->sub_category3 = $page->sub_category3;
			$new->template_id = $page->template_id;
			$new->segment_ids = $page->segment_ids;
			$new->start_date = $page->start_date;
			$new->end_date = $page->end_date;
			$new->status = 'create-new-copy';
			$new->copy_from = $orig_id;
			$new->field_label = $page->field_label;
			// $new->field_content = $page->field_content;
			$new->meta_title = $page->meta_title;
			$new->meta_description = $page->meta_description;
			$new->meta_keyword = $page->meta_keyword;

			for ($i = 1; $i<= 5; $i++)
			{
				$img = 'image'.$i;
				$image_file = $page->{$img};
				if ($image_file)
				{
					$new_image_file = uniqid().'_'.substr($image_file, 14);
					// echo $image_file.' = '.$new_image_file.'<br />';
					if (is_file($directory.'/'.$image_file) AND file_exists($directory.'/'.$image_file))
					{
						@copy($directory.'/'.$image_file, $directory.'/'.$new_image_file);
						$new->{$img} = $new_image_file;
					}
				}

				$doc = 'doc'.$i;
				$doc_file = $page->{$doc};
				if ($doc_file)
				{
					$new_doc_file = uniqid().'_'.substr($doc_file, 14);
					// echo $doc_file.' = '.$new_doc_file.'<br />';
					if (is_file($directory.'/'.$doc_file) AND file_exists($directory.'/'.$doc_file))
					{
						@copy($directory.'/'.$doc_file, $directory.'/'.$new_doc_file);
						$new->{$doc} = $new_doc_file;
					}
				}

				$body = 'body'.$i;
				$new->{$body} = $page->{$body};

				$link = 'link'.$i;
				$new->{$link} = $page->{$link};

				$doc_label = 'doc_label'.$i;
				$new->{$doc_label} = $page->{$doc_label};

				$embed = 'embed'.$i;
				$new->{$embed} = $page->{$embed};
			}

			$new_field_content = array();
			$field_content = $page->field_content ? json_decode($page->field_content, true) : array();
			foreach ($field_content as $field => $value)
			{
				if (strstr($field, 'image')) {
					$new_image_file = uniqid().'_'.substr($value, 14);

					if (is_file($directory.'/'.$value) AND file_exists($directory.'/'.$value))
					{
						@copy($directory.'/'.$value, $directory.'/'.$new_image_file);
						$new_field_content[$field] = $new_image_file;
					}
				}
				elseif (strstr($field, 'doc')) {
					$new_doc_file = uniqid().'_'.substr($value, 14);

					if (is_file($directory.'/'.$value) AND file_exists($directory.'/'.$value))
					{
						@copy($directory.'/'.$value, $directory.'/'.$new_doc_file);
						$new_field_content[$field] = $new_doc_file;
					}
				}
				else {
					$new_field_content[$field] = $value;
				}
			}
			$new_field_content = json_encode($new_field_content);
			$new->field_content = $new_field_content;

			$new->save();
			$new_id = $new->id;

			return $new_id;
		}
	}
}