<?php defined('SYSPATH') or die('No direct script access.');

class Task_Mailer extends Minion_Task {

	// send email to maker/checker 1 month prior to the page expiry
	protected function _execute(array $params)
	{
		$current_date = date('Y-m-d', time());

		// Email Reminder in 30 days
		$int_reminder = Kohana::$config->load('site')->get('email_reminder');

		$sql = ORM::factory('Page')
			->where(DB::expr("DATEADD(day, $int_reminder, end_date)"), '=', $current_date)
			->where('status', '=', 'published')
			->order_by('category_id')
			->find_all();

		$subject = "Your EOL posting will expire in ".$int_reminder." days";
		$pages = '';
		$categ = 0;
		if ($sql->count())
		{
			foreach ($sql as $res)
			{
				$page_id = $res->id;
				$control_no = $res->control_no;
				$category_id = $res->category_id;
				$title = html_entity_decode($res->title);
				$content_type = Arr::get(MyHelper::content_types(), $res->content_type_id);

				if ($categ != $category_id AND $categ != 0)
				{
					if ($pages)
					{
						$message = 'Reminder!<p>Listed below are the EOL CMS pages that will expire in '.$int_reminder.' days.</p>';
						$message .= '<table><tr><td>Control No.</td><td>Title</td><td>Content Type</td></tr>'.$pages.'</table>';
						$message .= '<p>This is an auto generated email.  Please do not reply.</p>';
					}

					if ($message)
					{
						Email::reminder(array(4, 5, 6), $categ, $subject, $message);
					}

					$pages = '';
				}

				$pages .= '<tr><td>'.$control_no.'</td><td>'.$title.'</td><td>'.$content_type.'</td></tr>';

				$categ = $category_id;
			}

			if ($pages)
			{
				$message = 'Reminder!<p>Listed below are the EOL CMS pages that will expire in 1 month.</p>';
				$message .= '<table><tr><td>Control No.</td><td>Title</td><td>Content Type</td></tr>'.$pages.'</table>';
				$message .= '<p>This is an auto generated email.  Please do not reply.</p>';
			}

			if ($message)
			{
				Email::reminder(array(4, 5, 6), $category_id, $subject, $message);
			}
		}
		// End email reminder in 30 days

		// Email reminder in 7 days
		$int_reminder2 = Kohana::$config->load('site')->get('email_reminder2');

		$sql = ORM::factory('Page')
			->where(DB::expr("DATEADD(day, $int_reminder2, end_date)"), '=', $current_date)
			->where('status', '=', 'published')
			->order_by('category_id')
			->find_all();

		$subject = "Your EOL posting will expire in ".$int_reminder2." days";
		$pages = '';
		$categ = 0;
		if ($sql->count())
		{
			foreach ($sql as $res)
			{
				$page_id = $res->id;
				$control_no = $res->control_no;
				$category_id = $res->category_id;
				$title = html_entity_decode($res->title);
				$content_type = Arr::get(MyHelper::content_types(), $res->content_type_id);

				if ($categ != $category_id AND $categ != 0)
				{
					if ($pages)
					{
						$message = 'Reminder!<p>Listed below are the EOL CMS pages that will expire in '.$int_reminder2.' days.</p>';
						$message .= '<table><tr><td>Control No.</td><td>Title</td><td>Content Type</td></tr>'.$pages.'</table>';
						$message .= '<p>This is an auto generated email.  Please do not reply.</p>';
					}

					if ($message)
					{
						Email::reminder(array(4, 5, 6), $categ, $subject, $message);
					}

					$pages = '';
				}

				$pages .= '<tr><td>'.$control_no.'</td><td>'.$title.'</td><td>'.$content_type.'</td></tr>';

				$categ = $category_id;
			}

			if ($pages)
			{
				$message = 'Reminder!<p>Listed below are the EOL CMS pages that will expire in 1 month.</p>';
				$message .= '<table><tr><td>Control No.</td><td>Title</td><td>Content Type</td></tr>'.$pages.'</table>';
				$message .= '<p>This is an auto generated email.  Please do not reply.</p>';
			}

			if ($message)
			{
				Email::reminder(array(4, 5, 6), $category_id, $subject, $message);
			}
		}
	}
}