<div class="row">
	<div class="span9">
		<?php echo Form::open('admin/cms/save', array('id'=>'_form', 'enctype'=>'multipart/form-data'));?>
		<fieldset>
			<legend><?php echo $title_bar;?><span class="pull-right"><a class="act-danger" id="close-form" href="#">&times;</a></span></legend>
			<div class="row">
				<div class="span9">
					<label>Select Content Type:</label>
					<?php echo Form::select('content_type', $arr_content_types, NULL, array('class'=>'required', 'id'=>'content_type'));?>
				</div>
			</div>
			<div id="form-content">
			</div>
		</fieldset>
		<input type="hidden" name="btn_clicked" id="btn_clicked" value="" />
		<input type="hidden" name="id" id="id" value="0" />
		<input type="hidden" name="token" value="<?php echo Security::token();?>" />
		<?php echo Form::close();?>
	</div>
</div>
<script src="<?php echo URL::site('assets/js/jquery-ui-1.10.2.custom.min.js');?>"></script>
<link href="<?php echo URL::site('assets/css/smoothness/jquery-ui-1.10.2.custom.min.css');?>" rel="stylesheet">
<script src="<?php echo URL::site('assets/colorbox/jquery.colorbox-min.js');?>"></script>
<link href="<?php echo URL::site('assets/colorbox/colorbox.css');?>" rel="stylesheet">
<script src="<?php echo URL::site('assets/js/additional-methods.js');?>"></script>
<script type="text/javascript">
$(document).on('change', '#content_type', function(){
	if ($(this).val() > 0)
	{
		$.post("<?php echo URL::site('admin/cms/get_content_type');?>", {type: $(this).val(), id: $('#id').val()},
			function(htm) {
				$('#form-content').html(htm);
			});
	}
	else
	{
		$('#form-content').html('');
	}

	$('#_form').validate({
		// onfocusout: false,
		rules: {
			content_type: {valueNotEquals: 0},
			segment_view: {valueNotEquals: 0},
			category: {
				valueNotEquals: 0
			},
			enddate: {
				greaterThan: "#startdate",
				equalDate: "#startdate"
			}
		},
		messages: {
			content_type: "Please select a Content Type",
			segment_view: "Please select a Segment",
			category: "Please select a Category",
			startdate: {
				required: 'Please input a Start Date for this request',
				currentDate: 'Start Date should not be earlier than current date'
			},
			enddate: {
				required: 'Please input an End Date for this request',
				currentDate: 'End Date should not be earlier than current date',
				greaterThan: 'End Date should not be earlier than Start Date',
				equalDate: 'End Date should not be equal to the Start Date'
			},
			template_id: 'Please select a default template for this page'
		},
		ignore: "",
		errorPlacement: function (error, element) {
			if (element.hasClass("htmlEditor")) {
				error.insertAfter(element.next());
			}
			else {
				error.insertAfter(element);
			}
		},
		submitHandler: function(form) {
			var btn = $('#btn_clicked').val();

			var content_type = $('#content_type').val();

			if ((content_type == 1 || content_type > 7) && btn != 'btn-preview')
			{
				var cn;
				var check = check_navstring();
				cn = check.success(function (data) {
					return data;
				});

				var r = cn.responseText.split('|');

				if (r[0] == 1) {
					if (r[1] == 'Published')
					{
						if (confirm('Your chosen hierarchy already has an existing info page posting. Do you want to edit the published info page posting instead?\n\nClick OK to clear all progress and go to the published page. Otherwise, click Cancel to select a different hierarchy for your posting.'))
						{
							page_id = r[3];
							window.location.href = "<?php echo URL::site('admin/cms/view');?>/"+page_id;
						}
						return false;
					}
					else
					{
						var status = r[1];
						var ccn = r[2];
						alert('Your chosen hierarchy is already used.\n\nStatus: '+status+'\nControl No.: '+ccn);
						return false;
					}
				}
			}

			// for splash block, supersede check
			if (content_type == 7 && btn != 'btn-preview')
			{
				var cs;
				var check = check_segment();
				cs = check.success(function (data) {
					return data;
				});
				if (cs.responseText == 'alert')
				{
					alert('Splash Block is already defined for this Segment.');
					return false;
				}
				else if (cs.responseText == 'alert2')
				{
					alert('Splash Block is already defined for this Segment.\n\nIf you want to replace the published splash block page posting, please use the same segment');
					return false;
				}
				else if (cs.responseText == 'alert3')
				{
					alert('Splash Block is not yet defined for this Segment.\n\nIf you want to replace the published splash block page posting, please use the same segment. Otherwise, uncheck the supersede option.');
					return false;
				}
			}

			if (btn == 'btn-submitted')
			{
				if (confirm('Do you want to submit posting request for checking?'))
				{
					form.submit();
				}
			}
			else
			{
				form.submit();
			}
		}
	});

	check_navstring = function() {
		var content_type = $('#content_type').val();
		var category = $('#category').val();
		var sub_category1 = $('#sub_category1').val();
		var sub_category2 = $('#sub_category2').val();
		var sub_category3 = $('#sub_category3').val();
		var page_id = $('#id').val();

		return $.ajax({
			url: "<?php echo URL::site('admin/cms/check_navstring');?>",
			type: 'POST',
			data: {content_type: content_type, category: category, sub_category1: sub_category1, sub_category2: sub_category2, sub_category3: sub_category3, pid: page_id},
			async: false
		});
	}

	check_segment = function(){
		var page_id = $('#id').val();
		var segment_id = $('#segment_view').val();
		var copy_from = $('#copy_from').val();
		var supersede = $('#supersede_cn').is(':checked');

		return $.ajax({
			url: "<?php echo URL::site('admin/cms/check_segment');?>",
			type: 'POST',
			data: {segment_id: segment_id, pid: page_id, copy_from: copy_from, supersede: supersede},
			async: false
		});
	}
});

$(document).on('click', '#check-navtree', function(){
	var cn;
	var check = check_navstring();
	cn = check.success(function (data) {
		return data;
	});

	var r = cn.responseText.split('|');

	if (r[0] == 1) {
		if (r[1] == 'Published')
		{
			if (confirm('Your chosen hierarchy already has an existing info page posting. Do you want to edit the published info page posting instead?\n\nClick OK to clear all progress and go to the published page. Otherwise, click Cancel to select a different hierarchy for your posting.'))
			{
				page_id = r[3];
				window.location.href = "<?php echo URL::site('admin/cms/view');?>/"+page_id;
			}
		}
		else
		{
			var status = r[1];
			var ccn = r[2];
			alert('Your chosen hierarchy is already used.\n\nStatus: '+status+'\nControl No.: '+ccn);
		}
	}
	else
	{
		alert('Your chosen hierarchy is not yet used');
	}
});

// X icon
$(document).on('click', '#close-form', function(e){
	if (formmodified)
	{
		if (confirm('Entries will be cleared. Do you want to save as Draft?')) {
			var categ = $('#category').val();

			if (categ == 0)
			{
				alert('Please input a Category for this request');
			} else {
				$('#btn_clicked').val('btn-draft');
				$.post("<?php echo URL::site('admin/cms/save');?>", $('#_form').serialize(), function(){
					window.location.href="<?php echo URL::site('admin/cms');?>";
				});
			}
		} else {
			window.location.href="<?php echo URL::site('admin/cms');?>";
		}
	} else {
		window.location.href="<?php echo URL::site('admin/cms');?>";
	}
});

// clicked Navigation link when user creating a page
$(document).on('click', '.navlink', function(e){
	for (var i in CKEDITOR.instances){
		var editor = i;
		var ckchange = 0;
	   if (CKEDITOR.instances[editor].checkDirty())
		{
			var ckchange=1;
		}
		if (ckchange) break;
	}
	if (formmodified)
	{
		if (confirm('Entries will be cleared. Do you want to save as Draft?')) {
			var categ = $('#category').val();

			if (categ == 0)
			{
				alert('Please input a Category for this request');
				e.preventDefault();
			} else {
				$('#btn_clicked').val('btn-draft');
				$.post("<?php echo URL::site('admin/cms/save');?>", $('#_form').serialize(), function(){
					window.location.href="<?php echo URL::site('admin/cms');?>";
				});
			}
		} else {
			window.location.href="<?php echo URL::site('admin/cms');?>";
		}
	}
});

// Get the subcategory assigned to this category
$(document).on('change', '#category', function(){
	var categ_id = $(this).val();
	// get sub category if any under this category
	$.post("<?php echo URL::site('admin/cms/category_change');?>", {categ_id: categ_id, content_type: $('#content_type').val(), page_id: $('#id').val()},
		function(h){
			$('#div-content').html('');
			$('#div-content').html(h);
		}
	);
});

// Get subcategory of a subcategory
$(document).on('change', '.subcateg', function(){
	var category_id = $('#category').val();
	var parent_id = $(this).val();
	var level = $(this).attr('data-level');
	var nxtlevel = parseInt(level) + 1;
	if (level)
	{
		for(var i = nxtlevel + 1; i <= 3; i++)
		{
			$('#subcateg'+i).html('');
		}

		$.post("<?php echo URL::site('admin/cms/get_subcategory');?>", {category_id: category_id, parent_id: parent_id, level: level},
			function(h){
				$('#subcateg'+nxtlevel).html(h);
			}
		);
	}
});

// display list of templates available
$(document).on('click', '#select-tpl', function(){
	var category_id = $('#category').val();
	var tpl_list = $('#tpl_list').val();

	$.colorbox({
  		href: "<?php echo URL::site('admin/cms/select_template');?>",
  		data: {tpl_list: tpl_list},
  		height: 350,
  		onOpen: function(){}
  	});
});

// template select
$(document).on('click', '.thumbnail', function(e){
	var tpl_id = $(this).attr('id');
	var category_id = $('#category').val();
	var content_type_id = $('#content_type').val();

	if (content_type_id != 3 && tplselect == 1)
	{
		if (confirm('Selecting a different template will clear all your entries. Do you wish to Continue?'))
		{
			$.post("<?php echo URL::site('admin/cms/set_template');?>", {tpl_id: tpl_id, category_id: category_id, content_type_id: content_type_id},
				function(h){
					$('#div-tpl').html(h.html);
					$('#current-tpl').html(h.tpl);
					$('#template_id').val(h.tpl_id);
					$.colorbox.close();
				},'json'
			);
		} else {
			$.colorbox.close();
		}
	} else {
		$.post("<?php echo URL::site('admin/cms/set_template');?>", {tpl_id: tpl_id, category_id: category_id, content_type_id: content_type_id},
			function(h){
				$('#div-tpl').html(h.html);
				$('#current-tpl').html(h.tpl);
				$('#template_id').val(h.tpl_id);
				$.colorbox.close();
			},'json'
		);
	}
	tplselect = 1;
});

// check which button was clicked by the user
$(document).on('click', ':button', function(e){
	var btn_clicked = $(this).attr('id');
	$('#btn_clicked').val(btn_clicked);

	$("#_form").validate().cancelSubmit = false;

	$("#_form").attr('action', "<?php echo URL::site('admin/cms/save');?>");
	$("#_form").attr('target', "_self");

	$('#startdate').addClass('required');
	$('#enddate').addClass('required');

	// clear ckeditor content
	if (btn_clicked == 'btn-clear')
	{
		$('iframe').contents().find('body').empty();
		$("#content_type").val($("#content_type option:first").val());
		$('#form-content').html('');
		tplselect=0;
	} else if (btn_clicked == 'btn-del') {
		// delete request is clicked
		if (confirm('This request will be deleted. Do you wish to continue?'))
		{
			window.location.href="<?php echo URL::site('admin/cms');?>";
		}
	} else if (btn_clicked == 'btn-preview') {
		// for Promo Preview.  Check if user is previewing promo with link or custom form
		var content_type_id = $('#content_type_id').val();
		var link = $('#link5').val();

		if (content_type_id == 4 && link)
		{
			$("#_form").attr('action', "<?php echo URL::site('preview/promo_layout');?>");
		} else {
			$("#_form").attr('action', "<?php echo URL::site('preview/new_page');?>");
		}
		$("#_form").attr('target', "_blank");
		$("#_form").submit();
	} else if (btn_clicked == 'btn-draft') {
		// remove validation of start date and end date
		$("#_form").validate().cancelSubmit = true;

		var categ = $('#category').val();

		for ( instance in CKEDITOR.instances ) {
    		CKEDITOR.instances[instance].updateElement();
    	}

		if (categ == 0)
		{
			alert('Please input a Category for this request');
			e.preventDefault();
		}

		// $('#startdate').removeClass('required');
		// $('#enddate').removeClass('required');
		// $('#enddate').rules("remove", "greaterThan");
	}
});

$(document).on('change', '.adbanner', function(){
	var fieldname = $(this).attr('rel');
	var limit = $('#c_'+fieldname).val();

	if ($(this).val().length > limit)
	{
		alert('You may only select '+limit+' ad banner for this page');
		$('option:selected:last', this).removeAttr('selected');
	}
});

$(document).on('click', '#layout-prev', function(){
	var content_type = $('#content_type').val();

	$('#btn_clicked').val('');
	$('#startdate').removeClass('required');
	$('#enddate').removeClass('required');

	if (content_type == 4) {
		$("#_form").attr('action', "<?php echo URL::site('preview/promo_layout');?>");
	} else if (content_type == 5) {
		$("#_form").attr('action', "<?php echo URL::site('preview/client_update_layout');?>");
	} else if (content_type == 6) {
		$("#_form").attr('action', "<?php echo URL::site('preview/splash_page_layout');?>");
	}

	$("#_form").attr('target', "_blank");
	$("#_form").submit();
});

// check if form has been changed.
$(document).ready(function(){
	formmodified=0;
	tplselect=0;
	$('form *').change(function(){
	  formmodified=1;
	});
});
/*
$(document).ready(function() {
	formmodified=0;
    $('form *').change(function(){
        formmodified=1;
    });
    window.onbeforeunload = confirmExit;

    function confirmExit() {
        if (formmodified == 1) {
            return "New information not saved. Do you wish to leave the page?";
        }
    }
    $("input[name='commit']").click(function() {
        formmodified = 0;
    });
});
*/
/*
function setConfirmUnload(on) {
   window.onbeforeunload = (on) ? unloadMessage : null;
}

function unloadMessage() {
   return 'You have entered new data on this page.' +
      ' If you navigate away from this page without' +
      ' first saving your data, the changes will be' +
      ' lost.';
}

$(document).ready(function() {
	$(':input',document._form).bind(
	   "change", function() {
	        setConfirmUnload(true);
	   }
	); // Prevent accidental navigation away
});
*/
</script>