<div class="row">
	<div class="span9">
	<?php echo Form::open('admin/contenttype/save', array('id'=>'_form', 'class'=>'form-horizontal'));?>
	<fieldset>
		<legend><h4>Content Type</h4></legend>
		<div class="control-group">
			<?php echo Form::label('name', 'Content Type Name', array('class'=>'control-label'));?>
			<div class="controls">
			<?php
			if (Arr::get($data, 'id'))
			{
				echo Form::input('name', Arr::get($data, 'name'), array('class'=>'span4', 'id'=>'name', 'disabled'=>'disbled'));
			} else {
				echo Form::input('name', Arr::get($data, 'name'), array('class'=>'span4', 'id'=>'name', 'maxlength'=>70));
			}
			?>
			</div>
		</div>
		<div class="control-group">
			<?php echo Form::label('charlimit', 'CMS Title Character Limit', array('class'=>'control-label'));?>
			<div class="controls">
			<?php
				echo Form::input('charlimit', Arr::get($data, 'charlimit'), array('class'=>'span1 required digits', 'id'=>'charlimit', 'maxlength'=>4));
			?>
			</div>
		</div>
		<div class="control-group">
			<?php echo Form::label(NULL, 'Template', array('class'=>'control-label'));?>
			<div class="controls">
			<label><a href="javascript:;" class="btn btn-info" id="select-tpl">Assign a Template</a></label>
			<label class="error" for="def_tpl" style="display:none;"></label>
			</div>
		</div>
		<div class="form-actions">
			<?php
			if(Arr::get($data, 'id'))
			{
			?>
		    <button type="submit" class="btn btn-primary">Save Changes</button>
		    <?php
		    if (Arr::get($data, 'id') > 6)
		    {
		    ?>
		    <button type="button" id="btn-delete" class="btn btn-danger">Delete Content Type</button>
		    <?php
			}
			} else {
			?>
			<button type="submit" class="btn btn-primary">Add Content Type</button>
			<?php
			}
			?>
			<button type="reset" class="btn"><i class="icon-refresh"></i> Clear</button>
	    </div>
	</fieldset>
	<input type="hidden" name="id" id="content_type_id" value="<?php echo Arr::get($data, 'id');?>" />
	<input type="hidden" name="def_tpl" id="def_tpl" value="<?php echo Arr::get($data, 'def_tpl');?>" class="required" />
	<input type="hidden" name="token" value="<?php echo Security::token();?>" />
	<?php echo Form::close();?>

	<div id="comment-form" style='display:none;'>
		<?php echo Form::open('admin/contenttype/delete', array('id'=>'_form-del', 'class'=>'form-horizontal'));?>
		<div class="row">
			<div class="offset1 span7">
				<label>Your comment here:</label>
				<?php echo Form::textarea('comment', NULL, array('class'=>'span3 htmlEditor htmlEditorLimit', 'id'=>'comment'));?>
				<script>
					CKEDITOR.replace("comment", {
						width: 700,
						wordcount: {
							showWordCount: false,
							showCharCount: true,
							charLimit: 500
						}
					});
				</script>
			</div>
		</div>
		<div class="row" style="margin-top:20px;">
			<div class="offset1 span7">
				<button type="submit" id="btn-del" class="btn btn-danger">Confirm & Delete</button>
				<a class="btn" href="<?php echo URL::site('admin/contenttype/edit/'.Arr::get($data, 'id'));?>" id="btn-no-del">Cancel</a>
			</div>
		</div>
		<input type="hidden" name="id" id="ctype_id" value="<?php echo Arr::get($data, 'id');?>" />
		<input type="hidden" name="token" value="<?php echo Security::token();?>" />
		<?php echo Form::close();?>
	</div>
	</div>
</div>
<script src="<?php echo URL::site('assets/colorbox/jquery.colorbox-min.js');?>"></script>
<link href="<?php echo URL::site('assets/colorbox/colorbox.css');?>" rel="stylesheet">
<script src="<?php echo URL::site('assets/js/additional-methods.js');?>"></script>
<script type="text/javascript">
$('#_form').validate({
	ignore: [],
	rules: {
		name: {
			required: true,
			maxlength: 70,
			remote: {
				url: "<?php echo URL::site('admin/contenttype/check');?>",
				type: "post"
			},
			textfield: true
		}
	},
	messages: {
		def_tpl: 'Please assign template/s in this Content Type.',
		name: {
			required: 'Please input a Content Type Name',
			maxlength: 'The Content Type Name field should no longer allow entries in excess of 70 number of characters',
			remote: 'Content Type Name already exists. Please nominate a different name.',
			textfield: 'The Content Type Name field should no longer allow special character entries'
		},
		charlimit: {
			required: 'Please enter the maximum allowed character limit',
			digits: 'Value must be numbers only'
		}
	}
});

$('#_form-del').validate({
	ignore: "input:hidden:not(input:hidden.required),input:hidden:not(input:hidden.htmlEditor)",
	errorPlacement: function (error, element) {
		if (element.hasClass("htmlEditor")) {
			error.insertAfter(element.next());
		}
		else {
			error.insertAfter(element);
		}
	},
	submitHandler: function(form) {
		form.submit();
	}
});

$(document).on('click', '#select-tpl', function(){
	$.colorbox({
		href: "<?php echo URL::site('admin/contenttype/select_tpl');?>",
		data: {selected_tpls: $('#def_tpl').val(), ctype_id: $('#ctype_id').val()}
	});
});

// color box, close button
$(document).on('click', '#cbox-btn-close', function(){
	$.colorbox.close();
});

$(document).on('click', '#cbox-btn-save', function(){
	var form = $('#_form_select_tpl');
	form.validate({
		rules: {
			'tpl[]': 'required'
		},
		messages: {
			'tpl[]': 'Please select at least one Template'
		},
		errorPlacement: function (error, element) {
			$("#tpl-error-msg").html('');
			error.appendTo($("#tpl-error-msg"));
      }
	});

	if (form.valid())
	{
		var ctype = '';
		$('input[type=checkbox]').each(function () {
			if (this.checked)
			{
				ctype += (ctype ? ',' : '') + $(this).val();
			}
		});

		$('#def_tpl').val(ctype);
		$.colorbox.close();
	}
});

$(document).on('click', '#btn-delete', function(){
	if (confirm('Are you sure you want to delete this Content Type?'))
	{
		var id = $('#content_type_id').val();
		// check if there are posting created for this content type
		$.post("<?php echo URL::site('admin/contenttype/check_cms');?>", {ctype_id: id},
			function(d)
			{
				if(d)
				{
					alert("Cannot process delete request. Posting/s are defined under this Content Type.\nTry again at a later time when posting/s have been purged.");
					return false;
				}
				else
				{
					$('.form-actions').hide();
					$('#comment-form').show();
				}
			}, 'json'
		);
	}
});

$(document).on('click', '.tpl-img', function(){
	var img = $(this).attr('data-main');
	$.post("<?php echo URL::site('admin/template/view_main');?>", {img: img}, function(data){
		var win=window.open('about:blank');
	   with(win.document)
	   {
	      open();
	      write(data);
	      close();
	   }
	});
});
</script>