<div class="row">
	<div class="span8">
	<?php echo Form::open('admin/logs/download', array('id'=>'_form-logs', 'class'=>'form-horizontal'));?>
	<fieldset>
		<legend><h4>User Logs</h4></legend>
		<?php
		if ($flash_data)
		{
		?>
		<div class="alert">
		 	<button type="button" class="close" data-dismiss="alert">&times;</button>
		 	<?php echo $flash_data;?>
		 </div>
		<?php
		}
		?>
		<div class="row" style="margin-bottom:20px;">
			<div class="span2">
				<label>Start Date</label>
				<?php echo Form::input('startdate', NULL, array('class'=>'span2 required', 'id'=>'startdate'));?>
			</div>
			<div class="span2">
				<label>End Date</label>
				<?php echo Form::input('enddate', NULL, array('class'=>'span2 required', 'id'=>'enddate'));?>
			</div>
		</div>
		<div class="row" style="margin-bottom:20px;">
			<div class="span2">
				<label>Users</label>
			</div>
			<div class="span2">
				<label class="radio">
					<input type="radio" name="users" class="required usr" id="optionsRadios1" value="all">
					All User
				</label>
			</div>
			<div class="span2">
				<label class="radio">
					<input type="radio" name="users" class="usr" id="optionsRadios2" value="single"<?php echo $user_id > 0 ? ' checked="checked"' : '';?>>
					Single User
				</label>
				<?php echo Form::select('user', NULL, NULL, array('id'=>'user'));?>
			</div>
			<div class="offset2 span4">
				<label class="error" for="users" style="display:none;"></label>
			</div>
		</div>
		<div class="row" style="margin-bottom:20px;">
			<div class="span2">
				<label>Category</label>
			</div>
			<div class="span3">
				<?php echo Form::select('category', $arr_categories, NULL, array('id'=>'category'));?>
			</div>
		</div>
		<div class="row" style="margin-bottom:30px;">
			<div class="span2">
				<label>Control No.</label>
			</div>
			<div class="span3">
				<?php echo Form::input('control_no', NULL, array('id'=>'control_no', 'autocomplete'=>'off', 'class'=>'controlNo typeahead', 'data-provide'=>'typeahead', 'maxlength'=>19));?>
			</div>
		</div>
		<div class="row">
			<div class="span4">
				<button class="btn btn-primary" type="submit" id="btn-submitted">Download / Export CSV File</button>
				<button class="btn" type="reset" id="btn-reset">Reset</button>
			</div>
		</div>
	</fieldset>
	<input type="hidden" name="user_id" value="<?php echo $user_id;?>" id="user_id" />
	<?php echo Form::close();?>
	</div>
</div>

<script src="<?php echo URL::site('assets/js/jquery-ui-1.10.2.custom.min.js');?>"></script>
<link href="<?php echo URL::site('assets/css/smoothness/jquery-ui-1.10.2.custom.min.css');?>" rel="stylesheet">
<script src="<?php echo URL::site('assets/js/jquery.validate.min.js');?>"></script>
<script src="<?php echo URL::site('assets/js/additional-methods.js');?>"></script>
<script src="<?php echo URL::site('assets/js/date.js');?>"></script>
<script type="text/javascript">
$(document).ready(function(){
	$("#_form-logs").validate({
		rules: {
			enddate: {
				greaterThan: "#startdate"
			}
		},
		messages: {
			enddate: {
				greaterThan: 'End Date should not be earlier than Start Date.  Please input a new entry.'
			}
		},
    	submitHandler: function(form) {
    		var ds = Date.parse($('#startdate').val());
    		var de = Date.parse($('#enddate').val());
    		var e = false;
    		if (ds == null)
    		{
    			e = true;
    			alert('Start Date is not a valid date');
    		}
    		if (de == null)
    		{
    			e = true;
    			alert('End Date is not a valid date');
    		}

    		if ( ! e)
    		{
	    		if (confirm('Download / Export CSV file to your computer?'))
	    		{
	    			form.submit();
	    		}
	    	}
    	}
	});

	$('#startdate').datepicker();
	$('#enddate').datepicker();

	<?php
	if ($user_id > 0)
	{
	?>
	$('.usr').change();
	<?php
	}
	?>
});

$(document).on('change', '.usr', function(){
	var val = $(this).val();
	var user_id = $('#user_id').val();

	var $el = $("#user");
	$el.empty(); // remove old options

	if (val == 'single') {
		$('#category').attr('disabled', 'disabled');
		$('#control_no').attr('disabled', 'disabled');
		$.post("<?php echo URL::site('admin/logs/get_users');?>",
			function(newOptions){
				$.each(newOptions, function(key, value) {
					$el.append($("<option></option>")
				     .attr("value", key).text(value));
				   if (key == user_id)
				   {
				   	$el.val(user_id);
				   }
				});
			}, 'json'
		);
		$("#user").rules('add', 'required');
	} else {
		$('#category').removeAttr('disabled');
		$('#control_no').removeAttr('disabled');
		$("#user").rules('remove', 'required');
	}
});

$(document).on('change', '#category', function(){
	var val = $(this).val();

	if (val > 0)
	{
		$('#control_no').attr('disabled', 'disabled');
	}
	else
	{
		$('#control_no').removeAttr('disabled');
	}
});

$(document).on('keypress', '#control_no', function(){
	$('.usr').attr('disabled', 'disabled');
	$('#user').attr('disabled', 'disabled');
	$('#category').attr('disabled', 'disabled');
});

$(document).on('focusout', '#control_no', function(){
	if ($(this).val() == '')
	{
		$('#control_no').removeAttr('disabled');
		$('.usr').removeAttr('disabled');
		$('#user').removeAttr('disabled');
		$('#category').removeAttr('disabled');
	}
});

$(document).on('click', '#btn-reset', function(){
	$('#control_no').removeAttr('disabled');
	$('.usr').removeAttr('disabled');
	$('#user').removeAttr('disabled');
	$('#category').removeAttr('disabled');
});

$('.typeahead').typeahead({
    source: "<?php echo URL::site('admin/logs/get_control_no');?>"
});
</script>