<div class="row">
	<div class="span3">
      <?php echo $navlink;?>
   </div><!--/span-->
	<div class="span7">
	<?php echo Form::open('admin/promo/save', array('id'=>'_form', 'class'=>'form-horizontal', 'enctype'=>'multipart/form-data'));?>
	<fieldset>
		<legend><h4>Promo Category <small><span class="pull-right"><a href="<?php echo URL::site('admin/promo');?>">Back to list</a></span></small></h4></legend>
		<div class="control-group">
			<?php echo Form::label('name', 'Promo Category Name', array('class'=>'control-label'));?>
			<div class="controls">
			<?php
			if ($request_action == 'edit')
			{
				$name_class = array('class'=>'span3', 'id'=>'name');
			} else {
				$name_class = array('class'=>'span3 required', 'id'=>'name');
			}
			?>
			<?php echo Form::input('name', Arr::get($data, 'name'), $name_class);?>
			</div>
		</div>
		<div class="control-group">
			<?php echo Form::label('image', 'Promo Category Image', array('class'=>'control-label'));?>
			<div class="controls">
			<?php
			$cls = array('class'=>'required', 'id'=>'image');
			$file_img = Arr::get($data, 'image');
			if ($file_img and is_file(DOCROOT.'/media/uploads/'.$file_img))
			{
			?>
				<div style="margin-bottom:5px;" id="d_image">
					<img src="<?php echo URL::site('media/uploads/'.$file_img);?>" /><br /><a href="javascript:;" data-ref="image" id="<?php echo Arr::get($data, 'id');?>" rel="<?php echo $file_img;?>" class="rem-img">Remove</a>
					<input type="hidden" name="image_hid" value="<?php echo $file_img;?>" />
				</div>
			<?php
				$cls['class'] = '';
			}
			?>
			<?php echo Form::file('image', $cls);?>
			</div>
		</div>
		<div id="comment-form" style="display:none;">
		</div>
		<div class="form-actions" id="form-actions">
			<button type="submit" class="btn btn-primary" id="btn-save"><i class="icon-ok-circle icon-white"></i> Save</button>
			<?php
			if (Arr::get($data, 'id'))
			{
			?>
			<a class="btn btn-danger" href="javascript:;" id="btn-del"><i class="icon-remove-circle icon-white"></i> Delete</a>
			<?php
			}
			?>
			<button type="reset" class="btn"><i class="icon-refresh"></i> Clear</button>
			<a class="btn" id="btn-cancel" href="<?php echo URL::site('admin/promo');?>"><i class="icon-arrow-left"></i> Cancel</a>
		</div>
		<input type="hidden" name="id" id="promo_category_id" value="<?php echo Arr::get($data, 'id');?>" />
		<input type="hidden" name="token" value="<?php echo Security::token(true);?>" />
		<input type="hidden" name="btn_clicked" id="btn_clicked" value="" />
		<input type="hidden" name="navlink" id="navlink" value="" />
	</fieldset>
	<?php echo Form::close();?>
	</div>
</div>
<script src="<?php echo URL::site('assets/js/additional-methods.js');?>"></script>
<script type="text/javascript">
$(document).ready(function(){
	$("#_form").validate({
    	submitHandler: function(form) {
    		var btn = $('#btn_clicked').val();
    		if (btn == 'btn-del')
    		{
    			$("#_form").attr('action', "<?php echo URL::site('admin/promo/delete');?>");
    		}

    		form.submit();
    	}
	});

	// check if form has been modified
	formmodified=0;
	$('form *').change(function(){
		formmodified=1;
	});
});

// clicked Navigation link when user creating a page
$(document).on('click', '.navlink', function(e){
	if (formmodified)
	{
		if (confirm('Do you want to Save your entries? Click OK to save or Cancel to exit.')) {
			e.preventDefault();
			$('#navlink').val($(this).attr('rel'));
			// $("#_form").validate().cancelSubmit = true;
			$('#_form').submit();
		} else {
			window.location.href="<?php echo URL::site('admin/promo');?>";
		}
	}
});

$(document).on('click', '#btn-cancel', function(e){
	if (formmodified)
	{
		if (confirm('All your modified entries will be discarded. Do you wish to continue?')) {
			return true;
		} else {
			e.preventDefault();
		}
	}
});

$(document).on('click', '#btn-del', function(){
	if(confirm('Are you sure you want to delete this promo category?'))
	{
		var id = $('#promo_category_id').val();

		$.post("<?php echo URL::site('admin/promo/check_cms');?>", {promo_category_id: id},
			function(d)
			{
				if(d)
				{
					alert("Cannot process delete request. Posting/s are defined under this Promo Category.\nTry again at a later time when posting/s have been purged.");
					return false;
				}
				else
				{
					$('#form-actions').hide();
					$.post("<?php echo URL::site('admin/promo/show_comment_form');?>",
						function(htm) {
							$('#comment-form').html(htm).fadeIn();
						}
					);

					var btn_clicked = $("#btn-del").attr('id');
					$('#btn_clicked').val(btn_clicked);
				}
			}, 'json'
		);
	}
	else
	{
		$('#form-actions').show();
		$('#comment-form').html('').hide();
		$('#btn_clicked').val('');
		return false;
	}
});

$(document).on('click', '#btn-no-del', function(){
	$('#form-actions').show();
	$('#comment-form').hide();
	$('#btn_clicked').val('');
});

$(document).on('click', '.rem-img', function(){
	if (confirm('Are you sure you want to remove this file?'))
	{
		var page_id = $(this).attr('id');
		var field = $(this).attr('data-ref');
		var file = $(this).attr('rel');

		$.post("<?php echo URL::site('admin/promo/remove_file');?>", {page_id: page_id, field: field, file: file},
			function(data) {
				if (data) {
					$('#d_'+field).hide();
					$('input:file#'+field).addClass('required');
				}
			}, 'json'
		);
	}
});
</script>