<div class="row">
	<div class="span8">
	<?php echo Form::open('admin/users/save', array('id' => '_form', 'class' => 'form-horizontal'));?>
	<fieldset>
		<legend><h4>User <small><em>Add/Edit Admin Information</em><span class="pull-right"><a href="<?php echo URL::site('admin/users');?>">Back to list</a></span></small></h4></legend>
		<div class="control-group">
			<?php echo Form::label('name', 'Name', array('class'=>'control-label'));?>
			<div class="controls">
			<?php
			if ($request_action == 'edit')
			{
				$name_class = array('class'=>'span3', 'disabled'=>'disabled', 'id'=>'name');
			} else {
				$name_class = array('class'=>'span3 required', 'id'=>'name');
			}
			?>
			<?php echo Form::input('name', Arr::get($data, 'name'), $name_class);?>
			</div>
		</div>
		<div class="control-group">
			<?php echo Form::label('username', 'Username', array('class'=>'control-label'));?>
			<div class="controls">
			<?php
			if ($request_action == 'edit')
			{
				$username_class = array('class'=>'span3', 'disabled'=>'disabled', 'id'=>'username');
			} else {
				$username_class = array('class'=>'span3 required', 'id'=>'username');
			}
			?>
			<?php echo Form::input('username', Arr::get($data, 'username'), $username_class);?>
			</div>
		</div>
		<?php /*
		<div class="control-group">
			<?php echo Form::label('password', 'Password', array('class'=>'control-label'));?>
			<div class="controls">
			<?php
			if ($request_action == 'edit')
			{
				$pass_class = array('class'=>'span3');
			} else {
				$pass_class = array('class'=>'span3 required');
			}
				echo Form::input('password', NULL, $pass_class);
			?>
			</div>
			<input type="hidden" name="old_password" value="<?php echo Arr::get($data, 'password');?>" />
		</div>
		*/ ?>
		<div class="control-group">
			<?php echo Form::label('email', 'Email', array('class'=>'control-label'));?>
			<div class="controls">
			<?php echo Form::input('email', Arr::get($data, 'email'), array('class'=>'span3 required email'));?>
			</div>
		</div>
		<div class="control-group">
			<?php echo Form::label('office_phone', 'Office Phone', array('class'=>'control-label'));?>
			<div class="controls">
			<?php echo Form::input('office_phone', Arr::get($data, 'office_phone'), array('class'=>'span3 required'));?>
			</div>
		</div>
		<div class="control-group">
			<?php echo Form::label('role_id', 'Role', array('class'=>'control-label'));?>
			<div class="controls">
			<?php
			$params = Arr::get($data, 'id') == 1 ? array('class'=>'span3 required', 'id'=>'role_id', 'disabled'=>'disabled') : array('class'=>'span3 required', 'id'=>'role_id');
			?>
			<small>Please select a role</small><br />
			<?php echo Form::select('role_id', $arr_roles, Arr::get($data, 'role_id'), $params);?>
			</div>
		</div>
		<?php
		if (Session::instance()->get('user_role_id') == 2)
		{
		?>
		<div class="control-group">
			<?php echo Form::label(NULL, 'Categories', array('class'=>'control-label'));?>
			<div class="controls">
			<small>The CATEGORY list below will be displayed after you select a Role.</small><br />
			<?php echo Form::select('category_ids[]', $arr_categories, Arr::get($data, 'category_ids'), array('class'=>'span4 required', 'id'=>'category_id', 'multiple'=>'multiple', 'style'=>'height:150px;'));?>
			</div>
		</div>
		<div class="control-group">
			<?php echo Form::label(NULL, 'Segments', array('class'=>'control-label'));?>
			<div class="controls">
			<?php
			foreach ($arr_segments as $segment_id => $segment_name)
			{
			?>
				<label class="checkbox">
					<input type="checkbox" name="segment_ids[]" value="<?php echo $segment_id;?>"<?php echo in_array($segment_id, Arr::get($data, 'segment_ids')) ? ' checked="checked"' : '';?>>
					<?php echo $segment_name;?>
				</label>
			<?php
			}
			?>
			<label class="error" for="segment_ids[]" style="display:none;">This field is required</label>
			</div>
		</div>
		<?php
		}
		?>
		<div id="comment-form" style="display:none;">
		</div>
		<div class="form-actions" id="form-actions">
			<button type="button" class="btn btn-primary" id="btn-save"><i class="icon-ok-circle icon-white"></i> Save</button>
			<?php
			if (Arr::get($data, 'id') AND Arr::get($data, 'id') != 1)
			{
			?>
			<a class="btn btn-danger" href="javascript:;" id="btn-del"><i class="icon-remove-circle icon-white"></i> Delete</a>
			<?php
			}
			?>
			<button type="reset" class="btn"><i class="icon-refresh"></i> Clear</button>
			<a class="btn" id="btn-cancel" href="<?php echo URL::site('admin/users');?>"><i class="icon-arrow-left"></i> Cancel</a>
		</div>
		<input type="hidden" name="id" value="<?php echo Arr::get($data, 'id');?>" />
		<input type="hidden" name="token" value="<?php echo Security::token(true);?>" />
		<input type="hidden" name="btn_clicked" id="btn_clicked" value="" />
		<input type="hidden" name="navlink" id="navlink" value="" />
	</fieldset>
	<?php echo Form::close();?>
	</div>
</div>

<div id="userModal" class="modal hide fade" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
	<div class="modal-header">
		<h4 id="myModalLabel">User Management - Confirm Changes</h4>
	</div>
	<div class="modal-body">
		<div id="form-content"></div>
	</div>
	<div class="modal-footer">
		<button class="btn btn-primary" id="btn-confirm-update" data-dismiss="modal" aria-hidden="true">Ok</button>
		<button class="btn" id="btn-modal-cancel">Cancel</button>
	</div>
</div>

<script src="<?php echo URL::site('assets/js/additional-methods.js');?>"></script>
<script type="text/javascript">
$(document).ready(function(){
	$("#_form").validate({
		ignore: "input:hidden:not(input:hidden.required),input:hidden:not(input:hidden.htmlEditor)",
		rules: {
			username: {
				remote: {
      			url: "<?php echo URL::site('admin/users/check_username');?>",
        			type: "post"
      		}
			},
    		email: {
    			maxlength: 70
    		},
    		office_phone: {
    			maxlength: 8,
    			phonePH: true
    		},
    		'segment_ids[]': 'required'
    	},
    	messages: {
  			username: {
  				remote: 'Please provide a unique username'
  			}
  		},
  		errorPlacement: function (error, element) {
			if (element.hasClass("htmlEditor")) {
				error.insertAfter(element.next());
			}
			else {
				error.insertAfter(element);
			}
		},
    	submitHandler: function(form) {
    		var btn = $('#btn_clicked').val();
    		if (btn == 'btn-del')
    		{
    			$("#_form").attr('action', "<?php echo URL::site('admin/users/delete');?>");
    		}

    		form.submit();
    	}
	});

	// check if form has been modified
	formmodified=0;
	$('form *').change(function(){
		formmodified=1;
	});
});

$(document).on('change', '#role_id', function(){
	var role_id = $(this).val();
	$('#btn-save').attr('disabled', 'disabled');
	$.post("<?php echo URL::site('admin/users/get_role_categories');?>", {role_id: role_id},
		function(newOptions){
			var $el = $("#category_id");
			$el.empty(); // remove old options
			$.each(newOptions, function(key, value) {
				$el.append($("<option></option>")
			     .attr("value", key).text(value));
			});
		}, 'json'
	);
	$('#btn-save').removeAttr('disabled');
});

// clicked Navigation link when user creating a page
$(document).on('click', '.navlink', function(e){
	if (formmodified)
	{
		if (confirm('Do you want to Save your entries? Click OK to save or Cancel to exit.')) {
			e.preventDefault();
			$('#navlink').val($(this).attr('rel'));
			// $("#_form").validate().cancelSubmit = true;
			$('#_form').submit();
		} else {
			window.location.href="<?php echo URL::site('admin/users');?>";
		}
	}
});

$(document).on('click', '#btn-cancel', function(e){
	if (formmodified)
	{
		if (confirm('All your modified entries will be discarded. Do you wish to continue?')) {
			return true;
		} else {
			e.preventDefault();
		}
	}
});

$(document).on('click', '#btn-del', function(){
	if(confirm('Are you sure you want to delete this user?'))
	{
		$('#form-actions').hide();
		$.post("<?php echo URL::site('admin/users/show_comment_form');?>",
			function(htm) {
				$('#comment-form').html(htm).fadeIn();
			}
		);

		var btn_clicked = $(this).attr('id');
		$('#btn_clicked').val(btn_clicked);
	}
	else
	{
		$('#form-actions').show();
		$('#comment-form').html('').hide();
		$('#btn_clicked').val('');
		return false;
	}
});

$(document).on('click', '#btn-no-del', function(){
	$('#form-actions').show();
	$('#comment-form').hide();
	$('#btn_clicked').val('');
});

$(document).on('click', '#btn-save', function(){
	var form = $("#_form");
	form.validate();

	if (form.valid())
	{
		$.post("<?php echo URL::site('admin/users/confirm_edit');?>", $('#_form').serialize(),
			function(data) {
				$('#form-content').html(data);
			}
		);
		$('#userModal').modal('show');
	}
});

$(document).on('click', '#btn-confirm-update', function(){
	$('#_form').submit();
});

$(document).ready(function(){
	$('#btn-modal-cancel').click(function(){
		$('#userModal').modal('hide');
	});

	$('#btn-cancel').click(function(e){
		var c = false;

		$('input').each(function(){
			var val = $(this).val();
			var def_val = $(this).prop('defaultValue');

			if (val != def_val)
			{
				c = true;
			}
		});

		if (c)
		{
			if (! confirm('All your modified entries will be discarded. Do you wish to Continue?'))
			{
				e.preventDefault();
			}
		}

	});
});
</script>