/**
 * @license Copyright (c) 2003-2013, CKSource - Frederico Knabben. All rights reserved.
 * For licensing, see LICENSE.html or http://ckeditor.com/license
 */

CKEDITOR.editorConfig = function( config ) {
	// Define changes to default configuration here.
	// For complete reference see:
	// http://docs.ckeditor.com/#!/api/CKEDITOR.config

	// The toolbar groups arrangement, optimized for two toolbar rows.
	config.toolbarGroups = [
		{ name: 'document',	  groups: [ 'mode', 'document', 'doctools' ] },
		{ name: 'clipboard',   groups: [ 'clipboard', 'undo' ] },
		{ name: 'editing',     groups: [ 'find', 'selection' ] },
		{ name: 'forms' },
		{ name: 'basicstyles', groups: [ 'basicstyles', 'cleanup' ] },
		{ name: 'paragraph',   groups: [ 'list', 'indent', 'blocks', 'align', 'bidi' ] },
		{ name: 'links' },
		{ name: 'insert' },
		{ name: 'styles' },
		{ name: 'colors' },
		{ name: 'tools' },
		{ name: 'others' },
		{ name: 'about' }
	];

	// Remove some buttons provided by the standard plugins, which are
	// not needed in the Standard(s) toolbar.
	config.removeButtons = 'Source,About,PasteFromWord,PasteText,Cut,Copy,Paste,Undo,Redo,Anchor,Strike,Subscript,Superscript,Image,HorizontalRule,SpecialChar,Styles,Maximize,Blockquote';

	// Set the most common block elements.
	config.format_tags = 'h1;h2;h3;h4;h5;h6';

	config.extraPlugins = 'justify,dialogadvtab,maxlength,colorbutton,panelbutton,pastetext';

	// fix for forcing of copy/paste as plain text
	config.forcePasteAsPlainText = true;
	/*
	config.wordcount = {
		// Whether or not you want to show the Word Count
		showWordCount: false,
		// Whether or not you want to show the Char Count
		showCharCount: false,
		// Whether or not to include Html chars in the Char Count
		countHTML: false
	};
	*/
	// Simplify the dialog windows.
	config.removeDialogTabs = 'image:advanced;link:advanced';
};
