/*
Navicat SQL Server Data Transfer

Source Server         : MS SQL
Source Server Version : 105000
Source Host           : :1433
Source Database       : eol
Source Schema         : dbo

Target Server Type    : SQL Server
Target Server Version : 105000
File Encoding         : 65001

Date: 2013-09-12 16:29:39
*/


-- ----------------------------
-- Table structure for activities
-- ----------------------------
DROP TABLE [dbo].[activities]
GO
CREATE TABLE [dbo].[activities] (
[id] bigint NOT NULL IDENTITY(1,1) ,
[user_id] int NULL ,
[user_name] varchar(150) NULL ,
[user_type] varchar(50) NULL ,
[action] varchar(200) NULL ,
[description] text NULL ,
[date_added] datetime NULL DEFAULT (getdate()) ,
[category_id] int NULL ,
[control_no] varchar(50) NULL 
)


GO
DBCC CHECKIDENT(N'[dbo].[activities]', RESEED, 203)
GO

-- ----------------------------
-- Table structure for categories
-- ----------------------------
DROP TABLE [dbo].[categories]
GO
CREATE TABLE [dbo].[categories] (
[id] int NOT NULL IDENTITY(1,1) ,
[name] varchar(70) NULL ,
[folder_name] varchar(70) NULL ,
[roles] varchar(10) NULL ,
[content_types] varchar(70) NULL ,
[templates] varchar(100) NULL ,
[date_added] datetime NULL DEFAULT (getdate()) 
)


GO
DBCC CHECKIDENT(N'[dbo].[categories]', RESEED, 32)
GO

-- ----------------------------
-- Table structure for content_type
-- ----------------------------
DROP TABLE [dbo].[content_type]
GO
CREATE TABLE [dbo].[content_type] (
[id] int NOT NULL IDENTITY(1,1) ,
[name] varchar(100) NULL ,
[def_tpl] varchar(30) NULL ,
[date_added] datetime NULL DEFAULT (getdate()) 
)


GO
DBCC CHECKIDENT(N'[dbo].[content_type]', RESEED, 6)
GO

-- ----------------------------
-- Table structure for countries
-- ----------------------------
DROP TABLE [dbo].[countries]
GO
CREATE TABLE [dbo].[countries] (
[id] int NOT NULL IDENTITY(1,1) ,
[name] varchar(100) NULL 
)


GO
DBCC CHECKIDENT(N'[dbo].[countries]', RESEED, 22)
GO

-- ----------------------------
-- Table structure for media
-- ----------------------------
DROP TABLE [dbo].[media]
GO
CREATE TABLE [dbo].[media] (
[id] int NOT NULL IDENTITY(1,1) ,
[page_id] int NULL ,
[temp_id] varchar(50) NULL ,
[filename] varchar(150) NULL ,
[page_status] varchar(30) NULL ,
[date_added] datetime2(7) NULL 
)


GO
DBCC CHECKIDENT(N'[dbo].[media]', RESEED, 24)
GO

-- ----------------------------
-- Table structure for menus
-- ----------------------------
DROP TABLE [dbo].[menus]
GO
CREATE TABLE [dbo].[menus] (
[id] int NOT NULL IDENTITY(1,1) ,
[segment_id] int NULL ,
[action] varchar(70) NULL ,
[sort] tinyint NULL ,
[categories] varchar(50) NULL ,
[date_added] datetime NULL DEFAULT (getdate()) 
)


GO
DBCC CHECKIDENT(N'[dbo].[menus]', RESEED, 14)
GO

-- ----------------------------
-- Table structure for navtree
-- ----------------------------
DROP TABLE [dbo].[navtree]
GO
CREATE TABLE [dbo].[navtree] (
[id] int NOT NULL IDENTITY(1,1) ,
[category_id] int NULL ,
[name] varchar(70) NULL ,
[level] smallint NULL ,
[parent_id] int NULL ,
[date_added] datetime NULL DEFAULT (getdate()) 
)


GO
DBCC CHECKIDENT(N'[dbo].[navtree]', RESEED, 20)
GO

-- ----------------------------
-- Table structure for page_comments
-- ----------------------------
DROP TABLE [dbo].[page_comments]
GO
CREATE TABLE [dbo].[page_comments] (
[id] int NOT NULL IDENTITY(1,1) ,
[page_id] int NULL ,
[comment] text NULL ,
[comment_by] int NULL ,
[comment_date] datetime NULL 
)


GO
DBCC CHECKIDENT(N'[dbo].[page_comments]', RESEED, 8)
GO

-- ----------------------------
-- Table structure for page_history
-- ----------------------------
DROP TABLE [dbo].[page_history]
GO
CREATE TABLE [dbo].[page_history] (
[id] int NOT NULL IDENTITY(1,1) ,
[user_id] int NULL ,
[description] text NULL ,
[date_added] datetime2(7) NULL ,
[page_id] int NULL ,
[user_name] varchar(150) NULL ,
[role] varchar(50) NULL 
)


GO
DBCC CHECKIDENT(N'[dbo].[page_history]', RESEED, 76)
GO

-- ----------------------------
-- Table structure for pages
-- ----------------------------
DROP TABLE [dbo].[pages]
GO
CREATE TABLE [dbo].[pages] (
[id] int NOT NULL IDENTITY(1,1) ,
[control_no] varchar(50) NULL ,
[title] varchar(250) NULL ,
[body1] text NULL ,
[body2] text NULL ,
[body3] text NULL ,
[body4] text NULL ,
[body5] text NULL ,
[link1] varchar(300) NULL ,
[link2] varchar(300) NULL ,
[link3] varchar(300) NULL ,
[link4] varchar(300) NULL ,
[link5] varchar(300) NULL ,
[image1] varchar(100) NULL ,
[image2] varchar(100) NULL ,
[image3] varchar(100) NULL ,
[image4] varchar(100) NULL ,
[image5] varchar(100) NULL ,
[doc1] varchar(100) NULL ,
[doc2] varchar(100) NULL ,
[doc3] varchar(100) NULL ,
[doc4] varchar(100) NULL ,
[doc5] varchar(100) NULL ,
[doc6] varchar(100) NULL ,
[doc7] varchar(100) NULL ,
[doc8] varchar(100) NULL ,
[doc9] varchar(100) NULL ,
[doc10] varchar(100) NULL ,
[doc_label1] varchar(200) NULL ,
[doc_label2] varchar(200) NULL ,
[doc_label3] varchar(200) NULL ,
[doc_label4] varchar(200) NULL ,
[doc_label5] varchar(200) NULL ,
[doc_label6] varchar(200) NULL ,
[doc_label7] varchar(200) NULL ,
[doc_label8] varchar(200) NULL ,
[doc_label9] varchar(200) NULL ,
[doc_label10] varchar(200) NULL ,
[content_type_id] int NULL ,
[category_id] int NULL ,
[sub_category1] int NULL ,
[sub_category2] int NULL ,
[sub_category3] int NULL ,
[template_id] int NULL ,
[segment_ids] varchar(50) NULL ,
[start_date] datetime NULL ,
[end_date] datetime NULL ,
[status] varchar(50) NULL ,
[status_date] datetime NULL ,
[created_by] int NULL ,
[date_created] datetime NULL ,
[embed1] text NULL ,
[embed2] text NULL ,
[embed3] text NULL ,
[embed4] text NULL ,
[embed5] text NULL ,
[copy_from] int NULL ,
[control_no_supersede] varchar(50) NULL ,
[adbanner1] varchar(30) NULL ,
[adbanner2] varchar(30) NULL ,
[adbanner3] varchar(30) NULL ,
[adbanner4] varchar(30) NULL ,
[adbanner5] varchar(30) NULL 
)


GO
DBCC CHECKIDENT(N'[dbo].[pages]', RESEED, 28)
GO

-- ----------------------------
-- Table structure for roles
-- ----------------------------
DROP TABLE [dbo].[roles]
GO
CREATE TABLE [dbo].[roles] (
[id] int NOT NULL IDENTITY(1,1) ,
[name] varchar(50) NULL 
)


GO
DBCC CHECKIDENT(N'[dbo].[roles]', RESEED, 7)
GO

-- ----------------------------
-- Table structure for sequence_no
-- ----------------------------
DROP TABLE [dbo].[sequence_no]
GO
CREATE TABLE [dbo].[sequence_no] (
[id] int NOT NULL IDENTITY(1,1) ,
[d8] date NOT NULL ,
[seq] smallint NOT NULL 
)


GO
DBCC CHECKIDENT(N'[dbo].[sequence_no]', RESEED, 4)
GO

-- ----------------------------
-- Table structure for sessions
-- ----------------------------
DROP TABLE [dbo].[sessions]
GO
CREATE TABLE [dbo].[sessions] (
[session_id] varchar(24) NOT NULL ,
[last_active] int NULL ,
[contents] text NULL 
)


GO

-- ----------------------------
-- Table structure for setting
-- ----------------------------
DROP TABLE [dbo].[setting]
GO
CREATE TABLE [dbo].[setting] (
[id] int NOT NULL IDENTITY(1,1) ,
[sess_time_warn] smallint NULL ,
[sess_time_logout] smallint NULL ,
[purge_draft] smallint NULL ,
[purge_denied] smallint NULL ,
[purge_archived] smallint NULL 
)


GO

-- ----------------------------
-- Table structure for templates
-- ----------------------------
DROP TABLE [dbo].[templates]
GO
CREATE TABLE [dbo].[templates] (
[id] int NOT NULL IDENTITY(1,1) ,
[name] varchar(70) NULL ,
[file_name] varchar(150) NULL ,
[thumbnail] varchar(150) NULL ,
[content_type_id] int NOT NULL ,
[char_limit] int NULL ,
[sections] text NULL 
)


GO
DBCC CHECKIDENT(N'[dbo].[templates]', RESEED, 7)
GO

-- ----------------------------
-- Table structure for users
-- ----------------------------
DROP TABLE [dbo].[users]
GO
CREATE TABLE [dbo].[users] (
[id] int NOT NULL IDENTITY(1,1) ,
[name] varchar(100) NULL ,
[username] varchar(50) NULL ,
[email] varchar(100) NULL ,
[office_phone] varchar(10) NULL ,
[category_ids] varchar(150) NULL ,
[role_id] int NULL ,
[date_created] datetime2(7) NULL ,
[last_visit] datetime2(7) NULL ,
[segment_ids] varchar(20) NULL ,
[login_try] smallint NULL ,
[active] char(1) NULL DEFAULT ('Y') 
)


GO
DBCC CHECKIDENT(N'[dbo].[users]', RESEED, 16)
GO

-- ----------------------------
-- Indexes structure for table activities
-- ----------------------------

-- ----------------------------
-- Primary Key structure for table activities
-- ----------------------------
ALTER TABLE [dbo].[activities] ADD PRIMARY KEY ([id])
GO

-- ----------------------------
-- Indexes structure for table categories
-- ----------------------------

-- ----------------------------
-- Primary Key structure for table categories
-- ----------------------------
ALTER TABLE [dbo].[categories] ADD PRIMARY KEY ([id])
GO

-- ----------------------------
-- Indexes structure for table content_type
-- ----------------------------

-- ----------------------------
-- Primary Key structure for table content_type
-- ----------------------------
ALTER TABLE [dbo].[content_type] ADD PRIMARY KEY ([id])
GO

-- ----------------------------
-- Indexes structure for table countries
-- ----------------------------

-- ----------------------------
-- Primary Key structure for table countries
-- ----------------------------
ALTER TABLE [dbo].[countries] ADD PRIMARY KEY ([id])
GO

-- ----------------------------
-- Indexes structure for table media
-- ----------------------------

-- ----------------------------
-- Primary Key structure for table media
-- ----------------------------
ALTER TABLE [dbo].[media] ADD PRIMARY KEY ([id])
GO

-- ----------------------------
-- Indexes structure for table menus
-- ----------------------------

-- ----------------------------
-- Primary Key structure for table menus
-- ----------------------------
ALTER TABLE [dbo].[menus] ADD PRIMARY KEY ([id])
GO

-- ----------------------------
-- Indexes structure for table navtree
-- ----------------------------

-- ----------------------------
-- Primary Key structure for table navtree
-- ----------------------------
ALTER TABLE [dbo].[navtree] ADD PRIMARY KEY ([id])
GO

-- ----------------------------
-- Indexes structure for table page_comments
-- ----------------------------

-- ----------------------------
-- Primary Key structure for table page_comments
-- ----------------------------
ALTER TABLE [dbo].[page_comments] ADD PRIMARY KEY ([id])
GO

-- ----------------------------
-- Indexes structure for table page_history
-- ----------------------------

-- ----------------------------
-- Primary Key structure for table page_history
-- ----------------------------
ALTER TABLE [dbo].[page_history] ADD PRIMARY KEY ([id])
GO

-- ----------------------------
-- Indexes structure for table pages
-- ----------------------------

-- ----------------------------
-- Primary Key structure for table pages
-- ----------------------------
ALTER TABLE [dbo].[pages] ADD PRIMARY KEY ([id])
GO

-- ----------------------------
-- Indexes structure for table roles
-- ----------------------------

-- ----------------------------
-- Primary Key structure for table roles
-- ----------------------------
ALTER TABLE [dbo].[roles] ADD PRIMARY KEY ([id])
GO

-- ----------------------------
-- Indexes structure for table sequence_no
-- ----------------------------

-- ----------------------------
-- Primary Key structure for table sequence_no
-- ----------------------------
ALTER TABLE [dbo].[sequence_no] ADD PRIMARY KEY ([id])
GO

-- ----------------------------
-- Indexes structure for table sessions
-- ----------------------------

-- ----------------------------
-- Primary Key structure for table sessions
-- ----------------------------
ALTER TABLE [dbo].[sessions] ADD PRIMARY KEY ([session_id])
GO

-- ----------------------------
-- Indexes structure for table setting
-- ----------------------------

-- ----------------------------
-- Primary Key structure for table setting
-- ----------------------------
ALTER TABLE [dbo].[setting] ADD PRIMARY KEY ([id])
GO

-- ----------------------------
-- Indexes structure for table templates
-- ----------------------------

-- ----------------------------
-- Primary Key structure for table templates
-- ----------------------------
ALTER TABLE [dbo].[templates] ADD PRIMARY KEY ([id])
GO

-- ----------------------------
-- Indexes structure for table users
-- ----------------------------

-- ----------------------------
-- Primary Key structure for table users
-- ----------------------------
ALTER TABLE [dbo].[users] ADD PRIMARY KEY ([id])
GO
